#!/usr/bin/perl

# get_level_ser, ajouté @.*%s...

# A. updated_channel, terminer LVL, QUIT et ChangeNick...



package Channel;

use Data::Dumper;
use strict;
use warnings;

use vars qw($from $channel $nick $login $host $level
            $list  %list_sample
            $var
            );

    %list_sample = (
                        '0' => {
                                'nick'          => "CurIeuX",
                                'login'         => "mans",
                                'host'          => "gyptis.org",
                                'lvl'           => "150",
                                'channel'               => "#jose",
                                'pass'          => "pass",
                                'temp'		=> "",
                                'hash'          => { caca => "dodo" }
                                },
                        '1' => {
                                'nick'          => "Zilog80",
                                'login'         => "ObeliX",
                                'host'          => "*!*Zilog80\@gyptis.org",
                                'lvl'           => "100",
                                'channel'               => "*",
                                'pass'          => "pass",
                                'temp'		=> "",
                                'hash'          => { caca => "dodo" }
                                }
                        );



if ( 0 )
{
	# Le test
	my $o	= new Channel( DEBUG => 99);
	$o->{DEBUG}	= 0;
	#$o->from("cix!ns\@voila.org");
	#$o->adduser("cix", "password", "150", "login_cix", "host1", "#gyptis #jose #linux");
	#$o->from("vir!virginie\@gyptis.org");
	#$o->adduser("vir", "word", "50", "login_vir", "host2", "#gs #e");

	foreach my $tmp (keys %{$o->{list}[1]})
	{
   	#printf("TMP: %s => %s\n", $tmp, ${$o->{list}[0]}{$tmp} );
	}
	printf("LEVEL \n");
	#$o->get_list_channel(  );
	$o->{DEBUG}	= 99;
	# Procédure de sauvegarde/restitutions
	#$o->config_write();
	$o->config_read();
	foreach my $tmp ( @{$o->{list}} )
	{
    	$o->splash2( $tmp );
    	printf("\n");
	}
}

sub new
{
    my $self	= shift;
    my %arg	= @_;
    my $class	= {};

    $self	= ref($self) || $self;
    bless $class, $self;

    $class->{list}		= ();
    $class->init_channel();
    $var		= "";
    $from = $channel = $nick = $login = $host = $list	= $var;

    #$class->{DEBUG}	= $arg{DEBUG} || "0";
    $class->{DEBUG}	= "99";

    # METOD
    $class->{method_w}	= {
                            'adduser' => \&write_adduser
                           };

    $class->{method_r}	= {
                            'adduser' => \&read_adduser
                           };

    # Param à placer dans un fichier de config :
    $class->{user_list}	= "user.list";
    $class->{prot_list}	= "prot.list";
    $class->{shit_list}	= "shit.list";

    $class->config_read();

    return( $class );
}

sub cfg
{
    my $class	= shift;
    my $opt	= shift || "get";
    my $branch	= shift || "";
    my $var	= shift || "";

    my $ret	= "";

  if (defined($class->{cfg}) )
  {
    $branch	=~ s/\#//g;

    $class->debug(99, "CFG($opt), branch=$branch, var=$var\n");
    if ($opt eq "put")
    {
        $ret	= $class->{cfg}->put($branch, $var);
    }
    elsif ($opt eq "find")
    {
        $ret	= $class->{cfg}->find($branch);
    }
    else
    {
        $ret	= $class->{cfg}->get($branch);
    }
  }
  else
  {
    $class->debug(10, "Module Config2 is not implement\n");
  }

    return( $ret);
}

sub user_default
{
    my $class	= shift;
    my %user	= %{$class->add_struct()};
    $user{'lvl'}	= "0";
    $user{'channel'}	= "";
    $user{'pass'}	= "";
    return(\%user);
}

sub add_struct
{
    my $class	= shift;

    my $user	= {
                                'nick'          => $class->nick(),
                                'login'         => $class->login(),
                                'host'          => $class->host(),
                                'lvl'           => $class->level(),
                                'channel'       => $class->channel(),
                                'pass'          => $class->pass(),
                                'temp'		=> $class->temp(),
                                #'hash'          => {
				#                     caca => "dodo",
				#                     caca2 => "dodo2",
				#                     HaSHCaca => {"niarf" => "value"},
				#                   }
                  };
    return ($user );
}

sub add
{
    my $class	= shift;

    #my $list	= shift || $class->{list}; # Ca marche po :.(

    #printf("ADD: %s\n", $class->from() );

    push @{$class->{list}}, $class->add_struct();

    $class->debug( 99, sprintf("   AdD: (user...), %s, %s, %s, %s, %s (tm: %s)",
                            $class->nick(), $class->channel(), $class->login(), $class->host(), $class->from(), $class->temp()
                            ));
}

# &($channel present, $from);
# Prévue pour ON WHO
sub add_channel
{
    my $class	= shift;
    $class->ident( @_ );

    unless ( %{$class->_find_channel()} )
    {
        my %user	= %{$class->do_level( $class->nick())}; # A revoir
        $class->level( $user{lvl} || "0"); # A revoir

        $class->pass ( "" );
        if (0)
        {
        $class->debug( 99, sprintf("   ADD_channel: (channel), %s, %s, %s, %s, %s, %s",
                            $class->nick(), $list, $class->channel(), $class->login(), $class->host(), $class->from()
                          ));
        }
        #push @{$class->{chan}}, [$class->nick(), $class->channel(), $class->login(), $class->host(), $class->from() ];
        $nick		= $class->nick();
        $channel	= $class->channel();

        if ($class->cfg("find", "/channel/$channel/talk") ne "yes") #$class->cfg($channel, "talk") ne "")
        {
            printf("Speak channel mis à zero\n");
            $class->channel_speak($channel, 0);
        }
        else
        {
           $class->channel_speak($channel, 1);
        }

        $class->{chan2}->{$nick}->{$channel}	= $class->add_struct();
        $class->channel_list($channel);
        $class->debug( 99, sprintf("   ADD: (channel...), %s : %s, %s, %s, %s, %s",
                            $class->nick(), $class->level(), $class->channel(), $class->login(), $class->host(), $class->from() ));
    }
}

sub rename_nick
{
    my $class	= shift;
    return( $class->del_channel(@_, "changenick") );
}

#
# $action	= LVL	update level
#		= QUIT	Quit channel
# &($nick, "action", $value, "chan1 chan2 ...");
sub update_channel
{
    my $class	= shift;
    my $req	= shift || "";
    my $action	= uc(shift || "");
    my $var	= shift || undef;
    my $challow	= shift || "";

    #$challow	=~ s/\*/\.\*/g; # Pour les channel : #chna* == #chan.* en perl...
    my %user;

    if ( defined($class->{chan2}->{$req}) )
    {
        %user	= %{$class->{chan2}->{$req}};
        foreach my $chan (keys %user )
        {
            # On vérifie qu'il a bien le droit dans ce channel!
            if ($challow =~ / *$chan */i || $challow =~ / *\* */)
            {
                # Update ... LVL, QUIT, ...
                if ($action eq "LVL")
                {
                    $user{'lvl'}	= $var;
                    $class->{chan2}->{$req}->{$chan}->{'lvl'}	= $var;
                }
            }
        }
    }

}

sub topic
{
    my $class	= shift;
    my $to	= lc(shift) || "";
    my $nick	= shift || "";
    my $topic	= shift || "";
    my $time	= shift || "";

    if ($time eq "")
    {
        $class->{chan_topic_time}->{$to}	= time();
    #printf(" TT '%s'\n", $class->{chan_topic_time}->{$to});
    }
    if ($topic ne "")
    {
        $class->{chan_topic}->{$to}	= $topic;
    #printf(" CT '%s' :: '%s'\n", $topic, $class->{chan_topic}->{$to});
    }
    if ($nick eq "")
    {
        $nick = "server";
    }

    $class->{chan_topic_nick}->{$to}	= $nick; # Pas au bonne endroit, mais je m'en fou :)

    #$class->debug(59, sprintf("!: &channel::topic value '%s'", $class->{chan_topic}->{$to}) );
    #                                    to     nick  topic
    #printf(" KKKKK '%s': '%s', '%s'\n", $nick, $to, $topic);
    #printf(" KKKKK '%s': '%s', '%s'\n", $class->{chan_topic_nick}->{$to}, $to, $class->{chan_topic}->{$to}  );
    return( $class->{chan_topic}->{$to} );
}

sub del_channel
{
    my $class		= shift;
    $class->ident( shift, shift, shift, shift );
    #my $nick		= shift || "jose $#_ ";
    my $newnick		= lc(shift) || "";
    my $action		= shift || "leave";

    my $nick		= $class->nick();
    my $channel		= $class->channel();

    my @tmp			= (); # Pour ajouter les noms des channels QUITtés par l'user...

# Essayer pour quitter tous les channels, un channel et IRC QUIT

    $class->debug( 99, sprintf("del_channel3: List: '%s', '%s', '%s', '%s'\n",
                           $class->nick(), $class->channel(), $class->login(), $class->host() #, $class->from()
                          ));
           # j'efface un channel
           if ($nick eq "") # && $host eq "" && $login eq "" ...
           {
               foreach my $tmp (keys %{$class->{chan2}})
               {
                   #if ($class->{chan2}->{$tmp}->{$channel})
                   #if ($tmp eq $nick)
                   #{
                       $class->debug( 99, sprintf("del_channel2: REMOVE CHANNEL: %s on %s, %s\n", $tmp, $channel, $class->{chan2}->{$nick}->{$channel}) );
                       delete $class->{chan2}->{$tmp}->{$channel};
                       delete $class->{chan2}->{$tmp} unless (%{$class->{chan2}->{$tmp}});
                       delete $class->{chan2_list}->{$tmp};
                       $class->channel_list($channel, "raz");
                   #}
               }
               #delete $class->{chan2_list}->{$channel};
               $class->channel_list($channel, "raz");
           }
           # ChangeNick et LeaveChannel/QuitChannel...
           elsif($newnick ne "" || $channel eq "*")
           {
               foreach my $tmp (keys %{$class->{chan2}->{$nick}})
               {
                       if ($newnick ne "")
                       {
                           $class->{chan2}->{$newnick}->{$tmp} = $class->{chan2}->{$nick}->{$tmp};
                           $class->debug( 99, sprintf("del_channel2: CHANGE NICK Channel: %s on %s as newnick = '%s' --- >  '%s'__%s :: %s\n", $nick, $tmp, $newnick, $class->{chan2}->{$newnick}->{$tmp}->{'nick'},
                               $class->{chan2}->{$newnick}->{$tmp},
                               $class->{chan2}->{$nick}->{$tmp}

                           ) );
                       }
                       else
                       {
                           $class->debug( 99, sprintf("del_channel2: CLEAR NICK Channel: on %s\n", $tmp) );
                       }
                       push @tmp, $tmp; # pour mémoriser les channels sorties...
                       delete $class->{chan2}->{$nick}->{$tmp};
                       delete $class->{chan2}->{$nick} unless (%{$class->{chan2}->{$nick}});
               }
           }
           else
           {
             # j'enleve un user d'un channel
               $class->debug( 99, sprintf("iiidel_channel2: del_user: %s\n", $nick) );
               delete $class->{chan2}->{$nick}->{$channel};
               delete $class->{chan2}->{$nick} unless (%{$class->{chan2}->{$nick}});
           }
    return(\@tmp);
}

sub init_channel
{
    my $class			= shift;
    $class->{chan}		= ();
    $class->{chan2}		= ();
    $class->{chan2_list}	= ();
    $class->{chan_topic}	= {};
    $class->{chan_topic_nick}	= {};
    $class->{chan_topic_time}	= {};
}

# Elle existe pour ne pas refaire un $class->ident lors d'un &ADD_channel!
sub _find_channel
{
    my $class		= shift;
    my %ret;

    my $nick		= $class->nick();
    my $channel		= $class->channel();

    if (defined($class->{chan2}->{$nick}->{$channel}) )
    {
        %ret = %{$class->{chan2}->{$nick}->{$channel}};
        $class->debug( 99, sprintf("   FIND_Channel: user exist '%s'\n", $ret{nick}) );
    }
    return( \%ret );
}

sub channel_list
{
    my $class	= shift;
    my $channel	= shift || "";
    my $opt	= shift;

    my $ret	= "";

    if (defined($opt) )
    {
        if ($opt eq "raz" )
        {
            if (defined($class->{chan2_list}->{$channel}) )
            {
                delete $class->{chan2_list}->{$channel};
            }
        }
        elsif($opt eq "hash")
        {
            $ret	= $class->{chan2_list}; #return list HASH
        }
        elsif($opt eq "get")
        {
            $ret	= $class->{chan2_list}->{$channel}; #return value
        }
    }
    else
    {
        if ($channel ne "")
        {
            $ret	= $class->{chan2_list}->{$channel}	= $channel;
        }
    }
    return( $ret?$ret:"" );
}

sub get_list_user
{
    my $class	= shift;
    my $pattern	= shift || ".*";
    my @list	= @{$class->{list}};

    my %user;

    $class->debug(99, "&get_list_user(): Start\n");
    printf("  get_list_user: ");
    printf("+----------------------------------------+-----+-------------------------------\n" );
    foreach my $top ( @list )
    {
        %user = %{$top};

        $var	= sprintf("%s!%s\@%s", $user{'nick'}, $user{'login'}, $user{'host'} );
        if ( 1 ||  $var =~ /$pattern/ )
        {
            printf("  get_list_user: ");
            printf("%40s | %3s | %s (tm: %s)\n", $var, $user{'lvl'}, $user{'channel'}, $user{'temp'} );
        }
    }
    $class->debug(99, "&get_list_user(): End\n");
}

sub get_list_channel
{
    my $class	= shift;
    #my @list	= @{$class->{chan}};
    my %list	= %{$class->{chan2}};
    my $buf	= "";

    $class->debug( 99, sprintf("List2 HASH") );
    foreach my $tmp (keys %list )
    {
       $buf .= $tmp . " ";
       foreach my $tip (keys %{$list{$tmp}} )
       {
           $buf .= $tip . " ";
           foreach my $top (keys %{$list{$tmp}{$tip}} )
           {
              $buf .= $list{$tmp}{$tip}{$top} . " ";
              #$buf .= $tmp . " ";
           }
       }
       $class->debug( 99, sprintf("ARRAY: %s", $buf) );
       $buf = "";
    }
}

sub get_list_channel2
{
    my $class	= shift;
    my $opt	= shift || "scalar";
    my $ret	= "";

    foreach my $tmp (keys %{$class->{chan2_list}})
    {
        if ($opt eq "scalar")
        {
            if ($ret ne "") { $ret	.= ", "; }
            $ret	.= $tmp . "(" . ($class->channel_speak($tmp)?'Talk':'Shutup') . ")";
        }
    }
    return ( $ret );
}

# USER #

# Utilisateur 'nick' doit etre sur le channel,
# la gestion sur who se fera plu tard, vraiment plus tard :)
sub adduser
{
    my $class		= shift;
    $class->nick( shift) ;
    $class->pass( shift );
    $class->level( shift );
    $class->login( shift );
    $class->host( shift );
    $class->channel( shift );

    $class->ident($class->nick(), $class->channel(), $class->login(), $class->host() ); # bah ca évite d'avoir la structure de fro partout...
    $class->add( $class->{list} );
}

# Ajoute un user temporaire, celui-ci n'est pas enresgistré dans userlist.
sub adduser_temp
{
    my $class		= shift;
    $class->temp( time() ); #$class->cfg("find", "adduser_time" ) ); 
    $class->adduser( @_ );
    printf("----------------------------------------------------------------------\n");
    $class->update_channel($_[0], "LVL", $_[2], $_[5]); # $nick, action, value....

    $class->temp(0);
}

# A. Cette fonction est censée remplacer &Channel::do_level pour au moins
#    Mybot...
#    Elle vérifie, sous forme de nick:login@host, l'existance
#    du $from
#       &get_level_user("#channel", "nick") ||
#       &get_level_user("#channel", "nick!login\@from") ||
#
# B. Pour s'autentifier avec login/password.
#       &get_level_user("", "nick!login\@from", Login, Password)
sub get_level_user
{
    my $class	= shift;
    my $channel	= shift;
    my $from	= lc(shift) || "";
    my $login	= shift || "";
    my $password= shift || "";

    my @list	= @{$class->{list}};

    $class->ident_from( $from );
    my %ret	= %{$class->user_default()};
    my %user;
    delete $class->{lvl};


    # Si from contient seulenent un nickname alors je cherche
    # son login/host dans la liste de channels où je suis.
    # afin de le remplacer par un véritable champ from
    # comme nick!login@host ....
    if ($from !~ /\!.*\@/ && $from ne "")
    {
        #$from	= $class->from();
        if (defined($class->{chan2}->{$from}->{$channel}) )
        {
            $class->debug(99, sprintf("   search_from in chanlist: from: '%s', channel: '%s' -> '%s'", $from, $channel, $class->{chan2}->{$from}->{$channel}));
            %ret = %{$class->{chan2}->{$from}->{$channel}};
            $from	= sprintf("%s!%s\@%s",
                                   $from,
                                   $class->{chan2}->{$from}->{$channel}->{'login'},
                                   $class->{chan2}->{$from}->{$channel}->{'host'} );
            #printf("ICI : '%s'\n", $from);
        }
    }
    else
    {
        $class->ident_from( $from ); # sour forme *!*@*
    }

    #printf("glu1: %s | %s\n", $channel, $from );
    RETd: foreach my $top ( @list )
    {
        %user = %{$top};

        $var	= sprintf(".*!~*%s\@.*%s", $user{'login'}, $user{'host'} );

        # ATTENTION ici le login est représenté par le "nick"...
        if ( $login ne "" && $password ne "" ) # si password/login eq à ""
        {
            # Section servant à identifier un user...
            if ($login eq $user{'nick'} && $password eq $user{'pass'} )
            {
                %ret = %user;
                last RETd;
            }
        }
        elsif ( $from =~ /$var/ )
        {
            # Je stock dans un HASH tous le channel-droit
            # pour faciliter la recherche, et donc éviter de revenir ici...
            foreach my $tmp ( split(/ /, $user{'channel'}, 9999) )
            {
                if ($tmp ne "")
                {
                    #printf("chn: '%s'\n", $tmp);
                    #$class->{lvl}->{$tmp}	= $tmp;
                    $class->{lvl}->{$tmp}	= $user{'lvl'};
                }
            }
            #$class->{lvl}->{$tmp}	= "llll".$user{'channel'};
            #$class->{lvl}->{$user{'channel'}}	= $user{'channel'};
            if ($user{'channel'} =~ /\*|ALL|all/)
            {
                #printf("glu2: %s | %s\n", $var, $user{'lvl'}, $user{'channel'} );
                $class->{lvl}->{'all'}	= $user{'lvl'};
                %ret = %user;
                #last RETd;
            }
            elsif ($user{'channel'} =~ /$channel/)
            {
                #printf("glu3: %40s | %3s | %s\n", $var, $user{'lvl'}, $user{'channel'} );
                %ret = %user;
            }
            else
            {
                #printf("glu4: %40s | %3s | '%s'\n", $var, $from, $user{'channel'} );
            }
            #printf("glu6: %40s | %3s | '%s'\n", $var, $channel, $class->get_level_user_channel($channel) );
            #printf("glu6: %40s | %3s | '%s'\n", $var, $channel, $class->{lvl}->{$channel} );
        }
    }

    if (0)
    {
    foreach my $tmp (keys %{$class->{lvl}})
    {
        printf("lvl: '%s => %s'\n", $tmp, $class->{lvl}->{$tmp});
    }
    }

    return( \%ret );
}

# Cette fonction est totalement dépendante de &get_level_user
# Cette dernière doit être lancé avant &get_level_user_channel
# sous penne de message/avertissement d'erreur.
# Elle renvoit le nivo, numérique, d'une personne sur un channel
# qu'elle soit connue de la listuser ou pas.
sub get_level_user_channel
{
    my $class	= shift;
    my $channel	= shift;

    # l'ordre des if est important
    # cela permet d'avoir des droits sur tous les channels sauf
    # dans certains...
    if (defined($class->{lvl}->{$channel} ))
    {
        if ($class->{lvl}->{$channel} )
        {
            #printf("get_level_user_channe1: %s\n", $class->{lvl}->{$channel});
            return( $class->{lvl}->{$channel} );
        }
    }

    if ( defined($class->{lvl}->{'all'}) && $class->{lvl}->{'all'} > 0 )
    {
        #printf("get_level_user_channe2: %s\n", $class->{lvl}->{'all'});
        return( $class->{lvl}->{'all'} );
    }

    return( 0 );
}

# Renvoit le nick de l'utilisateur qui se trouve dans $pattern si et
# seulement s'il se trouve dans un channel...
# Si plusieur utilisateurs sont trouvé, dans le cas d'un match ((\S+).*)
# alors il revoint la liste sour forme de scalaire
# &get_user_channel(channel, "pattern", "chaine à placer avant $ret");
sub get_user_channel
{
    my $class	= shift;
    my $channel	= shift;
    my $pattern	= shift || "";
    my $before	= shift || "";
    #my $after	= shift [[ "";

    my @ret	= ();

    #printf("JE RENTRE avec '%s', '%s'\n", $channel, $pattern);
    #$pattern = "^" . $pattern ."\$";
    $pattern = quotemeta($pattern);
    #$pattern =~ s/\*/\E\.\*\Q/g;
    $pattern =~ s/\\\*/\.\*/g;
    my $zoubida	= '.*';


    $class->debug(99, sprintf("&get_user_channel: Enter foreach: Channel:%s, Pattern: '%s'\n", $channel, $pattern));
    foreach my $top (keys %{$class->{chan2}})
    {
	#printf("  OUH11! found: '%s' ! '%s'\n", $top, $pattern);
	if (lc($top) =~ m/^$pattern$/i)
	#if (lc($top) =~ m/^\Q$pattern\E$/i)
	{
	    #printf("    OUHAA! found: '%s' ! '%s'\n", $top, $pattern);
            if (1 && defined($class->{chan2}->{$top}->{$channel}) )
            {
		$top	= $before . $top;
	        $class->debug(99, sprintf("get_user_channels: %s -> '%s'\n", $top, $pattern));
		push @ret, $top;
            }
	}
    }
    return( join(" ", @ret) );
}

sub do_level
{
    my $class	= shift;
    $nick	= lc(shift) || "";
    my %ret;
    my @ret	= ();;
    my %user;
    my %list_user;
    my $channel	= "";

    $class->{ret}	= undef;

# je vérifie le nick dans la liste channel
#  Si trouvé, alors je compare son host à celui la list_user
#  s'il existe je renvoit list_user + channel où il se trouve.

    #$class->get_list("list");
    #$class->splash2($class->{list} );

    # On cherche le nivo de la personne qui utilise level (sans arguements)
    if ($nick eq "")
    {
        foreach my $top ( @{$class->{list}} )
        {
            %user = %{$top};

            if ($nick eq "" && $user{'login'} eq $class->login()  && $user{'host'} eq $class->host() )
            {
                %ret = %{$top};
                #printf("Level2: %s, %s\n", $user{'login'}, $user{'host'} );
            }
        }
    }
    else
    {
        # Je le cherche dans les channels où je me trouve.
        # Une fois trouvé, je le cherche dans la listuser (par login/host)
        foreach my $tmp (%{$class->{chan2}->{$nick}})
        {
            if ($class->{chan2}->{$nick}->{$tmp})
            {
                printf("do_level3(): %s :: %s\n", $nick, $tmp);
                $channel	.= $tmp . " ";
                %ret	= %{$class->{chan2}->{$nick}->{$tmp}};
            }
        }

        # Si je le trouve dans un channel, je cherche ses différents niveaux
        # la listuser
        


        # Si je le trouve pas dans le channel, je cherche dans la liste des users connus.
        if (1 || $channel eq "")
        {
            foreach my $top ( @{$class->{list}} )
            {
                %user = %{$top};
                if ($channel eq ""  && $nick eq $user{'nick'} )
                {
                    #%ret = %{$top};
                    #push @ret, %{$top};
                    push @ret, $top;
                    printf("do_level5:\n");
                }
                #elsif( $user{'login'} =~ /(~*)$ret{'login'}$/ && ( $ret{'host'} eq $user{'host'} || $user{'host'} =~ /$ret{'host'}$/) )
                #elsif( $user{'login'} eq $ret{'login'} && $ret{'host'} eq $user{'host'} )
                elsif( $user{'login'} eq $ret{'login'} && ( $ret{'host'} =~ /.*$user{'host'}/ || $user{'host'} =~ /$ret{'host'}$/) )
                {
                    #push @ret, %{$top};
                    push @ret, $top;
                    #printf("do_level6: '%s'=='%s', '%s'=='%s'\n", $user{'login'}, $ret{'login'}, $user{'host'}, $ret{'host'});
                }
            }
        }
        #printf("do_level4(): PAS TROUVE %s\n", $nick);
        #%user	= %{$class->_find_channel($nick)};
    }

    $class->{ret}	= \@ret;
    #if ($#ret >= 0) { $class->{ret}	= \@ret; }
    return( \%ret );
    return( \@ret );
    return( \%ret, \@ret );
}

sub do_change
{
    my $class	= shift;
    my $login	= shift || "";
    my $pass	= shift || "";
    my $newpass	= shift || "";

    my @list	= @{$class->{list}};
    my $ret	= 0;
    my $i	= 0;

    if ($login ne "")
    {
        foreach my $tmp (@list)
        {
            if ($tmp->{nick} eq $login)
            {
                #printf("CHANGE::::   %s, %s, ori: '%s'\n", $tmp->{nick}, $tmp->{pass}, ${$class->{list}}[$i]->{'pass'} );
                $tmp->{pass}	= $newpass;
                #printf("CHANGEiii:   %s, %s", $tmp->{nick}, $tmp->{pass});
                $ret	= 1;
            }
            $i++;
        }
    }
    return($ret);
}



########################################################################
#
# MISC
#
########################################################################
sub debug
{
    my ($class) = shift;
    my ($lvl)   = shift;
    my ($arg)   = shift;
    my ($buf)   = "";

    $_ = \$arg;
    if ($class->{DEBUG} >= $lvl)
    {
       #printf("DEBUG: ");
       if (/SCALAR\(.*\)/ )
       {
          printf("%s\n", $arg);
       }
       elsif (/ARRAY\(.*\)/ )
       {
          #  10        10         10
             $buf .= $class->{msg}{debug};;
             foreach my $tmp (@$arg)
             {
                $buf .= sprintf("[%s] %s", $tmp);
             }
             $buf .= sprintf ("\n");


             printf ($buf);
       }
       elsif ( /HASH\(.*\)/ )
       {
          #  10        10         10
          printf ("-HASH: \n");
          foreach my $tmp (keys %$arg)
          {
              printf(" %8s=>%s\n", $tmp, ${$arg}{$tmp} );
          }
       }
    }
}


# Rêgle le comportement du bot, parler ou pas, sur un channel.
# Si &channel_speak("name_channel")          Renvoit la valeur du name_channel
#    &channel_speak("name_channel", "raz")   Je réinitialise la liste.
#    &channel_speak("name_channel", !"")     Mémorise $opt dans l'option du $channel.
#    &channel_speak("", "")                  Renvois la liste des options de speak...
#                                            sous forme de HASH
sub channel_speak
{
    my $class	= shift;
    my $channel	= shift || "";
    my $opt	= shift;
    #my $channel	= shift || "";
    #my $opt	= shift || "";

    if (defined($opt) )
    {
        if ($opt eq "raz" )
        {
            $class->{option}->{speak} 	= {};
        }
        elsif ($opt ne "")
        {
            $class->{option}->{speak}->{$channel}	= $opt;
        }
        elsif ( $channel eq "" )
        {
            return($class->{option}->{speak});
        }
    }
    return($class->{option}->{speak}->{$channel});
}

sub config_read
{
    my $class	= shift;
    $class->read_list($class->{user_list}, $class->{list}, "adduser");
}

sub config_write
{
    my $class	= shift;
    $class->write_list($class->{user_list}, $class->{list}, "adduser");
    $class->debug(10, "Listuser writed in file '". $class->{user_list} ."'\n");
}

sub read_list
{
    my $class	= shift;
    my $file	= shift;
    my $list	= shift;
    my $method	= shift;

    my @tmp	= ();

    $class->{list}	= ();

    #my $fh	;

    if ( open( IN, "$file") )
    {
	while ( <IN> )
	{
	    #printf("Fileh1/ %s\n", $_);
	    @tmp = split(" ", $_, 99);
            #&{$class->{method_r}->{$method}} ($class, @tmp);
            if (defined($class->{method_r}->{$tmp[0]}) || $class->{method_r}->{$tmp[0]} ne "")
            {
                &{$class->{method_r}->{$tmp[0]}} ($class, splice(@tmp, 1, 9999) );
            }
	}
        close(IN);
    }
    else
    {
        $class->debug(1, "Erreur d'e lecture pour le fichier : ".$file);
    }
}

sub write_list
{
    my $class	= shift;
    my $file	= shift;
    my $list	= shift;
    my $method	= shift;

    my $fh	;

    if ( open( $fh, ">".$file) )
    {
	$class->debug(40, sprintf("Write file USERLIST '%s' ok\n", $file) );
	foreach my $tmp ( @{$list} )
	{
	    &{$class->{method_w}->{$method}} ($class, $tmp, $fh);
	}
        close($fh);
    }
    else
    {
        $class->debug(1, "Erreur d'écriture pour le fichier : ".$file);
    }
}

sub read_adduser
{
    my ($class)	= shift;

    $class->adduser( shift, shift, shift, shift, shift, join(" ", @_)  );
}

sub write_adduser
{
    my ($class)	= shift;
    my $tmp	= shift;
    my $fh	= shift;

    if (  $tmp->{temp} == 0)
    {
        printf $fh ("adduser %s %s %s %s %s %s\n",
	       $tmp->{'nick'},
	       $tmp->{'pass'},
	       $tmp->{'lvl'},
	       $tmp->{'login'},
	       $tmp->{'host'},
	       $tmp->{'channel'},
	       #$tmp->{''},
                );
    }
}

sub ident
{
    my $class		= shift;
    $class->nick( lc(shift)	);

    if ( @_ )
    {
    $class->channel( lc(shift) || "");
    }
    $class->login( lc(shift) );
    $class->host( lc(shift) );

    return( $class->from( $class->nick() . "!" . $class->login() . "\@" . $class->host() )      );
}

sub ident_from
{
    my $class		= shift;
    my $from		= shift;

    if ($from =~ /^~*(\S+)\!(.*)\@(.*)$/)
    {
        $class->nick( $1 );
        $class->login( $2 );
        $class->host( $3 );
    }

    return( $class->from( $from )      );
}

sub from	{ my ($class) = shift; if (@_) { $class->{from}		= shift; } return( $class->{from} ); }
sub channel	{ my ($class) = shift; if (@_) { $class->{channel}	= shift; } return( $class->{channel} ); }
sub nick	{ my ($class) = shift; if (@_) { $class->{nick}		= shift; } return( $class->{nick} ); }
sub login	{ my ($class) = shift; if (@_) { $class->{login}	= shift; } return( $class->{login} ); }
sub host	{ my ($class) = shift; if (@_) { $class->{host}		= shift; } return( $class->{host} ); }
sub level	{ my ($class) = shift; if (@_) { $class->{level}	= shift; } return( $class->{level} ); }
sub pass	{ my ($class) = shift; if (@_) { $class->{pass}		= shift; } return( $class->{pass} ); }
sub temp	{ my ($class) = shift; if (@_) { $class->{temp}		= shift; } return( $class->{temp}?$class->{temp}:0 ); }
#sub from	{ my ($class) = shift; if (@_) { $class->{from}		= shift; } return( $class->{from} ); }

########################################################################
# Non utilisées:
# Plus utilisées
########################################################################
sub splash2
{
    my $class	= shift;
    my ($l)     = shift || "";
    my $c       = shift || 0;
    my (%m);

    $_ = ref($l);
    if (ref($l) eq "HASH")
    {
        %m = %{$l};
        #$class->spouf($c);
        #$c++;
        foreach my $tmp (keys %m )
        {
            printf("{ %s => ", $tmp);
            $class->splash2( $m{$tmp}, $c );
            printf("}\n");
        }
    }
    elsif (ref($l) eq "ARRAY")
    {
        foreach my $tmp ( @{$l} )
        {
            $class->splash2( $tmp, $c );
        }
    }
    else
    {
        printf("%s\n", $l);
    }
}

sub find_channel
{
    my $class		= shift;
    my $ret		= 0;
    $class->ident( @_ );

    $class->debug( 99, sprintf("   FIND_channel: (channel), %s, %s, %s, %s, %s\n",
                            $class->nick(), $class->channel(), $class->login(), $class->host(), $class->from() ));

    return( $class->_find_channel() );
    return( $ret );
}

sub do_level_old1
{
    my $class	= shift;
    $nick	= lc(shift);
    my %ret;

    #$class->get_list("list");
    #$class->splash2($class->{list} );

    foreach my $top ( @{$class->{list}} )
    {
       foreach my $tmp (keys %{$top})
       {
          if ($tmp eq "nick")
          {
             if ( lc(${$top}{$tmp}) eq $nick)
             {
                %ret = %{$top};
                printf("AVANT LEVEL: %s, %s\n", $top, $top );

    #$class->debug(99, sprintf( "A: LEVEL: Nick: %s!%s@%s LVL: %s, CH: %s \n",  $ret{'nick'}, $ret{'login'}, $ret{'host'},$ret{'lvl'}, $ret{'channel'} ));
             }
          }
          #printf("TMP: %s => %s\n", $tmp, ${$top}{$tmp} );
       }
    }

    printf("TESTEEEUU: %s, %s\n", ref(%ret), %ret);
    return( \%ret );
}

sub del_channel_old1
{
    my $class		= shift;
    $class->ident( shift, shift, shift, shift );
    my $newnick		= shift || "";
    my $action		= shift || "leave";

    my $nick		= $class->nick();
    my $channel		= $class->channel();

    $class->debug( 99, sprintf("del_channel: List: '%s', '%s', '%s', '%s'\n",
                           $class->nick(), $class->channel(), $class->login(), $class->host() #, $class->from()
                          ));
    #$class->splash( $class->{chan} );
    foreach my $tmp ( @{$class->{chan}}  )
    {
       if ($action eq "leave")
       {
          if ($tmp->[1] eq $class->channel() )
          {
             # j'efface un channel
             if ($class->nick() eq "")
             {
                $tmp = ();
                $class->debug( 99, sprintf("del_channel: REMOVE CHANNEL: %s\n", $tmp->[0]) );
             }
             # j'enleve un user d'un channel
             elsif ($tmp->[0] eq $class->nick() )
             {
                $class->debug( 99, sprintf("del_channel: del_user: %s\n", $class->{chan2}->{$nick}->{$channel}) );
                $class->debug( 99, sprintf("del_channel: del_user: %s\n", $class->{chan2}->{$nick})  );
                delete $class->{chan2}->{$nick}->{$channel};
                delete $class->{chan2}->{$nick} unless (%{$class->{chan2}->{$nick}});
                #$class->{chan2}->{$nick}->{$channel} = ();
                $tmp = ();
                last;
             }
          }
          elsif( $class->channel() eq "*" && $class->nick() eq $tmp->[0] )
          {
             printf("Le mec QUIT alors je l'efface tous mes channels :) ".$class->nick().$class->channel()."\n");
             $tmp = ();
          }
       }
       else
       {
          if ($tmp->[0] eq $class->nick() )
          {
             $tmp->[0] = $newnick;
             $class->debug( 99, sprintf("changenick_channel: New nick: %s : %s\n", $tmp->[0], $newnick) );
          }
       }
    }
}

#
# &listuser( channel );
#
sub list_channel_user_old2
{
    my $class		= shift;
    $class->debug( 99, sprintf("   List2 User: \n") );
    if (defined($class->{chan2}))
    {
       $class->get_list_channel( );
    }
    else
    {
       return("Userlist no defined");
    }

    $class->debug( 99, sprintf("   lis2: \n") );
}

#
# &listuser( channel );
#
sub listuser_old1
{
    my $class		= shift;
    my ($list2)		= shift; # || "";
    $class->debug( 99, sprintf("   List User: \n") );
    if (defined($class->{chan}))
    {
       $class->get_list_channel( );
    }
    else
    {
       return("Userlist no defined");
    }

    $class->debug( 99, sprintf("   lis2: \n") );
}

sub get_list_channel_old1
{
    my $class	= shift;
    my @list	= @{$class->{chan}};
    my $buf	= "";

    $class->debug( 99, sprintf("List ARRAY") );
    foreach my $tmp ( @list )
    {
       foreach my $tip ( @{$tmp} )
       {
          $buf .= $tip . " ";
       }
       $class->debug( 99, sprintf("ARRAY: %s", $buf) );
       $buf = "";
    }
}

sub get_list
{
    my $class	= shift;
    my $list2	= shift;
    $class->debug( 99, sprintf("   Get List : \n")  );

    foreach my $tmp (keys %{$class->{$list2}}  )
    {
        $class->debug(99, sprintf("%s", $tmp ));
       foreach my $top (keys %{$class->{$list2}{$tmp}}  )
       {
           $class->debug(99, sprintf(" %s => %s", $top, $class->{$list2}{$tmp}{$top} ));
       }
    }
}

sub spouf
{
    my $class	= shift;
    my ($c)     = shift || 0;
    for ( ;$c != 0; $c--)
    {
        printf("-");
    }
    print(">");
}

sub splash
{
    my $class	= shift;
    my ($l)     = shift;
    my $c       = shift;
    my (%m);

         $class->spouf($c);
    $c++;
    $_ = ref($l);
    if (/HASH/)
    {
       %m = %{$l};
       #$class->debug( 99, sprintf("%d %s\n", $c, \%m ) );
       foreach my $tmp (keys %m )
       {
          if ( ref( $m{$tmp} ) eq "HASH")
          {
              #$class->debug( 99, sprintf("<> %s\n", $m{tmp}) );
              $class->splash( $m{$tmp}, $c );
          }
          else
          {
              $class->spouf($c);
              #$class->debug( 99, sprintf("%d %s => %s\n", $c, $tmp, $m{$tmp} )   );
          }
       }
    }
    if (/ARRAY/)
    {
       foreach my $tmp ( @{$l} )
       {
          if ( ref( $tmp ) eq "ARRAY")
          {
             $class->splash( $tmp, $c );
          }
          else
          {
             $class->spouf($c);
             #$class->debug( 99, sprintf("%s\n", $tmp)  );
          }
       }
    }
}

# Elle existe pour ne pas refaire un $class->ident lors d'un &ADD_channel!
sub _find_channel_old1
{
    my $class		= shift;
    my %ret;

    foreach my $tmp ( @{$class->{chan}}  )
    {
       if ($tmp->[1] eq $class->channel() )
       {
          if ($class->nick() eq $tmp->[0])
          {
             $class->debug( 99, sprintf("   FIND_Channel: user exist '%s'\n", $tmp->[0]) );
       #push @{$class->{chan}}, [$class->nick(), $class->channel(), $class->login(), $class->host(), $class->from() ];
             %ret = (
                       'nick'	=> $tmp->[0],
                       'channel'	=> $tmp->[1],
                       'login'	=> $tmp->[2],
                       'host'	=> $tmp->[3],
                       'from'	=> $tmp->[4]
                     );
          }
       }
    }

    return( \%ret );
}

1;

