#!/usr/bin/perl 

# 31.08.99
# Modification de option =~ s/%20/ /g.....

package jm_misc;
use strict;

use IO::File;

sub new
{
    my $self    = shift;
    #my %args   = @_;
    my $class   = {};

    bless $class, $self;
    $class->{DEBUG}		= 0;
    $class->{err}	= 0;

    return ($class);
}

# Affiche le contenu d'une table @table
# &(\@var);
sub ptable
{
    my $class   = shift;
    my ($list) = shift;
    foreach my $tmp (@$list) { printf("%s,", $tmp); } print "\n";

}

sub me_chop
{
    my $class   = shift;
    my $var	= shift;

    # Chomp et chop ne pas intelligent!!!!
    # Alors je les aide!!!
    for (my $c=2; $c >= 0; $c--)
    {
       my ($char) = ord(substr($var, length($var)-1, 1));

       chop ($var) if ($char == 10 );
       chop ($var) if ($char == 13 );

       # si char = 10 alors je continu a le cherche en fin de $_
       # car meme si c'est pas normal, ca peut arriver....
       $c++ if ($char == 13);
    }

    return ($var);
}

sub dec
{
    my $class   = shift;
    my $var;
    my $nd;

    ($var, $nd) = @_;
    if (!$nd)
    {
       $nd = 2;
    }

    if ($var =~ /^(.*)\.(.*)/)
    {
       return( "$1." . substr($2, 0, $nd) );
    }
    else
    {
       return( "$var." . substr("0000000000" , 0, $nd) );
    }
}

# Pas fini, voir : use Data::Dumper;
sub splash
{
    my $class   = shift;
    my ($l)     = shift;
    my $c       = shift;
    my (%m);

    $class->spouf($c);
    $c++;
    $_ = ref($l);
    $_ = $l;
    if (/HASH/)
    {
       %m = %{$l};
       $class->debug( 0, sprintf("%d %s\n", $c, \%m ) );
       foreach my $tmp (keys %m )
       {
          if ( ref( $m{$tmp} ) eq "HASH")
          {
          $class->debug( 0, sprintf("<> %s\n", $m{tmp}) );
             $class->splash( $m{$tmp}, $c );
          }
          else
          {
         $class->spouf($c);
         $class->debug( 0, sprintf("%d %s => %s\n", $c, $tmp, $m{$tmp} )   );
          }
       }
    }
    if (/ARRAY/)
    {
       foreach my $tmp ( @{$l} )
       {
          #if ( ref( $tmp ) eq "ARRAY") # 27/01/2006
          if ( /(?:ARRAY)|(?:HASH)/)
          {
             $class->splash( $tmp, $c );
          }
          else
          {
             $class->spouf($c);
             $class->debug( 0, sprintf("%s\n", $tmp)  );
          }
       }
    }
}

sub spouf
{
    my $class   = shift;
    my ($c)     = shift || 0;
    for ( ;$c != 0; $c--)
    {
        printf("-");
    }
    print(">");
}

sub debug
{
    my ($class) = shift;
    my ($lvl)   = shift;
    my ($arg)   = shift;
    my ($buf)   = "";

    $_ = \$arg;
    if ($class->{DEBUG} >= $lvl)
    {
       printf("DEBUG: ");
       if (/SCALAR\(.*\)/ )
       {
          printf("%s\n", $arg);
       }
       elsif (/ARRAY\(.*\)/ )
       {
          #  10        10         10
             $buf .= $class->{msg}{debug};;
             foreach my $tmp (@$arg)
             {
                $buf .= sprintf("[%s] %s", $tmp);
             }
             $buf .= sprintf ("\n");


             printf ($buf);
       }
       elsif ( /HASH\(.*\)/ )
       {
          #  10        10         10
          printf ("-HASH: \n");
          foreach my $tmp (keys %$arg)
          {
              printf(" %8s=>%s\n", $tmp, ${$arg}{$tmp} );
          }
       }
    }
}

sub singlespace
{
    my ($class)	= shift;
    my ($var)	= shift;

    while ( $var =~ s/  / / ){}

    return($var);
}

sub fgets
{
    my $class		= shift;
    my $filehandle	= shift;
    my %opt		= @_;

    # J'aime pas l'appelle <$fh> dans l'criture des fonctions
    # alors j'adapte perl.
    if ($opt{raw} )
    {
        return( $_ = <$filehandle>  );
    }
    else
    {
        return( $class->me_chop($_ = <$filehandle>)  );
    }
}

sub suck_file_in_scalar
{
    my $class	= shift;
    my $file	= shift;

    my $fh;
    my $ret	= "";

    if ( open($fh, $file) )
    {
        while( !eof($fh))
        {
            $ret	.= $class->fgets($fh, raw => "1");
        }

        close($fh);
    }
    else
    {
        $ret	= "Error open file in &suck_file_in_scalar($file)\n";
        $class->{err}	= 1;
    }

    return($ret);
}

# Enregistre un scalair simple, sans sous scalar/hash ...
sub put_scalar_in_file
{
    my $class	= shift;
    my $file	= shift;
    my $scalar	= shift;

    my $fh;
    my $ret	= "";

    $fh = new IO::File ($file, "w+", "077");#O_WRONLY|O_APPEND;
    #$fh = new IO::File "file", O_WRONLY|O_APPEND; # Marche pas, trouve pas O_APPEND...
    #$fh->open( "file", "w+" );
    if (defined($fh))
    #if ( open($fh, $file) )
    {
        foreach my $tmp (@{$scalar})
        {
            printf $fh ("%s", $tmp);
        }

        #close($fh);
        undef ($fh);
    }
    else
    {
        $ret	= "Error open file in &put_scalar_in_file($file)\n";
        $class->{err}		= 1;
        $class->{err_msg}	= $ret;
    }

    return($ret);
}

# Enregistre un scalair simple, sans sous scalar/hash ...
sub put_array_in_file
{
    my $class	= shift;
    my $file	= shift;
    my $array	= shift;

    my $fh;
    my $ret	= "";

    $fh = new IO::File ($file, "w+", "077");#O_WRONLY|O_APPEND;
    if (defined($fh))
    {
        foreach my $tmp (@{$array})
        {
            printf $fh ("%s", $tmp);
        }

        #close($fh);
        undef ($fh);
    }
    else
    {
        $ret	= "Error open file in &put_array_in_file($file)\n";
        $class->{err}		= 1;
        $class->{err_msg}	= $ret;
    }

    return($ret);
}

sub shell_option
{
    my $class	= shift;
    my @opt		= @_;

    foreach my $tmp (@opt)
    {
        #printf(">! %s, \n", $tmp);
        if ($tmp =~ /^(.*) *\= *(.*)$/)
        {
            $class->{opt}->{$1}	= $2;
            #printf("M! %s, l: %s,\n", $1, $2);
        }
        else
        {
            $class->{opt}->{$tmp}	= 1;
        }
    }

    #$class->{opt}	= \%opt;
    return($class->{opt});
}


sub date
{
    my $class	= shift;
    my $date	= shift || time();
    my $opt		= shift || "normal";

    my @DoW;
    my @MoY;
    my @Mon;
    my $nsec	= 0;
    my $nday	= 0;
    my $aprim	= 0; # A'

    my $sec; my $min; my $hour; my $mday; my $mon; my $year; my $wday; 
    if ($opt eq "normal")
    {
        ($sec,$min,$hour, $mday, $mon, $year, $wday) = localtime($date);
    }
    else
    {
    }
    @DoW = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
    @MoY = ('Jan','Feb','Mar','Apr','May','Jun',
            'Jul','Aug','Sep','Oct','Nov','Dec');
    @DoW = ('Dim','Lun','Mar','Mer','Jeu','Ven','Sam');
    @MoY = ('Jan','Fv','Mar','Avr','Mai','Juin',
            'Jui','Aout','Sep','Oct', 'Nov','Dec');
    @Mon = ('31','28','31','30','31','30',
            '31','31','30','31', '30','31');

    my $lday	= $DoW[$mday];

    if ($opt eq "normal")
    {
        my $lmon	= $MoY[$mon];
        $mon++;
        $year	+= 1900;
        $date        = sprintf("%s/%s/%s  %s:%s", 
                               substr("0000".$mday,		1, 2),
                               substr("0000".$mon,		1, 2),
                               $year,
                               substr("0000".$hour,	1, 2),
                               substr("0000".$min,		1, 2),
                               );
    }
    else
    {
        use integer;
        $aprim	= $year / 4;
        $aprim	=~ /^(\d+)(\.*)(.*)$/;
        $aprim	= $1;
        if ($3 eq "")
        {
            #printf("Anne bisextielle\n");
            $nday	+= 1;
        }
        else
        {
            #printf("Anne normale\n");
        }

        no integer;
        #printf("Nombre de jours  ajouter ; ca vient des annes bissextille '%s'\n", $1);
        for(my $i=0; $i < $mon-1; $i++)
        {
            $nday += $Mon[$i];
        }
        # on ajoute le nombre de jours + celui du mois courant
        $nday += ($year * 1461 / 4) + $mday;
        #printf("Nombre de jours Total '%s'\n", $nday);
        $nsec	+= $nday * (24 * 3600);
        $nsec	+= $hour*3600 + $min*60 + $sec;
        
        $date	= $nsec;
        #printf("Nombre de seconds depuis l'an 0 (...)  '%s'\n", $nsec);
    }
    return ( $date );
}

1;
