#!/usr/bin/perl -w

# Version 0.0.2
# A REVOIR


package Config2;

use vars qw($VERSION @ISA @EXPORT $msg $arg @arg $tmp $var $ret
        );

use strict;
use warnings;
use diagnostics;
#use Carp; # croak("blabla");
#use jm_misc;
use Config::General;
use Data::Dumper;
use File::Basename();
#use IRC::Bot;
#use POE;
#use POE::Component::IRC;

if (0 && $#ARGV >= 0)
{

my $opt		= "get";

    if ($ARGV[0] =~ /(get|put|find|list)/)
    {
        $opt	= $1;
        shift @ARGV;
    }

my $o	= new Config2(
                       configfile => "bot.cfg"
                     );
    if ($opt eq "list")
    {
        use Data::Dumper;
        print Dumper( $o->{cfg} );
    }
    else
    {
       foreach my $tmp (@ARGV)
       {
           if ($opt eq "find")
           {
               printf("Method FIND %s: '%s'\n", $tmp, $o->find($tmp)  );
           }
           elsif ($opt eq "put")
           {
               $o->put($tmp, $ARGV[1]);
               #shift @ARGV;
               printf("Method PUT : %s var = %s\n", $tmp, $ARGV[1]);
               printf("   retour de FIND : '%s'\n", $o->get($tmp)  );
               last;
           }
           else
           {
               printf("Method  GET %s: '%s'\n", $tmp, $o->get($tmp)  );
           }
       }
    }
        #print Dumper( $o->{cfg});
$o->test();
}

=head1 DESCRIPTION

=over
=back

=cut

sub new
{
    my $self	= shift;

    my $class	= {};
    $self	= ref($self) || $self;
    bless $class, $self;

    my %opt	= ();
    if ( $#_ >= 0)
    {
        %opt	= @_;
    }
    else
    {
        # Config default
        %opt	= (
                    configfile	=> "config.conf",
                   );
    }

    $class->{DEBUG}	= "99";

    unless (-f $opt{configfile})
    {
        $opt{configfile}	= "sextium.conf";
        #printf("ll '%p'\n'", $class->{config}->ParseConfig( $opt{configfile} ) );
    }

    $class->{config}	= new Config::General(
                                 -DefaultConfig		=> "",
                                 -ConfigFile		=> $opt{configfile},
                                 -UseApacheInclude	=> "",
                                 #-AllowMultiOptions	=> "no", # elle fait planter quand il y a un double (c nul)
                                 -IncludeRelative	=> 1
                                 );

    #$class->{cfg}	= {};
    $class->cfg_set( $class->{config}->{config} );
    return ( $class );
}

=item cfg_set
Fonction de bas niveau (Pile 1)

=over

Sans option, cfg_set(), renvoit la rfrence de la liste de configuration. Elle
mmorise la configuration acquise avec Config::General, dans $class->{cfg}, si un $config
possde une rfrence ...

=over

<!> Son existance peut paratre inutile, mais en ce qui me concerne sa prsence me
rassure et rends mon code claire.

=back

=back

=cut
sub cfg_set
{
    my $class		= shift;
    if ($#_ >= 0)
    {
        my $config		= shift || {};
        $class->{cfg}	= $config;
    }
    return( $class->{cfg} );
}

=item _put_get
Permet de reccuprer, ou de placer, une valeur. dans un HASH au format "Config::General".
Si le chemain (path) n'existe pas, alors il le crer... En y plant le contenu de $var.

<!> PUT() Si la valeur,  l'interrieur d'un HASH donc d'un <tag></tag> n'existe pas, &_put_get
crera la clef avec la valeur contenu dabs $var. Pareil avec un HASH. Ex:
Si vous fait (_put_get("/valide/valide2/non_valide1/non_valide2/non_valide3", $cfg, "valeur", "put")
&_put_get() crera un hash $cfg->{valide}->{valide2}->{non_valide1}->{non_valide2}->{non_valide3} = "valeur".

=over

=back

=cut
sub _put_get
{
    my $class	= shift;
    my $path	= shift;
    my $cfg	= shift || $class->cfg_set();
    my $var	= shift || "no";
    my $opt	= shift || "get";

    # comme : sub f { ... $var =~ /(.*)/; if defined($1) {$var = $1;} &f($var); }# une fois dans le &f le $1 garde
    #          -> &f($var) => $1 == previous $1... (thx Benjamin Dauvergne)
    while( $path =~ s%//%/%g) {}
    my @toto		= ($path		=~ /(.*)\/+$/); # on limine le dernier /
    if (defined($toto[0])) { $path		= $toto[0]; }

    my $ret		= "";
    my @path		= split(/\//, $path, -1);

    foreach my $tmp (@path) { if ($tmp eq "") { shift @path;} }

    if ($opt =~ /global/) { @path	= $path[$#path]; }

    if (defined($path[0]) && $path[0] ne "")
    {
       if (defined($cfg->{$path[0]}))
       {
           if ( $#path >= 1)
           {
               $ret = $class->_put_get( join("/", @path[1..$#path]), $cfg->{$path[0]}, $var, $opt );
               #printf("/%s(%s, %s), ret='%s'\n", $path[0], $cfg->{$path[0]}, join("/", @path[1..$#path]), $ret  );
           }
           else
           {
               #printf("/%s(%s, %s), ret='%s'\n", $path[0], $cfg->{$path[0]}, join("/", @path[1..$#path]), $ret  );
               #printf("FINAL : origin: '%s', ", ${$cfg}{$path[0]});

               if ($opt eq "put" )
               {
                   $ret	= ${$cfg}{$path[0]} = $var;
               }
               else
               {
                   $ret	= $cfg->{$path[0]};
               }
               #printf("aprs: '%s' = %s\n", $path[0], $ret);
           }
       }
       else # PENSER  virer le  && $path[0] ne "" du if
       {
           if ($opt eq "put")
           {
               if ( $#path >= 1)
               {
                   $ret = ${$cfg}{$path[0]}	= {};
                   $ret = $class->_put_get( join("/", @path[1..$#path]), $cfg->{$path[0]}, $var, $opt );
               }
               else
               {
                   $ret = ${$cfg}{$path[0]}	= $var;
               }
           }
       }
    }

    return( $ret?$ret:"" ); # no undef, bad choice.
}

sub find
{
    my $class	= shift;
    my $path	= shift;
    my $cfg	= shift || $class->cfg_set();
    $cfg	= $class->{cfg};

    my $ret	= "";

    $ret = $class->_put_get($path, $cfg, "");

    if ($ret eq "")
    {
        $ret = $class->_put_get($path, $cfg, "", "global");
    }
    return( $class->response_norm($ret?$ret:"") );
}

sub get
{
    my $class	= shift;
    my $path	= shift;
    my $var	= shift || "";
    my $cfg	= shift || $class->cfg_set();

    my $ret	= $class->_put_get($path, $cfg);

    return( $class->response_norm($ret?$ret:"") );
    return( $ret?$ret:"" );
}

sub put
{
    my $class	= shift;
    my $path	= shift;
    my $var	= shift || "";
    my $cfg	= shift || $class->cfg_set();

    my $ret	= $class->_put_get($path, $cfg, $var, "put");

    return( $ret?$ret:"" );
}

=item _global
Fonction de bas niveau (Pile 1)

=over

=back

=cut
sub _global
{
    my $class		= shift;

    my $ret		= undef;

    # SET
    if ($#_ >= 0)
    {
        $ret	= $class->{cfg}	= shift;
    }
    # GET
    elsif (defined($class->{cfg}))
    {
        $ret	= $class->{cfg};
    }

    return( $ret );
}

sub save_file
{
    my $class		= shift;
    my $filename	= shift || "sextium.tmp";
    my $cfg		= shift || $class->{cfg};

    $class->{config}->save_file($filename, $cfg);
}

sub to                { my ($class) = shift; if (@_) { $class->{to}                = shift; } return( $class->{to} ); }

########
# MISC #
########
sub response_norm
{
    my $class	= shift;
    my $ret	= shift || "";
    $ret	=~ s/\l(none|non|not|no)/no/ig;
    $ret	=~ s/\l(yes|oui|ja)/yes/ig;
    return( $ret );
}

sub test
{
    my $class	= shift;

    ##$class->{cfg}->{global}	= "GloBals";
    #$class->{cfg}				= ();
    #$class->{cfg}->[0]->{global}->{talk}	= "None";
    #$class->{cfg}->[0]->{global}->{autojoin}	= "all";
    #$class->{cfg}->[1]->{gyptis}->{talk}	= "yes";
    #$class->{cfg}->[2]->{linuxfr}->{log}	= "yes";
    #$class->{cfg}->[2]->{linuxfr}->{talk}	= "no";

    #$class->{cfg}		= $o->{cfg};
    #$class->{cfg}->{Name}	= ("ASTERIX");
    #$class->{cfg}->{global}->{talk}	= "None";
    $class->{cfg}->{global}->{kill}	= "no";
    $class->{cfg}->{gyptis}->{talk}	= "non merci";
    #$class->{cfg}->{linuxfr}->{log}	= "yes";
    #$class->{cfg}->{linuxfr}->{talk}	= "no";
    #$class->{cfg}->{server}	= {'freenode' => {'autojoin'	=> "no"}};

    #print Dumper( $class->{cfg} );
    printf("
Recherche du contenu de : channel=gyptis=talk			: %s
Rfrence de                                   channel=linux	: %s
Recherche du contenu de                                 talk	: %s
Recherche du contenu de : /channel/nochannel/talk		: %s
    ",
       $class->find("/channel/gyptis/talk/"),
       $class->find("/channel/gyptis"),
       $class->find("///talk"),
       $class->find("/channel/nochannel/talk"),
       );
    #$class->{cfg}->{}	= ;

    $class->save_file("rcfile", $class->{cfg}); # enregistre n'importe kel HASH (ne comportant pas d'array)
    printf("FIN NORMAL\n");
    #$o->save_string("rcfile");
    #$o->save_store("rcfile");
}

###########################
# Pas utilis ou Dpass: #
###########################


# Greffe $cfg dans $class->{cfg}
sub fusion
{
    my $class	= shift;
    my $cfg	= shift || {};
    my @user	= %{$class->{cfg}};
    my @user2	= %{$cfg};
    my %user	= ();

    if ( $class->{cfg} )
    {
         %user   = @user; # pour viter les cellules orphelines.
         @user   = %user; # symbiose avec /^
         %user   = @user2;
         @user2  = %user;

         @user   = (@user, @user2);
    }
}

=item cfg_read

=over
Fonction de niveau moyen (Pile 2)
Cette fonction cherche la (ou les) clefs "$key" dans la configuration. Elle
commence ses recherches dans la partie dcrite par "$section", si l'action
choue c'est dans la section "global" qu'elle continue la recherche.

=back

=cut
sub cfgread
{
    my $class		= shift;
    my $section		= shift;

    my $key		= "";

    my $ret		= "";
    my $_global		= $class->_global();
    my @section		= split(/\//, $section, -1);

    # GET section, dans un tag
    if (defined($_global->{$section}))
    {
        $key	= shift;
        $ret	= $_global->{$section}->{$key};
    }
    # GET global, hors des tags...
    elsif (defined($_global))
    {
        if (defined($_global->{$section}))
        {
            $ret	= $class->{$section};
        }
    }


    return( $ret?$ret:"" ); # no undef, bad choice.
}

1;
