#!/usr/bin/perl -w

# Version 0.1.1 07/06/2004
#   Ajout de &anagramme, qui cherche l'anagramme d'un mot.

# Version 0.0.1 07/06/2004
#   Cration de Dico.pm
#   Ajout de &search, pour chercher un mot dans le dictionnaire de Ren.


# A REVOIR

# A. prendre en compte "? pour n'importe kel caractre 0 ou 1 fois"
#                      ". pour n'importe quel caractre"
#                      "* pour n'importe quel caractre ou rien"
#                      "+ pour n'importe quel caractre"
# B. dtudier remplacement du exec/grep par glob( {a,b,...} dans dico/anagram)

package Dico;

use vars qw($VERSION @ISA @EXPORT $log $help
        $tmp $var $ret $word
        );

use strict;
use warnings;
use Carp; # croak("blabla");
    use English;
use jm_misc;

# HELP:
# $var = new Dico ( [self] );
# "self" command extern, result depend of called the "$var = new Dico ..."
if (0)
{

$ENV{PATH}	= "/usr/bin/:/bin/";
my $dico	= new Dico();
#$dico->wordlong(join(" ", @ARGV) );
printf("Anagrammes trouv : '%s'\n", $dico->anagramme(join(" ", @ARGV) )  );
#printf("Mots trouv : '%s'\n", $dico->word(join(" ", @ARGV) )   );
printf("Mots trouv : '%s'\n", $dico->{obj}->{"word"}($dico, join(" ", @ARGV))   );
}

sub new
{
    my $self = shift;
    my $class        = {};
    bless $class, $self;

    if ( $#_ >= 0)
    {
        $class->{self}	= shift;
    }

    $class->{DEBUG}        = "99";

    # variables de fonctionnements
    $class->dico_file( "/usr/share/dico-cougnenc/dictionnaire.dic" );
    $class->dico_exe(  "/usr/bin/dico");

    $class->{found}		= {};
    $class->{found_array}	= {};
    $class->{found_hash}	= {};

    $class->{obj}	= {
                            "word"	=> \&word,
                            "dico"	=> \&word,
                            "anagram"	=> \&anagramme,
                            "anagrame"	=> \&anagramme,
                            "anagramme"	=> \&anagramme,
                          };

    # On charge les fichier, variable, liste, ...
    #$class->load();

    return ( $class );
}

# j'ai pas chech  optimiser, alors camembert :)
sub anagramme
{
    my $class	= shift;
    my $var	= shift || "_nb_words_";

    ($word)	= split(/ /, $var, -1);

    my @my	= ();
    my @found	= ();
    my %found	= ();
    my %ana	= ();
    my $faut	= 0;
    my $nb	= 0;
    #my $len	= 0;
    #my $all_len	= 0;
    my $nia	= "";

    for (my $i = 0; $i < length($var); $i++)
    {
        push @my, '['.$var.']';
    }
    #$class->multi_find2( $word);
    $class->multi_find2('^'. join ("", @my)."\$", $word);
    if ($#{$class->{found}} >= 0)
    {
        # Je comptabilise les lettres  chercher ; soit le nombre de fois
        # o elles peuvent tre prsentes dans le dictionaire.
        for my $tmp (split(//, $var, -1))
        {
            if ($tmp ne "")
            {
                $ana{$tmp}++;
                #printf("C: '%s'\n", $tmp);
            }
        }

        for my $tmp ( @{$class->{found}})
        {
            $nia	= $tmp;
            for my $lettre (keys %ana)
            {
                #if (1 || $lettre ne "")
                #{
                    #printf(" Mots : '%s' lettre recherche '%s' (n) fois '%s'\n", $tmp, $lettre, $ana{$lettre});
                    $nb = ($tmp =~ s/$lettre//ig);
                    if ( $nb  != $ana{$lettre})
                    {
                    #printf("   Faut pour : '%s'\n", $lettre);
                        $faut++;
                        last;
                    }
                    #printf("A: '%s' = %s, ", $tmp, $ana{$tmp});
                #printf("\n");
                #}
            }

            if ($faut == 0)
            {
                #printf("Mots a anagramme correct: '%s'\n", $nia);
                # chain
                push @found, $nia;
                $found{$nia}	= 1;

                # Len
                #$len					= length( $nia );
                #$all_len				+= $len + 1; # +1 for \0 ...
                #$class->{found_hash_len}->{$nia}	= $len;
                #push @{$class->{found_array_len}}, $len;

            }
            $faut = 0;
        }
        #printf("mots trouvs : %s\n", join(", ", @{$class->{found}}) );
    }

    $class->{found_array}	= \@found;
    $class->{found_hash}	= \@found;

    #$class->{found_len}		= $all_len;
    return( join(", ", @found) );
}

sub word
{
    my $class	= shift;
    my $var	= shift || "_nb_words_";

    ($word)	= split(/ /, $var, -1);

    $class->multi_find2("'^".$var."\$'", $word);
    if ($#{$class->{found}} >= 0)
    {
        #printf("mots trouvs : %s\n", join(", ", @{$class->{found}}) );
    }
    $class->{found_array}	= $class->{found};
    return( join(", ", @{$class->{found}})   );
}

sub multi_find
{
    my $class	= shift;
    my $regex	= shift || "";
    my $var	= shift || "_nb_words_";
    my $fh;
    ($word)	= split(/ /, $var, -1);
    my $dico	= $class->dico_file();
    my @found	= ();

    my $exe	= sprintf(q@grep -i %s %s@, $regex, $dico);
    $class->debug(99, "II: " .$exe);
    $class->{found}	= {};

    if ( open($fh, "$exe" . "|"))
    #if ( open($fh, "/usr/bin/dico ange" . "|"))
    {
        $ENV{PATH}	= "/usr/bin/:/bin/";

        while (<$fh>)
        {
             # faire quelque chose
            $_	= $class->fgets( $fh );
            if ($_ ne "")
            {
                push @found, $_;
                #printf("mots trouv : %s\n", $_ );
            }
        }
        $class->{found}	= \@found;
        close( $fh );
    }


}

sub multi_find2
{
    my $class	= shift;
    my $regex	= shift || "";
    my $var	= shift || "_nb_words_";
    my $fh;
    ($word)	= split(/ /, $var, -1);
    my $dico	= $class->dico_file();
    my @found	= ();

    my $exe	= sprintf(q@grep -i '%s' %s@, $regex, $dico);
    $exe	= sprintf("grep -i %s %s", $regex, $dico);
    $class->debug(99, "II: " .$exe);
    $class->{found}	= {};

    $ENV{PATH}	= "/usr/bin/:/bin/";
    my $pid	= 0;
    my @temp	= ();

    if (defined( $pid = open($fh, "-|")) )
    {
    if ($pid) # parent
    {
        #printf("PID existe : %s\n", $pid );
        while ( !eof( $fh ))
        {
            $_	= $class->fgets( $fh );
            if ($_ ne "" && $_ !~ /^\#.*$/)
            {
                push @found, $_;
            }
            #printf("mots trouv : %s\n", $_ );
        }
        $class->{found}	= \@found;
        close( $fh );
    }
    else
    {
        my @temp = ($EUID, $EGID);
        $EUID = $UID;
        $EGID = $GID; # initgroups() est aussi appel !
        # S.assurer que les privilges sont rellement partis
        ($EUID, $EGID) = @temp;
        die "Can.t drop privileges" unless $UID == $EUID && $GID eq $EGID;
        $ENV{PATH} = "/bin:/usr/bin:/home/mans/sextium";
        my $exe	= sprintf(q@grep -i '%s' %s@, $regex, $dico);
        exec ( "grep", "-i", $regex, $dico);
        #exec ( "grep", "-i", "^ange\$", $dico);
        #exec ( $exe );
    }
    }
}

sub fgets
{
    my ($class)	= shift;
    my $fh	= shift;
    if ( defined($class->{self})  )
    {
       $ret	= $class->{self}->fgets( $fh );
    }
    else
    {
       $ret	= &jm_misc::me_chop($class, $_ = <$fh>);
    }

    return( $ret );
}

sub dico_file	{ my ($class) = shift; if (@_) { $class->{dico_file}	= shift; } return( $class->{dico_file} ); }
sub dico_exe	{ my ($class) = shift; if (@_) { $class->{dico_exe}	= shift; } return( $class->{dico_exe} ); }
sub host	{ my ($class) = shift; if (@_) { $class->{host}	= shift; } return( $class->{host} ); }
sub debug
{
    my ($class)	= shift;
    if ( defined($class->{self})  )
    {
       $class->{self}->debug( @_ );
    }
    else
    {
       shift; # on passe le lvl
       print @_;
       print ("\n");
    }
}

1;


