#!/usr/bin/perl -w
#
#
# Dernière utilisation/odif : juil. 23  2010 Mybot.pm

# A REVOIR
# A. &macro_level_commun bugge, il permet à tout le monde d'effacer
#    n'importe quel macro.
# B. placer un verrou dans macro_add afin d'éviter d'ajouter $add comme deuxième arg, après ';'
# C. Empécher l'execution de 10 macro consécutives...
# I. Ajouter la prise en compte des déjà opé dans Channel.pm parse_mode
# L. Ajouter fonction encylopédique autre que add, un truc sérieux...
# Z. objectiver le maximum :)
# N. INtégrer 1,2:3 dans macro_run
# O. &dico marche plus :(
# AA. dans sub log, remplacer _channel par kkch de mieux, qui prent en compte 
#     les demandes privées.
# BB. &do_log2, ne prends pas 1 ou 0 arguement, 0 arg doit afficher le INFO, 1 (si channel) le INFO...
# CC. do_part, ne part pas quand l'argument est manquant.


# Fonction à présenter
# $class->ident( ["login@host.dtl"] );	Identifie l'utilisateur "from"
#					Elle cherche toutes les informations
#					contenus dans la vase user.list et les
#					places dans $class->{current_user}.
#					<!> $class->current_user( opt ) permet
#					de controler $class->{current_user} plus
#					facilement...

# $class->current_user( [$hash] | [$var] );
#					Cette fonction gère l'identité courante
#					établie par $class->ident();
#					Elle permet d'accèder facilement aux
#					informations personnelles d'un utilisateur
#					reconnu dans la "userlist". Ex: pour avoir
#					son mot de pass : $class->current_user("pass");
#					$var peut contenir (nick, pass, login, host,
#					channel, lvl, ...)

#					
package Mybot;

use vars qw($VERSION @ISA @EXPORT $log $seen $auth $help $mybot
        $from $nick $channel $_channel $_prefix_chan $chan $lvl $pass $cmd @list %list $msg $arg @arg
        $login $host $sec $min $hour $mday $mon $year $wday %current_user $lmon $lday
        $tmp @tmp $var $ret $id $prefix_msg $prefix
        $nom_say $received_by $action $from $add_id $message $finished $created $delete $delete_time
        );

use strict;
use warnings;
use Data::Dumper;
use Carp; # croak("blabla");
use jm_misc;
#use IRC::Bot;
#use POE;
#use POE::Component::IRC;

use Channel;
use Dico;


if (0)
{
require Exporter;

@ISA     = qw(Exporter AutoLoader);
@EXPORT  = qw();
$VERSION = '0.04';

}

sub new
{
    my $self	= shift;

    my $class        = {};
    bless $class, $self;

    ### OPTIONS ###
    my %opt	= ();
    if ( $#_ >= 1 )
    {
        %opt	= @_;#$opt;
    }
    elsif( ref($_[0]) eq "HASH")
    {
        %opt	= %{$_[0]};
    }
    $class->{opt}	= \%opt;
    $class->cfg_default( );

    $class->{_channel}		= new Channel();
    $class->{_channel}->{DEBUG}	= "99";

    $class->{dico}		= new Dico( $class );
    $class->{macro}		= new Macro(self => $class);

    return ( $class );
}

sub init
{
    my $class		= shift;

    # variables de fonctionnements
    $class->{do_parse}		= ();
    $class->{lvl}		= 0;
    #$class->{prefix_msg}	= $class->cfg("find", "/prefix_msg"); #{config}->{prefix_msg};
    $class->{prefix_msg}	= $class->{cfg}->{cfg}->{prefix_msg};
    printf("DDDDDDDDDDD: '%s'\n", $class->{prefix_msg} );
    $class->{prefix_chan}	= $class->{cfg}->{cfg}->{prefix_chan};
    $class->{sleep}		= 0;

    # STAT
    $class->{stat}->{list_word}	= {};
    $class->{stat}->{file}	= $class->{cfg}->{cfg}->{stat}->{namefile};

    # Macro
    $class->{macro}->{macro_file}	= $class->{cfg}->{cfg}->{macro}->{namefile};

    # On charge les fichier, variable, liste, ...
    $class->load();

    # CFG futur line for file_config.sextium
    $class->{cfg}->{server}->{MAX_IRC}	= $class->{cfg}->{cfg}->{server}->{MAX_IRC}; # char max for privmsg...

}

sub cfg_default
{
    my $class		= shift;
    my $opt		= shift;

    #$class->{cfg}->{prefix_msg}		= '[\!\$\-\+]';
    $class->{cfg}->{cfg}->{prefix_chan}	= "\#";
    $class->{stat}->{file}		= "stat.txt";
    $class->{cfg}->{cfg}->{server}->{MAX_IRC}	= 466;
    #$class->{cfg}->{}		= ;
}

sub cfg
{
    my $class	= shift;
    my $opt	= shift || "get";
    my $branch	= shift || "";
    my $var	= shift || "";

    my $ret	= "";

  printf("\n\nCGF: %s\n\n", $opt);
  if (defined($class->{cfg}) )
  {
    $branch	=~ s/\#//;
    $class->debug(99, "CFG2($opt), branch=$branch, var=$var\n");
    if ($opt eq "put")
    {
        $ret	= $class->{cfg}->put($branch, $var);
    }
    elsif ($opt eq "find")
    {
        $ret	= $class->{cfg}->find($branch);
    }
    else
    {
        $ret	= $class->{cfg}->get($branch);
    }
  }
  else
  {
    $class->debug(10, "Module Config2 is not implement\n");
  }

    return( $ret);
}

sub load
{
    my $class		= shift;
    $class->{macro}->macro_read_list( $class->{macro}->{macro_file} );
    if ( $class->{_channel} )
    {
        $class->{_channel}->config_read();
    }
    $class->stat_read($class->{stat}->{file});
}

sub save
{
    my $class		= shift;
    $class->{macro}->macro_write_list( "test.xml" );
    $class->{macro}->macro_write_list( $class->{macro}->{macro_file} );
    if ( $class->{_channel} )
    {
        $class->{_channel}->config_write();
    }
    $class->stat_write($class->{stat}->{file});
}

# For parse command interne for the bot.
sub myon_cmd
{
    my $class		= shift;

    my $prefix	= substr($class->{prefix_msg}, 0, 1);
    #printf("MYON_CMD: '%s' %s\n", $prefix, join (" ", @_));
    $class->on_cmd($class, shift, shift, shift, $prefix . shift, @_);
}

sub on_cmd
{
    my $class		= shift;
    $class->{self}	= shift;
    $class->from        ( shift );
    $class->to		( shift );

    #printf("MMM: '%s', '%s'\n", $class->to(), $class->{prefix_chan} );
    if ($class->to() =~ /^($class->{prefix_chan})(.*)$/)
    {
        $_channel	= $2;
        $_prefix_chan	= $1;
    }
    $msg		= shift;
    my $lvl		= 0;
    my $ret		= 0;
    my $sleep		= 0;
    my $cmd_ok		= 1; # Sert à savoir si $cmd à été traité ou pas,
                             # si ce n'est pas le cas alors l'appel
                             # à &macro_run() est effectué en fin de function (on_cmd)

    # On vire $, ! ou - du début de $msg
    $prefix_msg	= $class->{prefix_msg};
    @tmp	= ($msg =~ /^ *([${prefix_msg}])(.*)$/);
  if ( defined($tmp[0]) && $tmp[0] ne '' )
  {
        $class->{on_cmd}->{prefix_msg}	= $tmp[0];
        $msg	= $tmp[1];

    $class->msg( $msg ); # backup de msg
    $msg	= jm_misc::singlespace($class, $msg);

    $class->ident( $class->from() );
    return("nick no defined") unless (defined($class->nick()) ); # toujours le placer avant &ident()
    if ($class->{self}->current_nick() eq $class->nick() )
    {
       return("Impossible de me parler à moi-même!\n");
    }


    # EXPLICATION:
    #
    # $arg contient le contenu qui suit la commande à parser.
    #    ex: QUOTE PRIVMSG JOSE: message
    #    $arg contient "PRIVMSG JOSE: message"
    #    $cmd contient "QUOTE"

    $msg		=~ /^ *(.*)$/;
    if (0)
    {
    $msg		= $1;
    ($cmd, $arg)	= split(/ /, $1, 2);
    }
    ($cmd, $arg)	= split(/ /, $msg, 2);
    $cmd		= lc($cmd);
    $arg		= "" unless (defined($arg) );
    #$arg		= quotemeta( $arg );
    $class->arg( $arg ); # Backup de $arg
    $lvl		= $class->level( $class->to() );
    if (1)
    {
        $class->display_divers();
    }
    printf("CMD: SelfTime(%s) \$cmd='%s', \$arg='%s' => classFrom=%s: lvl='%s', Prefix: '%s OU %s'\n", $class->{self}->{time}, $cmd, $arg, $class->from(), $lvl, $class->{on_cmd}->{prefix_msg}, $tmp[0]) ;
    @arg		= split(/ /, $arg, 9999);

    # Commandes Public
    if ($cmd eq "level")
    {
       $class->do_level($arg?$arg:$class->nick());
    }
    elsif($cmd eq "sleep" )
    {
       $class->{self}->{time} += $arg[0];
    }
    elsif($cmd eq "listuser" || $cmd eq "userlist" )
    {
       $class->do_listuser($class->to() );
    }
    elsif ($cmd eq "log")
    {
       $class->do_log2( $arg );
    }
    elsif($cmd eq "list")
    {
       if ($arg[0] eq "macro")
       {
           $cmd        = "macro"; # sera executé par l'appel de &macro_run dans cette fonction
           $cmd_ok        = 0;
       }
       elsif ($arg[0] eq "user")
       {
           $cmd = "listuser";
           $cmd_ok        = 0;
       }
       else
       {
           $class->send_privmsg("Syntaxe: list [user | macro]");
       }
       $arg        = join(" ", @arg[1..$#arg]);
    }
    elsif($cmd eq "add")
    {
       $cmd_ok        = 0;
       if ($arg[0] eq "user")
       {
           $cmd        = "adduser";
           shift @arg;
       }
       elsif ($arg[0] eq "say" || $arg[0] eq "action"  || $arg[0] eq "dico" || $arg[0] eq "rnd")
       {
           $class->{macro}->do_macro_add($cmd, $arg, $msg, @arg);
       }
       else
       {
           $class->send_privmsg("Syntaxe: add [user | say | action]");
       }
       $arg        = join(" ", @arg[1..$#arg]); # ca sert à quelque chose ca ?
    }
    elsif($cmd eq "del")
    {
       $cmd_ok        = 0;
       if ($arg[0] eq "deluser")
       {
           $cmd        = "deluser";
       }
       elsif ($arg[0] eq "")
       {
           $class->send_privmsg("Syntaxe: del user nickname OR login\@host || name_macro [ all ] || id No_ID");
       }
       else
       {
           $class->{macro}->do_macro_del( @arg );
       }
       $arg        = join(" ", @arg[1..$#arg]); # ca sert à quelque chose ca ?
    }
    elsif($cmd eq "say" || $cmd eq "says")
    {
           $channel	= undef;
           if ($arg[0]	=~ /^(#\S+).*$/ && $lvl >= 51)
           {
               $channel	= $1;
               shift @arg;
           }
           $class->send_msg( join(" ", @arg), $channel);
    }
    elsif($cmd eq "msg" || $cmd eq "privmsg")
    {
           $tmp	= undef;
           if (defined($arg[0]) && $lvl >= 50)
           {
               $tmp	= $1;
               shift @arg;
           }
           $class->send_msg( join(" ", @arg), $tmp);
    }
    elsif($cmd eq "action" || $cmd eq "actions")
    {
           $class->send_action("$arg");
    }
    elsif($cmd eq "date")
    {
           #$class->send_action("offre l'heure de la part de Feanor, on est le " . $class->date() . "" );
           $class->send_msg("au 4e top, il sera le " . $class->date() . "" );
    }
    elsif($cmd eq "info")
    {
           $var = sprintf("Je suis le bot '%s' sur channel en mode '", $class->current_nick);
       if (1)
       {
           if ( $class->channel_speak($class->to()) )
           {
               $var	= sprintf("%stalk", $var);
           }
           else
           {
               $var	= sprintf("%sshutup", $var);
           }
       }
           $var = sprintf("%s', j'occupe les channels (%s)\n", $var, $class->get_list_channel());
           $class->send_msg( $var );
    }
    elsif($cmd eq "word" || $cmd eq "dico" || $cmd  eq "anagrame"|| $cmd eq "anagram"
       || $cmd eq "dico" || $cmd eq "dico")
    {
           $class->dico($cmd, $arg);
    }
    elsif ($cmd eq "stop" || $cmd eq "halt" || $cmd eq "end" || $cmd eq "arr.t")
    {
        $class->do_stop($arg);
    }
    elsif ($cmd eq "pass" || $cmd eq "password" || $cmd eq "login" || $cmd eq "ident")
    {
        $class->do_login($arg[0], $arg[1]);
    }
    elsif ( ($cmd eq "suicide" || $cmd eq "kickme" ) && $class->channel_speak($class->to()) )
    {
        $class->kick( $class->to(), $class->nick(), "Paix à ton âme!");
    }
    else
    {
       $cmd_ok        = 0;
    }

if ($lvl != 0 && !$cmd_ok)
{
if ($lvl >= 50)
{
    $cmd_ok        = 1;
    if (
         $cmd eq "me" ||
         $cmd eq "op" ||
         $cmd eq "o" ||
         $cmd eq "giveop" ||
         $cmd eq "massop"
       )
    {
       if ($cmd eq "me" || $cmd eq "giveop" || $cmd eq "me" || $cmd eq "moi" || $cmd eq "o")
       {
           $arg        = $class->nick() . " " . $arg;
       }

       if ($class->{on_cmd}->{prefix} eq "-")
       {
           $class->do_deop($arg);
       }
       else
       {
           $class->do_op($arg);
       }
    }
    elsif( $cmd eq "deop" || $cmd eq "unop" || $cmd eq "dop" ||
           $cmd eq "massdeop" || $cmd eq "massdop" || $cmd eq "no")
    {
        if ($cmd eq "no|unop|deop|dop" || $arg eq "" || $arg eq "me")
        {
            $arg        = $class->nick() . " " . $arg;
        }
       $class->do_deop($arg);
    }
    elsif($cmd eq "k" || $cmd eq "kick")
    {
       $class->do_kick($arg, "kick");
    }
    elsif($cmd eq "sk" || $cmd eq "skick")
    {
       $class->{sleep}	= 1;
       $class->do_kick($arg, "kick");
       $class->{sleep}	= 0;
    }
    elsif($cmd eq "b" || $cmd eq "ban")
    {
       $class->do_ban($arg);
    }
    elsif($cmd eq "ub" || $cmd eq "unban" || $cmd eq "uban")
    {
       #$class->do_unban($arg);
    }
    elsif($cmd eq "invite" || $cmd eq "i")
    {
       $class->do_invite( $arg );
    }
    elsif($cmd eq "topic")
    {
       $class->do_topic( $arg );
    }
    elsif($cmd eq "change") # Doit-être reconnu pour que ca fonctionne.
    {
       $class->do_change( @arg );
    }
    elsif($cmd eq "macro") # Macro information
    {
       $class->{macro}->do_macro_info( @arg );
    }
    else
    {
       $cmd_ok        = 0;
    }
} # level 50

if ($lvl >= 100 && !$cmd_ok)
{
    $cmd_ok        = 1;
    if($cmd eq "adduser" || $cmd eq "useradd")
    {
       if ($arg[0] =~ /help/i)
       {
           $class->send_privmsg("adduser NICK Password evel Login Host.Dtl channels...");
       }
       else
       {
           $class->do_adduser( @arg[0..5] );
       }
    }
    elsif($cmd eq "deluser" || $cmd eq "userdel")
    {
        $class->send_privmsg("Pas encore implémenté !!");
    }
    elsif($cmd eq "listuser" || $cmd eq "userlist" )
    {
       $class->do_listuser($class->to() );
       #splash($class->{_channel}->{list}, 0);
       #&A(\%list, 0);
    }
    elsif($cmd eq "listchan" || $cmd eq "listchannel" )
    {
       $class->{_channel}->get_list_channel();
    }
    elsif($cmd eq "massk" || $cmd eq "masskick")
    {
       $class->do_kick($arg, "masskick");
    }
    else
    {
       $cmd_ok        = 0;
    }
} # level 100

if ($lvl >= 125 && !$cmd_ok)
{
    $cmd_ok        = 1;
    if( $cmd eq "rehash")
    {
       if ($arg eq "write" || $arg eq "save")
       {
           $class->save();
       }
       $class->load();
    }
    elsif( $cmd eq "save")
    {
        $class->save();
       #$class->{macro}->macro_write_list( $class->{macro_file} );
    }
    elsif($cmd eq "join")
    {
        $class->do_join($arg);
    }
    elsif($cmd eq "part" || $cmd eq "leave")
    {
        $class->do_part($arg);
    }
    elsif($cmd eq "rejoin")
    {
        $class->do_part($arg);
        $class->do_join($arg);
    }
    elsif($cmd eq "nick" || $cmd eq "peusdo")
    {
        $class->send("NICK :%s\n", $class->to(), join(" ", @arg));
    }
    elsif($cmd eq "shutup" || $cmd eq "chute" || $cmd eq "tg" )
    {
        $class->channel_speak($class->to(), 0);
    }
    elsif($cmd eq "talk" || $cmd eq "verbose" || $cmd eq "parle" )
    {
        $class->channel_speak($class->to(), 1);
    }
    else
    {
       $cmd_ok        = 0;
    }
} # lvl 125

if ($lvl >= 150 && !$cmd_ok)
{
    $cmd_ok        = 1;
    if ($cmd eq "quote")
    {
       $class->send("$arg\n");
    }
    elsif($cmd eq "quit" || $cmd eq "cassosse") # arret normal
    {
       $class->{self}->{connect_die}	= 1;
       $class->sendp(sprintf("QUIT :%s\n", $arg?$arg:"byebye") );
       #$class->sendp("QUIT :" . $arg?$arg:"byebye" . "\n");
    }
    elsif( $cmd eq "revient") # arret normal
    {
       $class->{self}->{reconnect}	= 1;
       $class->sendp("QUIT :Bougez pas, je reviens!!!!!\n");
    }
    elsif($cmd eq "die") # arret Brutal !!!
    {
       if ($arg eq "")
       {
           $arg	= "Adieu monde cruel!!! je meurs !!!!!!";
       }
       $class->{self}->{connect_die}	= 3;
       $class->sendp("QUIT :". $arg. "\n");
       $class->debug(0, sprintf("Fin demandé par : %s\n", $class->from())   );
       sleep(1);
    }
    elsif ($cmd eq "state")
    {
       #$class->do_stat();
    }
    elsif ($cmd eq "auth")
    {
        $class->my_auth();
    }
    else
    {
       $cmd_ok        = 0;
    }
} # lvl 150

} # lvl == 0
else
{
    #$cmd_ok        = 0; # compte dans le cas où l'utilisateur n'a pas de droits.
    #$ret        = " Vous n'avez pas le niveau suffisant, il faut l'avoir au dessus de : ".$class->lvl();
}

    if ($class->{self}->{connect_die})
    {
        $class->save();
    }

    # cette suite de if pourrait être en haut, mais
    # par soucis :)) d'optimisation et de laisse le bot
    # répondre aux commandes, avant les macros
    if (!$cmd_ok && ( $class->channel_speak($class->to()) || $class->lvl() >= 125)  )#&& $class->{macro}->macro_test($cmd) )
    {
        $cmd_ok		= 1;
        $class->{macro}->macro_run($cmd, $arg, $msg, @arg);
    }

  }
  else
  {
        # NickServ!NickServ@services. NOTICE AsteriX :This nickname is owned by someone els
        if ($msg =~ /\QThis nickname is owned by someone\E/)
        {
            $class->my_auth();
        }
        else
        {
            $class->stat( $msg );
        }
        # Je prends un message privé ou public
        # Si "privé" alors possible d'avoir des commandes à executer...

        return(""); # je réponds pas, car on m'appel pas.
  }
    #$ret = "";
    return($ret);
}



########################################################################
# Version Alpha functions
########################################################################

sub do_stop
{
    my $class	= shift;
    $class->{self}->send_stop( $class->nick() ); # $arg...
}

sub my_auth
{
    my $class	= shift;
    my $fh;

    if (open($fh, "../auth"))
    {
        while(<$fh>)
        {
            $class->send($_);
        }
        close($fh);
    }
}

sub do_login
{
    my ($class)	= shift;
    my $login	= shift || "";
    my $password= shift || "";

    my $top;
    my %user	= ();

    if ($class->lvl() >= 0)
    {
        $top	= $class->level("", $from, $login, $password);
        if (ref($top) eq "HASH")
        {
            #%user	= %{$class->level("", $from, $login, $password)};
            %user	= %{$top};
        }
        if ($class->current_user("lvl") > 0)
        {
            $class->do_adduser_temp($user{"pass"}, $user{"lvl"}, $user{"channel"} );
            $ret	= sprintf("Cool, tes bon :)\n");
        }
        else
        {
            $ret	= sprintf("Te pas bon! essai encore!!!\n");
        }
    }
    else
    {
        $ret	= sprintf("Non, je ne veux pas!! :%s\n", $class->lvl());
    }
    $class->send_notice( $ret );
}

# Change le mot de passe du requérent
sub do_change
{
    my ($class)	= shift;

    my $login	= $arg[0]	|| "";
    my $oldpass	= $arg[1]	|| "";
    my $newpass	= $arg[2]	|| "";

    if ( 1 ) #$class->current_user("pass") eq $oldpass)
    {
        $ret	= sprintf("Changepass: Old: %s, New: %s, \n", $oldpass, $newpass);
        if ($class->{_channel}->do_change($login,
                                    $oldpass,
                                    $newpass
                ))
        {
            $ret	= sprintf("Changement effectué");
            $class->save();
        }
        else
        {
            $ret	= sprintf("!Changement NON effectué");
        }
            printf("__________________________\n");
        #$class->nick(), $class->(), $class->(), $class->(), $class->(), $class->(), $class->(), $class->(), ))
    }
    else
    {
        $ret	= sprintf("Password 'oldpass' invalide");
    }
    $ret	.= '\n';
    $class->send_notice( $ret );
}



########################################################################
# Analizer syntax
########################################################################

sub syntaxe_invite
{
    my ($class)		= shift;
    my $ex		= shift;

    $arg	= $class->to() ." ". jm_misc::singlespace($class, $arg);
    my @nia	= split(/$class->{prefix_chan}/, $arg, 999);
    if ($#nia == 0) { $nia[0] = $class->to() . " " . $nia[0]; }
    foreach my $tmp (@nia)
    {
        if ($tmp ne "" && $tmp =~ /^#*(\S+) *(.*)$/i)
        {
            $channel	= $1?$1:"";
            foreach my $top (split(/ /, $2, 99))
            {
                if ($top ne "")
                {
                    &$ex( $top, $class->{prefix_chan} . $channel );
                }
            }
        }
    }
}

sub syntaxe_channel
{
    my ($class)		= shift;
    my $ex		= shift;

    $arg	= jm_misc::singlespace($class, $arg);
    my @nia	= split(/$class->{prefix_chan}/, $arg, -1);
    if ($#nia == 0)
    {
        if ($class->to() =~ /^\#.*$/)
        {
            #$arg = $class->to() . " " . $arg;
            $nia[0] = $class->to() . " " . $nia[0];
        }
        else
        {
            $class->send_privmsg("Please, specify the name of the channel to leave\n");
        }
    }
    else
    {
        # Pas d'option alors je place le channel courant.
        $nia[0]	= $class->to();
    }
    foreach my $tmp (@nia)
    {
        if ($tmp ne "" && $tmp =~ /^#*(\S+) *(.*)$/i)
        {
            &$ex( $class->{prefix_chan}.$1, $2?$2:"");
        }
        else
        {
            printf("____ trouve pas : '%s', RAS: '%s'\n", $tmp, $2?$2:"RAS");
        }
    }
}

# Cette commande cherche si les nicks existent dans un channel.
# Elle accepte les nick matché : n*k, ...
# <!> Elle s'utilise principalement avec do_parse, elle est crée pour ca...
# Envoyer une liste de nick et elle cherche sur le channel courant.
# dans class->to();
sub match
{
    my ($class)		= shift;
    #my $list		= shift || "";

    #my @list        = split(/ /, $list, 9999);
    my $tmp		= "";
    my @ret		= ();
    my $sens		= "";
    my $nick		= "";

    #foreach my $tmp (@list)
    $class->debug(99, sprintf("&math:"));
    while ($tmp = shift)
    {
        $tmp	=~ /^([\-\+])*(.*)$/;
        $sens	= $1 || "";
        $nick	= $2;

        if ( ($ret = $class->get_user_channel($class->to(), $nick, $sens)) )#$tmp)) )
        {
           $class->debug(99, sprintf("   Touvé: '%s', %s \n", $ret, $tmp));
           #push @ret, $sens . split(/ /, $ret, 9999);
           push @ret, split(/ /, $ret, 9999);
        }
        else
        {
           $class->debug(99, sprintf("   pas trouvé: %s%s\n", $sens, $nick));
           # Donc je l'ajoute pas!
           #push @ret, $sens . $tmp;
        }
    }

    return( \@ret );
}

# Commande générqiue pour décoder les options de ban, op, mode ...
# avec arguement "-o +b +nick -nikc2...."
#                1         2         3          4                 5
#    &do_parse(\@list, pattern="", sep=\#, "moins|plus" , "normal | limited");
# 5 => limited ne renvoit pas les moins, mais uniquement les plus.
# 5 => normal  mode normal, renvoit tout.
sub do_parser
{
    my $class		= shift;
    my $albator		= shift; # Liste des personnes à changer le mode

    my $mode		= shift || "normal";
    my $sep		= shift || "\#";
    my $sens		= shift || ""; # "" == cotenu de arg qui en dépent
    my $match		= shift;
    my $channel		= "";
    my $var		= "";
    my $moins		= "";
    my $plus		= "";
    my $opt		= 0;
    my $ret		= 0;
    my @albator		= ();
    my @niol		= ();
    my @nio		= ();
    my @moins		= ();
    my @plus		= ();
    my %albator		= ();

    if (!defined($match)) { $match	= 1; }
    $albator		=~ /^.*$sep(.*)$/; # j'élimine les demandes privées
    $albator		= $1;
                                # Si la demande vient d'un mesage privé j'ignore
                                # tout ce qui n'est pas suivi d'un nom de channel...
                                # En privé, on devra préciser le channel /msg me Action #channel nick...
    $class->debug(99, sprintf("Option DO_parse: 1:'%s', 2:'%s', 3:'%s', 4:'%s', 5:'%s' \n", $albator, $mode, $sep, $sens, $match) );
    my @nia        = split(/$sep/, $albator, 99999);

    if ($sens eq "moins")
    {
        $moins	= '^\-(.*)';
        $plus	= '^\+(.*)';
    }
    else
    {
        $moins	= '^\-(.*)';
        $plus	= '^\+?(.*)';
    }
    # Trie par #channel
    foreach my $tmp (@nia)
    {
       # Trie par nick.
       @niol        = split(/ /, $tmp, 9999);
       $class->parse_mode_add("raz");
       # match()
       if (defined($niol[0]))
       {
          if ($niol[0] ne "")
          {
              $class->debug(99, sprintf("    \#channel: #%s\n", $niol[0] ));

              $channel        = "$sep" . lc( shift(@niol) );
              if ($match)
              {
                  @niol	= @{$class->match( @niol )};
              }
              printf( "PRIVMSG :%s\n", $channel?$channel:"" ); # Value default

              # Je trie les options à ajouter ou enlever.
              # $top contient le NICK
              @moins        = ();
              @plus        = ();
              foreach my $top (@niol)
              {
                  if ($top ne "")
                  {
                      if ($top =~ /$moins/ ) # Je supprime une option
                      {
                          $class->debug(99, sprintf("   Moins: '%s =~ '/%s/', %s", $top, $moins, $1));
                          $var = $1;
                          if ($mode eq "limited")
                          {
                              $class->parse_mode_del($var, $channel);
                              printf("  INFO6: %s  :: %s\n", $1, $plus);
                          }
                          else
                          {
                              push @albator, [$channel, "moins", $var];
                              $class->parse_mode_add($var, $channel, "moins");
                              printf("  INFO7: %s  :: %s\n", $1, $plus);
                          }
                      }
                      elsif ($top =~ /$plus/) # J'ajoute
                      {
                          $class->debug(99, sprintf("   Plus: '%s', %s", $plus, $1));
                          $var = $1;
                          push @albator, [$channel, "plus", $var];
                          $class->parse_mode_add($var, $channel, "plus");
                      }
                      else
                      {
                          if ($sens eq "moins")
                          {
                              if ($mode eq "limited")
                              {
                                  $class->parse_mode_del($top, $channel);
                              }
                              else
                              {
                                  printf("  INFO4: %s  :: %s\n", $1, $plus);
                                  push @albator, [$channel, "moins", $top];
                                  $class->parse_mode_add($top, $channel, "moins");
                              }
                          }
                          else
                          {
                              printf("  INFO5: %s  :: %s\n", $1, $plus);
                              push @albator, [$channel, "plus", $top];
                              $class->parse_mode_add($top, $channel, "plus");
                          }
                      }
                   }
               }

               
               # Créer un ARRAY à partir du hash
               @albator	= ();
               $var	= $class->parse_mode_add("hash");
               printf("  HASH: %s  :: %s\n", $var, "");
               if ( defined($var) )
               {
                   foreach my $tmp (keys %{$var})
                   {
                       foreach my $top (keys %{$class->parse_mode_add("hash", $tmp)})
                       {
                           $var	= $class->parse_mode_get($tmp, $top);
                           push @albator, [$top, $var, $tmp];
                       }
                       printf("\n ");
                   }
               }
          }
       }
    }

    $class->{do_parse}        = \@albator;
    #foreach my $tmp (@{$class->{do_parse}})
    #{
        #@nio = @{$tmp};
        #printf("Channel: %s, action: %s, nick: %s-\n", $tmp->[0], $tmp->[1], join(" ", @nio[2 .. $#nio]));#splice(@{$tmp}, 2, 999)) );
    #}

    return( \@albator );
    return( $ret );
}

sub parse_mode_add
{
    my $class	= shift;

    my $opt	= "++";
    if ($#_ <= 1)
    {
        $opt	= shift || $opt;
    }
    my $nick	= shift || "";
    my $channel	= shift;
    my $sens	= shift;

    my $ret	= "";
    my $i	= 0;
    my $exists	= 0;

    if ($opt eq "++")
    {
        $ret	= $class->{parse_mode}->{list}->{$nick}->{$channel}	= $sens;
        for($i =0; $i <= $#{$class->{parse_mode_array}}; $i++)
        {
        #(@{$class->parse_mode_array})
        #push @albator, [$channel, "moins", $top];
        #$class->parse_mode_add($top, $channel, "plus");
            if ($nick eq ${$class->{parse_mode_array}}[$i]->[0])
            {
                ${$class->{parse_mode_array}}[$i]->[1] = $sens;
                $exists	= 1;
                last;
            }
        }

        if (!$exists)
        {
            push @{$class->{parse_mode_array}}, [$channel, $sens, $nick]
        }
    }
    elsif ($opt eq "raz")
    {
        delete $class->{parse_mode}->{list};
        $class->{parse_mode_array} = ();
    }
    elsif ($opt eq "hash")
    {
        if ($nick ne "")
        {
            $ret	= $class->{parse_mode}->{list}->{$nick};
        }
        else
        {
            $ret	= $class->{parse_mode}->{list};
        }
    }
    elsif ($opt eq "array")
    {
        $ret	= $class->{parse_mode_array};
    }

    return( $ret );
}

sub parse_mode_del
{
    my $class	= shift;

    my $var	= shift || "";
    my $var2	= shift;

    my $ret	= 0;

    if ( defined($class->{parse_mode}->{list}->{$var}->{$var2}) )
    {
        delete $class->{parse_mode}->{list}->{$var}->{$var2};
        if ( !%{$class->{parse_mode}->{list}->{$var}} )
        {
            delete $class->{parse_mode}->{list}->{$var};
        }
        $ret	= 1;
    }
    return( $ret );
}

sub parse_mode_get
{
    my $class	= shift;

    my $var	= shift || "";
    my $var2	= shift;

    my $ret	= "";

    if ( defined($class->{parse_mode}->{list}->{$var}->{$var2}) )
    {
        $ret	= $class->{parse_mode}->{list}->{$var}->{$var2};
    }
    return( $ret );
}

########################################################################
# User misc
########################################################################

sub do_invite
{
    my ($class)		= shift;
    my $ex		= sub { $class->send("INVITE %s %s\n", shift, shift);};
    $class->syntaxe_invite($ex, @_);
}

sub do_join
{
    my ($class)		= shift;
    my $ex		= sub { $class->join2( shift ); };
    $class->syntaxe_channel($ex, @_);
}

sub join2
{
    my ($class)	= shift;
    my $channel	= shift;

    if ($class->{_channel}->channel_list( $channel, "get" ) eq "" )
    {
        $class->send("JOIN %s\n", $channel);
        #$channel	=~ s/\#//g;
        $class->cfg("put", "/channel/$channel/active", "yes");
    }
    else
    {
        printf("Je ne suis pas connecté sur le channel '%s' (%s)\n", $channel, $class->{_channel}->channel_list( $channel, "get" ));
    }
}

sub do_part
{
    my ($class)		= shift;

    my $ex		= sub { $class->part(shift, shift); };
    $class->syntaxe_channel($ex, @_);
}

sub part
{
    my ($class)	= shift;
    my $channel	= shift;
    my $raison	= shift || "";

    if ($class->{_channel}->channel_list( $channel, "get" ) ne "" )
    {
        $class->send("PART %s :%s\n", $channel, $raison);
        #$channel	=~ s/\#//g;
        $class->cfg("put", "/channel/$channel/active", "no");
        #printf("PART: '%s'\n", $class->cfg("get", "/channel/$channel/active")  );
    }
}

sub do_adduser
{
    my ($class)	= shift;

    my $newchan	= "";
    ($nick, $pass, $lvl, $login, $host) = @_;
    ($chan)	= join(" ", @_[5..$#arg]); #splice(@arg, 3, 9999) );
    #$chan	=~ s/\*/ALL/g;

    $ret = "";

    if ($class->{adduser_temp} == 1)
    {
    unless (defined($nick) )
    {
        $ret	= "Nickname ";
    }
    unless( defined($pass) )
    {
        $ret	.= "Password ";
    }
    unless( defined($lvl) )
    {
        $ret	.= "Level ";
    }
    unless( defined($chan) )
    {
        $ret	.= "Channel ";
    }

    if( $ret ne "" )
    {
        $ret	= "no define : " . $ret;
    }
    } # $class->{adduser_temp}

    if ($ret eq "")
    {
        foreach my $tmp ( @_[5..$#_] ) # Je regroupe les channels droits
        {
            if ($class->get_level_user_channel($tmp) => 125)
            {
                $chan		=~ s/\Q$tmp\E *//g;
                $newchan	.= $tmp . " ";
        #printf("LVL:: C:'%s', NC:'%s'\n'", $chan, $newchan);
            }
        }

        if ($newchan ne "" && $chan ne "")
        {
            $ret	= sprintf("Les channels suivant ont été refusés, car vous n'avez pas de droits sur : '%s'", $chan);
            $class->send_privmsg($ret);
        }

         # On ajoute l'utilisateur.
        $ret	= sprintf ("L'utilisateur 'User=%s!%s\@%s' a été ajouté avec le niveau '%s' sur : '%s'. Pensez à lui demander de changer son password\n",
                           $nick, $login, $host, $lvl, $newchan, $pass) ;
        printf("mybox: adduser: ret:'%s'\n", $ret);

        if ($class->{adduser_temp} == 1)
        {
            $class->{_channel}->adduser_temp($nick, $pass, $lvl, $login, $host, $newchan);
            $ret	= "";
        }
        else
        {
            $class->{_channel}->adduser($nick, $pass, $lvl, $login, $host, $newchan);
            $class->save();
        }
        #printf("LVL:: '%s', '%s', '%s, %s'\n'", $class->get_level_user_channel($tmp),
        #    $tmp, $chan, $newchan);
    }
    if ($ret ne "")
    {
        $class->send_privmsg($ret);
    }
}

sub do_adduser_temp
{
    my ($class)		= shift;
    my $password	= shift;
    my $lvl		= shift || 0;
    my $channel		= shift || $class->to();

    $class->{adduser_temp}	= 1;
    printf("LOGIN:: '%s', '%s, '%s', '%s', '%s', chan: '%s'\n", $class->nick, $password, $lvl, $class->login(), $class->host(), $channel);
    $class->do_adduser($class->nick, $password, $lvl, $class->login(), $class->host(), $channel);
    $class->{adduser_temp}	= 0;
}

sub do_level
{
    my ($class)        = shift;
    $nick        = shift;

    my $i;
    my %user;

    $ret = "";

    unless ( defined($arg[0]) )
    {
       $arg[0]	= $class->nick();
    }

    foreach my $nick (@arg) # crée dans &on_cmd
    {
        if ($nick ne "")
        {
            %user        = %{$class->{_channel}->do_level($nick)};
            if ( defined($class->{_channel}->{ret}) )
            {
                foreach my $tmp (@{$class->{_channel}->{ret}})
                {
                    %user        = %{$tmp};
                    $user{lvl}        = 0 unless (defined($user{lvl} ) );
                    $class->send_privmsg( "%s est : %s!%s@%s d'un Level %s valide sur '%s' \n",
                             $nick, $user{'nick'}, $user{'login'}, $user{'host'},$user{'lvl'}, $user{'channel'}
                     );
                }
            }
            else
            {
               $class->send_privmsg("User '%s' inconnu", $nick);
            }
        }
    }
}

sub do_listuser
{
    my ($class)        = shift;
    $class->{_channel}->get_list_user( shift );
}




########################################################################
# LOG
########################################################################

sub do_log2
{
    my $class	= shift;
    my $arg	= shift || "info";
    my $message	= shift || "log option for channel";
    my $default	= shift || "PRIVMSG";
    my $status	= shift || "info";
    my $all	= shift || "all";
    my $sep	= shift || '#';
    my $fh;
    my $channel	= "";
    my $opt	= "";
    my $type	= "";
    my $var	= "";
    my $start_date	= "de du depuis from";
    my $end_date	= "à au";
    my $deb	= "";
    my $end	= "";
    my $flag	= 0;
    my $timeval	= 0;
    my $sleep	= 1;
    my %info	= ();
    my @niol	= ();
    my @p	= ();

    #my @nia        = split(/$sep/, $arg, 99999);
    $class->log_date_reset();

    #if ( @p = @{$class->do_parser( $class->to() . " $arg", 'normal', $sep, "plus", "0" )} )# j'inclue le channel courant pour faciliter la gestion avec do_parse
    $class->do_parser( $class->to() . " $arg", 'normal', $sep, "plus", "0" );# j'inclue le channel courant pour faciliter la gestion avec do_parse
    if ( $#{$class->{parse_mode_array}} < 0 )
    {
        $class->parse_mode_add("info", $class->to(), "plus");
    }
        #$class->parse_mode( \@p, "o" );
        @p = @{$class->{parse_mode_array}};
        foreach my $tmp (@p)
        {
            $channel	= $tmp->[0];
            $type	= $tmp->[1];
            $opt	= $tmp->[2];
            if ($type eq "moins")	{ $type = "-"; }
            if ($type eq "plus")	{ $type = "+"; }
            #printf(" do_log2: '%s', '%s', '%s'\n", $channel, $type, $opt  );

            #                 1        2      3       4       5       6
            $class->log_date($opt, $flag);
                if ($opt eq "all" && $type eq "-")
                {
                    $class->log_option($channel, $opt, "raz");
                }
                elsif ($opt eq "info")
                {
                    $info{$channel}	= 1; #$class->log_option($channel);
                }
                else
                {
                    $class->log_option($channel, $opt, $type);
                }
        }

        foreach my $tmp (keys %info)
        {
            $class->send_msg( sprintf("$message, on '%s' option actived this : '%s'", $tmp, $class->log_option($tmp)));
        }

        #if ( 0 || defined($class->{log_date}->[0]) && defined($class->{log_date}->[1]) )
        if ( $class->{log_date_nio} > 0 )
        {
            $class->send_privmsg( sprintf("Pensez à utiliser %sSTOP pour stoper l'affichage qui suit :\n", $class->{on_cmd}->{prefix_msg}) );
            my @toto	= ($channel	=~ /\#(.*)$/);
            if (open($fh, $class->{cfg}->get("/log/directory_temp") . "/log_" . $toto[0] . ".log") )
            # 20100723 if (open($fh, "/mnt/tmp/log_" . $toto[0] . ".log") )
            #if (open($fh, "/mnt/tmp/log_" . $1 . ".log") )
            #if (open($fh, $class->{self}->{log_file} . $class->to() . ".log") )
            {
                $class->date_var_raz();
                $deb	= $class->log_date_ts(1);
                $class->date_var_raz();
                $end	= $class->log_date_ts(2);
                if (1)
                {

                printf("
***********************************************************************
sur channel	= %s / %s
Jour de dépard : %s
Heure de dépard : %s
Find Jour : %s
Fin Heure : %s
***********************************************************************
",
   $channel,
   $toto[0],
   $class->{log_date}->[1]->{date},
   $class->{log_date}->[1]->{time},
   $class->{log_date}->[2]->{date},
   $class->{log_date}->[2]->{time}
);
                }
                while( !eof($fh) )
                {
                     $_	= $class->fgets( $fh );

                     if (/^\((.*)\) <.*$/)
                     {
                         if ($1 =~ /^ *(\d*)\/ *(\d*)\/(\d*): *(\d*): *(\d*): *(\d*)$/)
                         {
                             $timeval	= $class->date_ts("$1/$2/$3", "$4:$5:$6");
                             if ( 
                                  $timeval >= $deb && $timeval <= $end
                                )
                             {
                                 printf("%s\n", $_);
                                 $class->send2($sleep, $class->nick(), "notice", sprintf("%s\n", $_));
                                 $sleep ++;
                             }
                         }
                     }
                }
            }
            else
            {
                $class->send_privmsg(sprintf("Log error or no disponible (sorry) '%s'\n",
                                             $class->{self}->{log_file} . $class->to() . ".log"));
            }
        }
    $class->debug(99, sprintf("ii: &do_log arg: %s\n", $arg));
}

sub log_date_reset
{
    my $class	= shift;

    $class->{log_date_nio}	= 0; # permet de savoir, si != 0, si des dates ont été enregistrées.
    $class->{log_date}	= undef;
    $class->{log_date_flag}->[3]	= 1;
    $class->{log_date_flag}->[4]	= 1;
    $hour = $min = $sec = $mday = $mon = $year = 0;
    # Ici je mets par defaut les heures de début et fin.
    $class->date(); # je demande la date du jour dans le cas où un des paramètres, des dates, serait manquant!
    $class->find_date_add();
    $class->find_time_add();
    $class->log_date_add_date( 1 );
    $class->log_date_add_time( 1 );
    $class->log_date_add_date( 2 );
    $class->log_date_add_time( 2 );
}

sub log_date
{
    my $class	= shift;
    my $opt	= shift;
    my $var	= shift || 0;

    my $ret	= 0;

    # Ce système est mauvais, il devrait changer (de 0 à 1) uniquement
    # s'il retrouve une deuxième fois (et plus avec $date/$time +00)
    # bascule sur le créno suivant.
    my $date	= $class->{log_date_flag}->[3]; # Je prends la position actuelle de la date.
    my $time	= $class->{log_date_flag}->[4]; # Je prends la position actuelle de la time.

    printf("OPT: '%s' ", $opt);
    if ( $ret = $class->find_date( $opt ) )
    {
        #if ($date > $time) { $time = $date; }
        $class->{log_date_nio}++;
        $class->log_date_add_date( $date );
        printf(" est une date\n");
    }
    elsif ( $ret = $class->find_time( $opt ) )
    {
        #if ($time > $date) { $date = $time; }
        $class->{log_date_nio}++;
        $class->log_date_add_time( $time );
        printf(" est une time\n");
        $time ++;
        $date	= $time;
    }

    $class->{log_date_flag}->[3]	= $date;
    $class->{log_date_flag}->[4]	= $time;

    return( $ret );
}

sub log_date_add_date
{
    my $class	= shift;
    my $var	= shift || 1;
        $class->{log_date}->[$var]->{mday}	= $class->{log_date}->[0]->{mday};
        $class->{log_date}->[$var]->{mon}	= $class->{log_date}->[0]->{mon};
        $class->{log_date}->[$var]->{year}	= $class->{log_date}->[0]->{year};
        $class->{log_date}->[$var]->{date}	= $class->{log_date}->[0]->{date};
}

sub log_date_add_time
{
    my $class	= shift;
    my $var	= shift || 1;
        $class->{log_date}->[$var]->{hour}	= $class->{log_date}->[0]->{hour};
        $class->{log_date}->[$var]->{min}	= $class->{log_date}->[0]->{min};
        $class->{log_date}->[$var]->{sec}	= $class->{log_date}->[0]->{sec};
        $class->{log_date}->[$var]->{time}	= $class->{log_date}->[0]->{time};
}

# Calcule le timeval, la date en seconds depuis l'an 1/1/0001
sub log_date_ts
{
    my $class	= shift;
    my $var	= shift || 0;
    my $ret	= "";

    printf("&log_date_ts '%s'\n", $class->{log_date}->[$var]->{time});
    $ret	= $class->date_ts($class->{log_date}->[$var]->{date}, $class->{log_date}->[$var]->{time});
    #$class->{log_date}->[$var]->{ts}	= $ret;
    printf("CIME: '%s'\n", $ret);
    return( $ret );
}

sub do_log
{
    my $class	= shift;
    #my $arg	= shift;
    my $message	= shift || "Info channel(s)";
    my $default	= shift || "PRIVMSG";
    my $status	= shift || "info";
    my $all	= shift || "all";
    my $sep	= shift || '#';
    my $channel	= "";
    my $var	= "";
    my $opt	= 0;
    my @niol	= ();
    my @info	= ();

    my @nia        = split(/$sep/, $arg, 99999);

    $class->debug(99, sprintf(" &do_log arg: %s, nia: %s\n", $arg, $#nia));
    foreach my $tmp (@nia)
    {
       @niol        = split(/ /, $tmp, 9999);
       if (defined($niol[0]))
       {
          if ($niol[0] ne "")
          {
             $channel        = lc( $sep . shift(@niol) );
             unless ( defined( $class->log_option($channel))) #$class->{self}->{log}->{$channel}->{option}) )
                { $class->log_option($channel, "");} #class->{self}->{log}->{$channel}->{option} = ""; }
             #printf( "PRIVMSG :%s\n", $channel?$channel:"" ); # Value default

             # Je trie les option à ajouter ou enlever.
             foreach my $top (@niol)
             {
                if ($top ne "")
                {
                   #printf("  INFO: %s\n", $top);
                   if ($top =~ /$status/i)
                   {
                      push @info, $channel;
                      #printf("  INFO1: %s\n", $#info );
                   }
                   else
                   {

                   if ($top =~ /^\-(.*)$/) # Je supprime une option
                   {
                      #printf("  INFO2: %s\n", $1);
                      $var = $1;
                      if ($var =~ /$all/i)
                      {
                         #$class->{self}->{log}->{$channel}->{option} = "";
                         $class->log_option($channel, "");
                      }
                      else
                      {
                         #$class->{self}->{log}->{$channel}->{option} =~ s/ $var//g;
                         $class->log_option($channel, $var, "-");
                      }
                   }
                   elsif ($top =~ /^(.*)$/) # J'ajoute
                   {
                      #printf("  INFO3: %s\n", $1);
                      $var = $1;
                      # Jé vérifie avant d'ajouter l'option.
                      if ( !($class->log_option_cmp($channel, $var)) ) #$class->{self}->{log}->{$channel}->{option} =~ /$var/i) )
                      {
                         #$class->{self}->{log}->{$channel}->{option} .= " " . $var;
                         $class->log_option($channel, " " . $var, "+");
                         #printf("  OPTION: %s\n", $top);
                      }
                      else
                      {
                      }
                   }
                   }
                   $opt++;
                }
             }

             # Si pas d'option alors atribution d'une par défaut.
             if ( !$opt)
             {
                 $class->{self}->{log}->{$channel}->{option} = " " . $sep; # Value default
             }

             $opt = 0;
             $class->debug(99, sprintf("i: Parser:  Option actuelles: %s\n", $class->{self}->{log}->{$channel}->{option}) );
          }
       }
    }

    if ($#info >= 0)
    {
       $var = "";
       foreach my $tmp (@info)
       {
          if ($var ne "") { $var .= ", "; }
          $var .= $tmp . ": " . $class->{self}->{log}->{$tmp}->{option};
       }
       $class->send_msg( "$message -> ". $var );
    }
    else
    {
       $class->send_msg( "$message -> log no active" );
    }
}



########################################################################
# MODE change
########################################################################

sub do_op
{
    my ($class)        = shift;
    my $mode        = "";
    my @p        = ();

    if ( @p = @{$class->do_parser( $class->to() . " $arg" )} )# j'inclue le channel courant pour faciliter la gestion avec do_parse
    {
        $class->parse_mode( \@p, "o" );
    }
}

sub do_deop
{
    my ($class)		= shift;
    my $mode		= "";
    my @p		= ();

    $tmp        = $class->do_parser( $class->to() . " $arg", 'normal', "\#", "moins" );
    if ( @p = @{$tmp} )# j'inclue le channel courant pour faciliter la gestion avec dio_parse
    {
        $class->parse_mode( \@p, "o", "-" );
    }
}

sub do_ban
{
    my ($class)		= shift;
    my $mode		= "";
    my @p		= ();

    $tmp        = $class->do_parser( $class->to() . " $arg", 'normal', "\#", "plus" );
    if ( @p = @{$tmp} )# j'inclue le channel courant pour faciliter la gestion avec dio_parse
    {
        $class->parse_mode( \@p, "b", "+" );
    }
}

sub do_topic
{
    my ($class)		= shift;
    my $arg		= shift || "";

    #$channel		= $class->to();
    my $topic		= "";

    if ($arg[0] =~ /(#\S+)/)
    {
        $channel        = $1;
        shift( @arg );
        $arg                = join(" ", @arg);
        #printf("JOSEMANS: '%s'\n'", $arg);
    }
    else
    {
        $channel        = $class->to();
    }

    $topic        = $arg;

    if ($channel ne "" && $topic ne ""  )
    {
        $class->send("TOPIC $channel :$topic\n");
    }
    else
    {
        if (defined($class->{_channel}->topic( $channel )) && $topic eq "" )
        {
            $class->send_msg("Le topic de ce channel est :" . $class->{_channel}->topic( $channel ) . " mais tu t'en doutais...\n" );
        }
    }

    return();
    if ($arg =~ /(#\S+) (.*)$/ )
    {
       $channel        = $1;
       $topic        = $2;
    }
    elsif($arg =~ /(\#\S+)$/)
    {
       $channel        = $1;
       #$topic        = $arg;
    }

    $class->debug(99, sprintf("I: do_topic  '%s', '%s', ", $channel, $topic) );
    if ($channel ne "" && $topic ne ""  )
    {
       $class->send("TOPIC $channel :$topic\n");
       #$class->debug(59, "i: do_topic SET %s, %s", $channel, $topic );
    }
    else
    {
       if ($topic eq "")
       {
           $class->send_msg("Le topic de ce channel est :" . $class->{_channel}->topic( $channel ) . " mais tu t'en doutais...\n" );
       }
       $class->debug(59, sprintf("I: do_topic ACTUAL %s, %s", $class->to( ), $class->{_channel}->topic($class->to() )) );
    }
    # ne renvoit pas le bon topic mais juste le nom du channel
    #  "   "  ni pour : topic "new topic" en public
}

# do_kick("nick raison", "kick");
# do_kick("ni* raison", "kick");  <!> Devient un masskick.
# do_kick("nick nick2 ni* ...", "masskick");
# <!> reste plus qu'an gérer la RAISON, genre /.*:(raison)$/
sub do_kick
{
    my $class		= shift;
    my $list		= shift;
    my $type		= shift || "kick";

    my $raison		= "";
    #my $raison		= shift;
    my @list		= ();
    my @p		= ();
    my $i		= 0;

    $channel	= $class->check_channel( $list );

    if (0 || $type eq "masskick")
    {
#    &do_parse(\@list, pattern="", sep=\#, "moins|plus" , "normal | limited");
        if ( @list = @{$class->do_parser( $channel . " $list", "limited", "\#", "plus" )} )# j'inclue le channel courant pour faciliter la gestion avec do_parse
        {
            do
            {
                @p = @{$list[$i]};
                if ( lc($p[2]) ne lc($class->{self}->current_nick()) )
                {
                    if ($p[0] ne "" )
                    {
                        if ($p[1] eq "plus")
                        {
                            if (defined($class->{kick_raison}) )
                            {
                                $class->kick( $p[0], $p[2], $class->{kick_raison} . " (". $class->nick().")" );
                            }
                            else
                            {
                                if ($type eq "masskick")
                                {
                                    $class->kick( $p[0], $p[2], "(**MASSKICK**) From ". $class->nick() );
                                }
                                else
                                {
                                    $class->kick( $p[0], $p[2], "From ". $class->nick() ." :". $class->{kick_raison} );
                                }
                            }
                        }
                    }
                }
                $i++;
            }
            while ( $i <= $#list );
        }
    }
    else
    {
        ($nick	, $class->{kick_raison})	= split(/ /, $list, 2);
        if ( $#{$class->match( split(/ /, $nick, 9999))}  > 0)
        {
            $class->do_kick($list, "masskick");
        }
        else
        {
            $class->kick($channel, $nick, $class->{kick_raison});
        }
    }

    $class->{kick_raison}	= "";
}


########################################################################
## STAT
########################################################################

sub stat
{
    my $class	= shift;

    my $var	= shift;

    $var	=~ s/[\!\?\-\+\(\)\_\|\`\[\]\{\}\#\~\&\=\£\$\^\š\µ\*\%\§\:\/\;\.\,\>\<\²\@\\\"\'\€\°]//g;
    my @nia	= split(/ /, $var, -1);

    foreach my $tmp (@nia)
    {
        if (defined( $class->stat_add($tmp, "get")))
        {
            $class->stat_add($tmp, "++");
        }
        else
        {
            $class->stat_add($tmp, "1");
        }
    }

}

sub stat_add
{
    my $class	= shift;
    my $word	= shift;
    my $opt	= shift;
    my $ret	= undef;

    if ($opt eq "++")
    {
        # Je rajoute 1 au mot "word"
        #printf("ADD: %s =+ '%s'\n", $word, $opt);
        $ret	= $class->{stat}->{list_word}->{$word}++;
    }
    elsif($opt eq "hash")
    {
        # Je renvoit la référence du hash des mots...
        $ret	= $class->{stat}->{list_word};
    }
    elsif($opt eq "get")
    {
        # Je renvoit le nombre de fois où j'ai rencontré le mot ; nombre de prononciations
        $ret	= $class->{stat}->{list_word}->{$word};
    }
    elsif($opt =~ /^\+(\d+)$/)
    {
        $class->{stat}->{list_word}->{$word}  += $opt;
        $ret	= $class->{stat}->{list_word}->{$word};
    }
    else
    {
            #printf("ADD: '%s' == '%s'\n", $word, $opt);
        # J'ajoute le mots dans la base avec un numéro (contenu dans $opt).
        $ret	= $class->{stat}->{list_word}->{$word}	= $opt;
    }

    return( $ret );
}

sub stat_write
{
    my $class	= shift;
    my $file	= shift || $class->{stat}->{file};
    my $opt	= shift; # ne sert pas encore....

    my $fh;
    if ( open( $fh, ">" . "$file") )
    {
        $class->debug(30, "STAT: Open Write file '$file' optionq: '$opt'\n");
        foreach my $tmp (keys %{$class->stat_add("", "hash")} )
        {
             printf $fh ("\$%s	= '%s';\n", $tmp, $class->stat_add($tmp, "get"));
             #printf $fh ("%s %s\n", $class->stat_add($tmp, "get"), $tmp);
        }

        close( $fh );
    }
    else
    {
        printf("Error open write file '%s\n", $file);
    }
}

sub stat_read
{
    my $class	= shift;
    my $file	= shift || $class->{stat}->{file};
    my $opt	= shift || "";

    my $fh        ;

    if ( open( $fh, "$file") )
    {
        $class->debug(30, "STAT: Open Read file '$file' optionq: '$opt'\n");
        if ($opt ne "append")
        {
            $class->{stat}->{list_word}	= {};
        }
        RETz: while ( !eof( $fh) )
        {
            $_	= $class->fgets( $fh );
            s/\t//g;
            if (/^\$*(.*) *\= *\'(.*)\';$/)
            {
	        #printf("ADD: '%s' => '%s'\n", $1, $2);
                if ($opt eq "append")
                {
                    $class->stat_add($1, "+".$2);
                }
                else
                {
                    $class->stat_add($1, $2);
                }
            }
        }
    }
    else
    {
        $class->debug(1, sprintf("Error open read file '%s'\n", $file) );
    }
}

sub do_stat
{
    my $class	= shift;
    my $old	= 0;
    my %nia	= ();
    my $key	= "";
    my $val	= "";
    my $value	= "";
    my $nb_word	= 43;

    if ($arg[0] eq "append" && $class->lvl() >= 150)
    {
        $class->stat_read($arg[1], $arg[0]);
        $class->stat_write("test_stat.txt", $arg[0]);
    }
    else
    {
        # Version qui limite à $nb_word...
        #for (my $i=0; $i < $nb_word; $i++)
        foreach my $top (keys %{$class->stat_add("", "hash")})
        {
            RETc: foreach my $tmp (keys %{$class->stat_add("", "hash")} )
            {
                 $val	= $class->stat_add($tmp, "get");
                 if ( defined($nia{$tmp}) && $nia{$tmp} < $val )
                 {
                     $nia{$tmp}	= $val;
                printf("- %4s %s\n", $tmp, $val);
                     last RETc;
                 }
                 elsif ($val > $old && !defined($nia{$tmp}) ) # je stock le plus grand
                 {
                     $key	= $tmp;
                     $value	= $val;
                     $old	= $val;
                 }
            }
    
            $old	= 0;

            if ($key ne "")
            {
                #$nia{$key}	= $value;
                #printf("%4s %s\n", $value, $key);
            }
            $key	= "";
            $value	= "";
        }
        printf("Les '%s' mots les plus utilisés sont (par ordre d'utilisation) :", $nb_word);
        foreach my $tmp (keys %nia)
        {
            printf("%4s %s ", $nia{$tmp}, $tmp);
        }
    }
}


########################################################################
## DICO
########################################################################

sub dico
{
    my $class	= shift;
    my $cmd	= shift || "";
    my $arg	= $class->clear_shell(shift);

    my $ret		= "";
    my $message		= "Les mots trouvés sont : ";
    my $message_len	= length( $message);
    my $len		= 0;
    my $str		= length($message); # le $message compte dans le PRIVMSG! Donc faut le prendre en compte!!
    my $seek		= 0;
    my $line		= 0;
    my $position	= 0;
    my @msg		= ();
    my $dico		= $class->{dico};

    if ( defined($dico->{obj}->{$cmd}) && ($ret = &{$dico->{obj}->{$cmd}}($dico, $arg)) ne ""  )
    #if ( ($ret = &{$dico->{obj}->{$cmd}}($dico, $arg)) ne ""  )
    {
        foreach my $tmp (@{$dico->{found_array}})
        {
            $len	= length( $tmp );
            if ( ($len + $str) <= $class->cfg("get", "/MAX_IRC") )
            {
                $position++;
                $str	+= $len;
                push @msg, $tmp;
            }
            else
            {
                if ($line >= 4)
                {
                    #$class->send_privmsg("Trop de mots trouvés, impossible de continuer à vous les envoyer par IRC...");
                    push @msg, $class;
                    push @msg, "Trop de mots trouvés, impossible de continuer à vous les envoyer par IRC...";
                    last;
                }
                else
                {
                    #$class->send_privmsg( sprintf("'%s:%s' %s %s", $seek, $position, $message, join (", ", @{$dico->{found}}[$seek..$position])) );
                    #$class->send_privmsg( sprintf("'%s:%s' %s %s", $seek, $position, $message, join (", ", @{$dico->{found}}[$seek..$position])) );
                    push @msg, $class; # délimiteur de ligne PRIVMSG supplémentaire.
                    #push @msg, sprintf("'%s:%s' %s %s", $seek, $position, $message, join (", ", @{$dico->{found}}[$seek..$position]));
                }
                $str	= length($message);
                $seek	= $position;
                $line	++;
            }
        }

        push @msg, $class; # on ajoute la Class afin d'envoyer, sinon ca part pas...
        $position	= 0;
        $seek		= 0;
        foreach my $msg (@msg)
        {
            if ($msg eq $class)
            {
                $position --; # on enlève le $class :) pour pas qu'elle s'affiche!
                $class->send_privmsg( sprintf("%s %s", $message, join (", ", @msg[$seek..$position])) );
                $position++;
                $seek	= $position + 1;
            }
            $position++;
        }
    }
}

########################################################################
## MISC
########################################################################

# Cette commande est censée éviter les exploit lorsque
# le bot utilisera &open/&system...
sub clear_shell
{
    my $class	= shift;
    my $var	= shift || "";

    $var	=~ s/\!//g;
    $var	=~ s/\`//g;
    $var	=~ s/\$//g;
    $var	=~ s/\]//g; # pas besoins du [ ...
    $var	=~ s/\)//g; # pas besoins du ( ...
    $var	=~ s/\&//g;
    $var	=~ s/\#//g;
    $var	=~ s/\\//g;

    return( $var );
}

sub date_test
{
    my $class	= shift;
    my $date	= shift;
    my $time	= shift;
    my $timeval	= $class->date_ts( $date, $time );
    printf("Test Date: '%s', '%s'\n", $date, $timeval);
}

sub date
{
    my $class	= shift;
    my $date	= shift || time();
    my $opt		= shift || "normal";

    my @DoW;
    my @MoY;
    my @Mon;
    my $nsec	= 0;
    my $nday	= 0;
    my $aprim	= 0; # A'

    if ($opt eq "normal")
    {
        ($sec,$min,$hour, $mday, $mon, $year, $wday) = localtime($date);
    }
    else
    {
    }
    @DoW = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
    @MoY = ('Jan','Feb','Mar','Apr','May','Jun',
            'Jul','Aug','Sep','Oct','Nov','Dec');
    @DoW = ('Dim','Lun','Mar','Mer','Jeu','Ven','Sam');
    @MoY = ('Jan','Fév','Mar','Avr','Mai','Juin',
            'Jui','Aout','Sep','Oct', 'Nov','Dec');
    @Mon = ('31','28','31','30','31','30',
            '31','31','30','31', '30','31');

    $lday	= $DoW[$mday];

    if ($opt eq "normal")
    {
        $lmon	= $MoY[$mon];
        $mon++;
        $year	+= 1900;
        $mday	= "0000".$mday;
        $mon	= "0000".$mon;
        $hour	= "0000".$hour;
        $min	= "0000".$min;
        $date        = sprintf("%0.2d/%0.2d/%0.4d à %0.2d:%0.2d", 
                               $mday,
                               $mon,
                               $year,
                               $hour,
                               $min,
                               );
    }
    else
    {
        use integer;
        $aprim	= $year / 4;
        $aprim	=~ /^(\d+)(\.*)(.*)$/;
        $aprim	= $1;
        if ($3 eq "")
        {
            #printf("Année bisextielle\n");
            $nday	+= 1;
        }
        else
        {
            #printf("Année normale\n");
        }

        no integer;
        #printf("Nombre de jours à ajouter ; ca vient des années bissextille '%s'\n", $1);
        for(my $i=0; $i < $mon-1; $i++)
        {
            $nday += $Mon[$i];
        }
        # on ajoute le nombre de jours + celui du mois courant
        $nday += ($year * 1461 / 4) + $mday;
        #printf("Nombre de jours Total '%s'\n", $nday);
        $nsec	+= $nday * (24 * 3600);
        $nsec	+= $hour*3600 + $min*60 + $sec;
        
        $date	= $nsec;
        #printf("Nombre de seconds depuis l'an 0 (...)  '%s'\n", $nsec);
    }
    return ( $date );
}

sub date_ts
{
    my $class	= shift;
    my $date	= shift;
    my $time	= shift;

    my $ret	= "";

    #printf("&date_ts()\n");
    #$class->date_var_raz();
    if ($class->find_date($date) && $class->find_time($time) )
    {
        $ret = $class->date("", "timeval");
    }
    else
    {
        $ret = $class->date(); # date/time of the day
    }

    return($ret);
}

sub date_var_raz
{
    $hour = $min = $sec = $mday = $mon = $year = 0;
}

sub find_date
{
    my $class	= shift;
    my $opt	= shift || "";

    my $ret	= 0;
    #printf("find_date: $opt\n");

            if ($opt =~ /^ *(\d+)\/* *(\d+)\/*(\d*)$/)
            {
                # si $* pas définit alors on prnes les param précédent (pas vérifié!)
                $mday	= $1 || $mday;
                $mon	= $2 || $mon;
                $year	= $3 || $year;
                #printf("TEMP DATE: '%s\\%s\\%s'\n", $mday, $mon, $year);
                $ret	= 1;
            }
                $class->find_date_add();
    return( $ret );
}

sub find_time
{
    my $class	= shift;
    my $opt	= shift || "";

    my $ret	= 0;

    #printf("find_time: $opt\n");

            if ($opt =~ /^(\d+):(\d+):*(\d*)$/)
            {
                $hour	= $1 || "00";
                $min	= $2 || "00";
                $sec	= $3 || "00";
                #printf("TEMP TIME: '%s;%s;%s'\n", $hour, $min, $sec);
                $ret	= 1;
            }
                $class->find_time_add();
    return( $ret );
}

sub find_time_add
{
    my $class	= shift;

    $class->{log_date}->[0]->{hour}	= $hour	|| "00";
    $class->{log_date}->[0]->{min}	= $min	|| "00";
    $class->{log_date}->[0]->{sec}	= $sec	|| "00";
    $class->{log_date}->[0]->{time}	= "$hour:$min:$sec";
}

sub find_date_add
{
    my $class	= shift;

    $class->{log_date}->[0]->{mday}	= $mday	|| "01" ;
    $class->{log_date}->[0]->{mon}	= $mon	|| "01";
    $class->{log_date}->[0]->{year}	= $year	|| "01";
    $class->{log_date}->[0]->{date}	= "$mday/$mon/$year";
}

sub check_channel
{
    my $class	= shift;
    my $list	= shift || "";

    my $channel	= "";

    if ($list =~ /^(#\S+).*$/)
    {
        $channel	= $1;
    }
    else
    {
        $channel	= $class->to();
    }

    return( $channel );
}

sub encap
{
    my $class        = shift;

    my $val        = shift || "";

    if (@_)
    {
        $val        = sprintf($val?$val:"", @_);
    }
    $val        =~ s/\&/&amp;/g;
    $val        =~ s/\</&lt;/g;
    $val        =~ s/\>/&gt;/g;
    return( $val );
}

sub de_encap
{
    my $class        = shift;

    my $val        = shift || "";

    if (@_)
    {
        $val        = sprintf($val?$val:"", @_);
    }
    $val        =~ s/&lt;/\</g;
    $val        =~ s/&gt;/\>/g;
    $val        =~ s/&amp;/\&/g;
    return( $val );
}

sub me_chop
{
    my $class	= shift;
    my $var	= shift;
    return(jm_misc::me_chop( $class, $var ) );
}

sub fgets
{
    my $class		= shift;
    my $filehandle	= shift;

    # J'aime pas l'appelle <$fh> dans l'écriture des fonctions
    # alors j'adapte perl.
    return( $class->me_chop($_ = <$filehandle>)  );
}

sub ident
{
    my $class           = shift;
    $var                = shift;
    $var                = $class->from( $var );

    $_ = $var;
    if ( /^~*(\S+)\!~*(\S+)\@(\S+)$/ )
    {
       #$class->debug(0, "MED: ".$var);
       ($nick, $login, $host)   = ($1, $2, $3);
    }
    else
    {
       ($nick, $login, $host)   = ("error", "error", "error");
    }

    $class->nick($nick);
    $class->login($login);
    $class->host($host);

    # On m'envoit un message privé.
    if ( $class->{self}->current_nick() eq $class->to() )
    {
       printf("========> C OK\n");
       $class->to( $nick );
    }

    if (defined($class->{_channel}) )
    {
        $class->{_channel}->nick($nick);
        $class->{_channel}->channel($class->to());
        $class->{_channel}->login($login);
        $class->{_channel}->host($host);
    }
}

sub parse_mode
{
    my $class		= shift;
    my $list		= shift;
    my $m		= shift || "o";
    my $sens		= shift;
    my $max		= 2; # 0 -> 1, 1 -> 2, 3 -> ...

    my @list		= @{$list};
    my @p		= ();
    my %user;
    my $mode		= "";
    my $i		= 0;
    my $o		= 0;

    $var		= "";
    do
    {
        @p = @{$list[$i]};
        $class->debug(99, sprintf("  cmp1: Botname: '%s', Nickparse '%s' and Channel: '%s'", $class->{self}->current_nick(), $p[0], $p[2]));
        if ( lc($p[2]) ne lc($class->{self}->current_nick()) &&
             $class->level($p[0], $p[2]) >= 0
            )
        {
            if ($m eq "b")
            {
                #printf("NOX: %s, %s\n", $p[0], $p[2]);
                %user	= %{$class->get_level_user($p[0], $p[2])};
                $p[2]	= sprintf("*!*%s@*%s", $user{'login'}, $user{'host'}); 
            }

            if ($p[0] ne "" )
            {
                if ($p[1] eq "moins")
                {
                    $mode        .= "-$m";
                }
                else
                {
                    $mode        .= "+$m";
                }
            }
            $var        .= $p[2] . " ";
            if ($o >= $max)
            {
                $class->sendp("MODE %s %s %s\n", $p[0], $mode, $var);
                $var        = "";
                $mode        = "";
                $o        = 0;
            }
            else
            {
                $o++;
            }
        }
        else
        {
            #$o++;
        }

        if ($i >= $#list)
        {
            if ($var ne "") # ca me plait pas, mais bon ca marche :)
            {
                $class->sendp("MODE %s %s %s\n", $p[0], $mode, $var);
            }
        }
        $i++;
    }
        while ( $i <= $#list );
}

# Renvoit le level d'un utilisateur sous forme numérique OU
# toutes les informations connus dans userlist de $from...
# Si pas d'argument, alors elle renvoit le level de
# l'utilisateur précédent. Dans tous les cas elle est lancée
# au début de &on_cmd() et donc elle possède toujours
# les bons réglages de l'utilisateur courant...
# <!> Elle active aussi &get_level_user_channel() qui
#     garde en mémoire tous les niveaux de channel d'un utilisateur;
#
sub level
{
    my ($class)		= shift;

    $ret		= 0;

    if (@_)
    {
        my $to		= shift;
        my $from		= shift || $class->from();
        my $login		= shift || "";
        my $password		= shift || "";

        $ret = 0;
        $class->{lvl}	= 0;

        if (substr($to, 0, 1) ne '#')
        {
            $to        = "private";
        }

        %current_user = %{$class->{_channel}->get_level_user($to, $from, $login, $password)};
        $class->current_user( \%current_user );

        if ( ($ret = $class->get_level_user_channel($to)) > 0 ) # OK sauf $user
        {
            #printf("nickl: %s, ch: %s\n", $from, $to);
            #$ret = $user{'lvl'};
        }
        $class->{lvl}        = $ret;


        $ret	= 0;
        if ($login ne "" && $password ne "")
        {
            $ret	= 1;
        }
    }

    if (!$ret)
    {
        $class->lvl( $class->{lvl} );
        return( $class->{lvl} );
    }
    else
    {
        return( \%current_user );
    }
}

sub current_user
{
    my ($class)		= shift;
    my $var		= shift;

    if (ref($var) eq "HASH")
    {
        $class->{current_user}	= $var;
        return( $var );
    }
    else
    {
        #printf("User: %s\n", ${$class->{current_user}}{$var} );
        return( ${$class->{current_user}}{$var} );

    }
}

########################################################################
## Commandes au format IRCD...
########################################################################

sub send2
{
    my $class		= shift;
    my $sleep  		= shift || 1;;
    my $to		= shift;
    my $type		= shift;
    my $var		= shift;

    my $str		= "";

    if ($type eq "private")
    {
        $str	= sprintf("PRIVMSG %s :%s", $to, $var);
    }
    elsif ($type eq "notice")
    {
        $str	= sprintf("NOTICE %s :%s", $to, $var);
    }
    else
    {
        $str	= sprintf("%s", $var);
    }

    $class->{self}->send_sleep2($sleep, $to, $type, $str);
}

# Send avec 1 seconds de retard.
sub send
{
    my $class		= shift;
    my $valist		= shift;
    if ($valist =~ /^(\d+)$/)
    {
        $class->{self}->send_sleep( $valist, sprintf(shift, @_));
        printf("Avec sleep définie par l'appellant\n");
    }
    else
    {
        $class->{self}->send_sleep( $class->cfg("find", "send_sleep_default"), sprintf($valist, @_) );
        printf("Avec sleep par défaut!!!\n");
    }
}

# Send priority
sub sendp
{
    my $class		= shift;
    my $valist		= shift;

    $class->{self}->send( sprintf($valist, @_) );
}

sub send_msg
{
    my $class		= shift;
    $msg		= shift;
    my $to		= shift || $class->to();
    $class->send( "PRIVMSG %s :%s\n", $to, $msg );
    #printf("---------------> PRIVMSG %s :%s\n", $to, $msg);
}

sub send_privmsg
{
    my $class		= shift;
    $msg		= shift;
    #$class->{self}->send( sprintf("PRIVMSG %s :%s\n", $class->nick(), $msg) );
    if (defined($msg))
    {
       $class->send_msg( sprintf($msg, @_), $class->nick() );
    }
}

sub send_notice
{
    my $class		= shift;
    my $msg		= "";
    my $to		= $class->nick();

    if ($#_ == 1)
    {
        $to		= shift;
    }
    $msg		= shift;

    if (defined($msg))
    {
       $class->send( sprintf("NOTICE %s :%s\n", $to, $msg)  );
    }
}

sub send_action
{
    my $class        = shift;
    $msg        = shift;
    my $to        = shift || $class->to();
    $class->send( sprintf("PRIVMSG %s :\001ACTION %s\001\n", $to, $msg) );
}

sub kick
{
    my $class		= shift;
    my $channel		= shift;
    my $nick		= shift || "";
    my $raison		= shift;

    if ($raison eq "")
    {
        $raison	= sprintf("From: %s", $class->nick() );
    }

    if ($class->{sleep}	)
    {
        $class->send("KIcK %s %s :%s\n", $channel, $nick, $raison );
    }
    else
    {
        $class->sendp("KiCK %s %s :%s\n", $channel, $nick, $raison );
    }
}

sub current_nick
{
    my $class	= shift;
    return( $class->{self}->current_nick( @_ ));
}

# Je vérifie si des options pour le $channel existent.
# Si oui je renvoit 1 sinon 0
sub log
{
    my $class		= shift;
    my $channel		= shift;
    my $ret		= 0;

    #if (defined($class->{self}->{cfg}->{log}->{$channel}) && $class->{self}->{cfg}->{log}->{$channel} ne "" )
    if ( $class->cfg("get", "/log/$_channel") ne "" )
    {
        $ret	= 1;
    }
    return ($ret);
}

# Je paramètre une option sur $channel
# Si pas d'option alors je renvoit le contenu de l'option du $channel
# sans vérifier s'il elle existe!
sub log_option
{
    my $class		= shift;
    my $channel		= shift;
    my $opt		= shift || "";
    my $type		= shift || "";

    my $var		= "";

    if ( $opt ne "" && $class->lvl() >= 125 )
    {
        if ($type eq "-")
        {
            #$class->{self}->{cfg}->{log}->{$channel}->{option} =~ s/ $opt//ig;
            $var	= $class->cfg("get", "/log/$channel");
            $var	=~ s/ $opt//ig;
            $class->cfg("put", "/log/$_channel", $var);
        }
        elsif ($type eq "+")
        {
            #$class->{self}->{cfg}->{log}->{$channel}->{option}	.= " " . $opt;
            $var	= $class->cfg("get", "/log/$channel");
            $var	.= " " . $opt;
            $class->cfg("put", "/log/$_channel", $var);
        }
        else
        {
            #$class->{self}->{cfg}->{log}->{$channel}->{option}	= "";
            $class->cfg("put", "/log/$_channel", "");
        }
    }
    #$ret	= $class->{self}->{cfg}->{log}->{$channel}->{option};
    $ret	= $class->cfg("get", "/log/$_channel");
    if ( !defined($ret) || $ret eq "no")
    {
        $ret	= "no options for this channel";
    }
    return ( $ret );
}

sub log_option_cmp
{
    my $class		= shift;
    my $channel		= shift;
    my $opt		= shift || "";

    my $ret		= 0;

    #if ( $class->{self}->{cfg}->{log}->{$channel}->{option} =~ /$opt/i )
    if ( $class->cfg("get", "/log/$_channel") =~ /$opt/i )
    {
        $ret = 1;
    }
}

########################################################################
## Divers....
########################################################################

sub debug
{
    my ($class)        = shift;
    if ( defined($class->{self})  )
    {
       $class->{self}->debug( @_ );
    }
    else
    {
       shift; # on passe le lvl
       print @_;
       print ("\n");
    }
}

# Découpe nick!login@host
sub from
{
    my ($class) = shift;
    if (@_) { $class->{from}    = shift; }

    ($var, $tmp)        = split(/\@/, $class->{from});
    $class->host ( $tmp );
    ($var, $tmp)        = split(/\!/, $var );
    $class->login( $tmp );

    return( $class->{from} );
}

sub spouf
{
    my ($c)        = shift;
    for ( ;$c != 0; $c--)
    {
        printf("-");
    }
    print(">");
}

sub splash
{
    my ($l)		= shift;
    my $c		= shift;
    my (%m);

         &spouf($c);
    $c++;
    $_ = ref($l);
    if (/HASH/)
    {
       %m = %{$l};
       printf("%d %s\n", $c, \%m );
       foreach my $tmp (keys %m )
       {
          #printf("<> %s\n", $tmp);
          if ( ref( $m{$tmp} ) eq "HASH")
          {
             &splash( $m{$tmp}, $c )
          }
          else
          {
         &spouf($c);
         printf("%d %s => %s\n", $c, $tmp, $m{$tmp} );
          }
       }
    }
    if (/ARRAY/)
    {
       #foreach my $tmp (keys @{$l} )
       #{
       #}
    }
}

sub display_divers
{
    my $class	= shift;
    printf("Nick: %s, Lvl: %s, Pass: %s, Login: %s, Host: %s\n",
           $class->current_user("nick"),
           $class->current_user("lvl"),
           $class->current_user("pass"),
           $class->current_user("login"),
           $class->current_user("host"),
           );
}

sub nick	{ my ($class) = shift; if (@_) { $class->{nick}                = shift; } return( $class->{nick} ); }
sub login	{ my ($class) = shift; if (@_) { $class->{login}        = shift; } return( $class->{login} ); }
sub host	{ my ($class) = shift; if (@_) { $class->{host}                = shift; } return( $class->{host} ); }
sub lvl		{ my ($class) = shift; if (@_) { $class->{lvl}                = shift; } return( $class->{lvl} ); }
sub channel	{ my ($class) = shift; if (@_) { $class->{channel}        = shift; } return( $class->{channel} ); }
sub msg		{ my ($class) = shift; if (@_) { $class->{msg}                = shift; } return( $class->{msg} ); }
sub arg		{ my ($class) = shift; if (@_) { $class->{arg}                = shift; } return( $class->{arg} ); }
sub to		{ my ($class) = shift; if (@_) { $class->{to}                = $_channel = shift; } return( $class->{to} ); }


#############################################################################
## CHANNEL
#############################################################################
sub adduser
{
    my $class        = shift;
    return( $class->{_channel}->adduser( @_ ) );
}

sub get_level_user
{
    my $class        = shift;
    return( $class->{_channel}->get_level_user(@_) );
}

sub get_level_user_channel
{
    my $class        = shift;
    return( $class->{_channel}->get_level_user_channel( @_ ) );
}

sub get_user_channel
{
    my $class        = shift;
    return( $class->{_channel}->get_user_channel( @_ ) );
}

sub channel_speak
{
    my $class        = shift;
    return( $class->{_channel}->channel_speak( @_ ) );
}

sub get_list_channel
{
    my $class        = shift;
    return( $class->{_channel}->get_list_channel2( @_ ) );
}


#############################################################################
## NON utilisees
#############################################################################

sub find_user
{
    my ($class)        = shift;
    my ($list)        = shift;
    RETa: foreach my $tmp (keys %list)
    {
       if ( ($class->host() eq $list{$tmp}{host}) && ($class->login() eq $list{$tmp}{login}))
       {
          return( $tmp );
          last RETa;
       }
    }
}

sub level_old1
{
    my ($class)        = shift;
    my $channel        = shift || "private";
    $ret = 0;

    $class->{lvl}        = 0;

    # Normalement $class->from est deja lance depuis on_msg, on_dcc...
    # Sinon ca marche pas :)
    RETa: foreach my $tmp (keys %list)
    {
       #if ( $from =~ /.*\!.*mans\@gyptis\.org/ ) # OK
       if ($class->host() eq $list{$tmp}{host} ) # && :p
       {
          if ($class->login() eq $list{$tmp}{login} )
          {
             $class->lvl( $list{$tmp}{lvl} );
             $ret = $list{$tmp}{lvl};
             last RETa;
          }
       }
    }
    return( $ret );
}

sub log_user
{
    my ($class)        = shift;
    $class->log( sprintf("From:%s, LVL:%d", $class->from(), $class->lvl()) );
}

sub macro_test
{
    my $class        = shift;
    my $macro        = shift;
    die;
    unless ( $#{$class->{macro}->{list}->{$macro}} >= 0 )
    {
        return(0);
    }
    1;
}

sub log_old1
{
    my ($class)        = shift;
    printf("L: %s\n", join(" ",  @_) );
}

sub find_date3
{
    my $class	= shift;
    my $opt	= shift || "";

    printf("find_date: $opt\n");

    my @time	= ("00", "00", "00");
    my @date	= ("00", "00", "00");

    @time	= split(/:/, $opt, -1);
    @date	= split(/\//, $time[0], -1);

    # Pas de DATE 
    if ($#date == 0 && $#time == 2)
    {
        printf("TOME: %s , %s\n", $#time, $time[0]);
    }
    elsif ($#date >= 0 && $#time == 1)
    {
    }

    printf("__TIME: ");
    foreach my $tmp (@time)
    {
        printf("'%s' ", $tmp);
    }

    printf("\n");
    printf("__DATE: ");
    foreach my $tmp (@date)
    {
        printf("'%s' ", $tmp);
    }
    printf("\n");

        if (0)
        {
            if ($opt =~ /^ *(\d*)\/* *(\d*)\/*(\d*):.*$/)
            {
                $mday	= $1;
                $mon	= $2;
                $year	= $3;
                printf("TEMP DATE: '%s!%s!%s'\n", $mday, $mon, $year);
            }
            if ($opt =~ /^.*:*(\d*):*(\d*):*(\d*)$/)
            {
                $hour	= $1 || "00";
                $min	= $2 || "00";
                $sec	= $3 || "00";
                printf("TEMP TIME: '%s!%s!%s'\n", $hour, $min, $sec);
            }
        }
}

package Macro;
########################################################################
# MACRO
########################################################################

use vars qw($VERSION @ISA @EXPORT 
        @arg $arg $tmp @tmp $var $ret $id $prefix_msg $prefix
        $nom_say $received_by $action $from $add_id $message $finished $created $delete $delete_time
        );

sub new
{
    my $self	= shift;

    my $class        = {};
    bless $class, $self;

    ### OPTIONS ###
    my %opt	= ();
    if ( $#_ >= 1 )
    {
        %opt	= @_;#$opt;
    }
    elsif( ref($_[0]) eq "HASH")
    {
        %opt	= %{$_[0]};
    }
    $class->{opt}		= \%opt;

    $class->{self}		= $class; # use my self default... Mais c pas bien!
    $class->{self}		= $opt{self} if (defined($opt{'self'}));

    # MACRO
    $class->{macro_file}	= "macro.xml"; #$class->{cfg}->{cfg}->{macro}->{file};
    $class->{macro}->{list}	= {};
    $class->{macro}->{list_del}	= {};

    return ( $class );
}

sub macro_run
{
    my $class	= shift;
    my $macro	= shift;
    my $arg	= shift;
    my $msg	= shift;

    my $nick	= $class->{self}->nick();
    my $channel	= $class->{self}->to();
    my @arg	= ();
    my @var	= ();
    my %mbak;
    my $count	= 0;
    my $row		= 0;
    my $macro_id	= -1;

    #die("finir macro(....)      ");
    if ( $macro =~ /^(\S+)\((\d+)\)$/ )
    {
    	$macro		= $1;
    	$macro_id	= $2;
    }

    if ( defined($macro) && $#{$class->{macro}->{list}->{$macro}} >= 0 )
    {
        $class->{self}->{sleep}	= 1;    # Là pour temporiser les kicks/autres commande afin
                                # que les commandes du bot de précèdent pas les macros...
                                # Que le KICK ne passe pas en priorité au SAY lors
                                # d'un enchainement de macro via ';'
        $class->{macro_count}		= 0 unless (defined($class->{macro_count}));

        $class->{macro_seek}->{$macro} ++; # on passe à la macro suivante!
        $class->{macro_seek_name}	= $macro;

        # Je choisi la macro demandé en fonction de son ID. $macro_name(ID)
        if ( $macro_id >= 0)
        {
        	foreach my $tmp (@{$class->{macro}->{list}->{$macro}})
        	{
        		%mbak	= %{$tmp};
        		if ($macro_id == $mbak{'add_id'} )
        		{
        			last;
        		}
        		$count++;
        	}
        	$class->{macro_seek}->{$macro}	= $count;
        }

        # Je remet le seek de la macro demandée à 0 si celui-ci est plus grand
        # que le stock...
        if ( $class->{macro_seek}->{$macro} > $#{$class->{macro}->{list}->{$macro}} )
        {
            $class->{macro_seek}->{$macro}	= 0;
        }

        # Je passe à la macro qui porte le même nom et avec un contenu cencé être différent.
        # et je sauveagrde la macro suivante.
        %mbak	= %{$class->{macro}->{list}->{$macro}->[$class->{macro_seek}->{$macro}]};

        # On garde en mémoire les premiers arguement pour la suite d'execution dans
        # le cas où il y aurait plusieur sous-macro dans la même...
        unless ( defined($class->{macro_arg}) )
        {
            @arg        = split(/ /, $arg, 9999);
            $class->{macro_arg}        = \@arg;
        }
        @arg	= @{$class->{macro_arg}};

        # On commence séparer les sous-macros pour les executer
        # une par une. Elles sont séparées de ';'...
        my @tmp        = split(/\;/, $mbak{'message'}, 9999);

        foreach my $tmp (@tmp)
        {
            $tmp	=~ /^ *(.*)$/;
            @var        = split(/\%s/, $1, 9999);
            #@var        = split(/\%s/, $tmp, 9999);

            $tmp =~ s/\Q\%n/$nick/;
            $tmp =~ s/\Q\%c/$channel/;
            # Je remplace les %s par les arguement ou nick() ...
            if ( $#var == 0)
            {
                $_ = join(" ", @{$class->{macro_arg}});
                $tmp =~ s/\Q\%s/$_/;
            }
            else
            {
                for(my $i = 0; $i <= $#var; $i++)
                {
                    $_        = ${$class->{macro_arg}}[$i]?${$class->{macro_arg}}[$i]:$class->{self}->nick();
                    if ($i == ($#var - 1))
                    {
                        $_ .= " " . join (" ", @{$class->{macro_arg}}[$i+1..$#{$class->{macro_arg}}]);
                        #$_ .= join (" ", @{$class->{macro_arg}}[1..3]);
                    }
                    $tmp =~ s/\Q%s/$_/;
                }
            }

            $var	= $class->{self}->{prefix_msg};
            $tmp	=~ s/^ *(.*)$/$1/g;
            #printf("BLATE: '%s', '%s'\n", $class->{self}->{prefix_msg}, $class->{prefix_msg});
            if ($tmp =~ /^([$var])+(.*)$/)
            {
                #printf("Lala: --> 1: '%s', 2: '%s', '%s', pre: '%s' <--\n", $1, $2, $tmp, $var);
                $class->{macro_count}++;
                $var	= sprintf("%s%s", $1, $2); # avec $1.$2 ca marche pas...
                #printf $var . "\n";
                #if (! $class->{macro}->{list}->{$macro}->[($class->{macro_seek}->{$macro} - 1)]->{sent}
                          #||
                if (      $class->{macro_count} <= 8 )
                {
                    #$class->{macro}->{list}->{$macro}->[($class->{macro_seek}->{$macro} - 1)]->{sent}	= 1;
                    $class->{self}->on_cmd($class->{self}->{self}, $class->{self}->{from}, $channel, $var );
                }
                #$class->{macro}->{list}->{$macro}->[($class->{macro_seek}->{$macro} - 1)]->{sent}	= 0;
                $class->{macro_count}--;
            }
            else
            {
                if ( $mbak{'action'} eq "action")
                {
                    $class->{self}->send_action( sprintf("%s", $tmp)   );
                }
                else
                {
                    $class->{self}->send_msg( sprintf("%s", $tmp)   );
                }
                #printf("%2sMAcro: %s:%s::'%s' -> '%s'\n", $class->{macro_count}, $#arg, $#var, join(" ", @{$class->{macro_arg}}), $tmp);
            }

            $row++;
        }

        if ($class->{macro_count} == 0)
        {
            $class->{macro_arg}        = undef;
            $class->{macro_count}        = undef;
        }
    #$class->{_channel}->splash2( $class->{macro}->{list});
        $class->{self}->{sleep}	= 0;
    }
    else
    {
       printf("macro_run NO DEFINED for macro_name :'%s'   \n", $macro);
    }
}

# $class->macro_add($received_by, $nom_say, $action, $from, $add_id, $message, $finished, $created);
sub macro_add
{
    my $class		= shift;

    my $received_by	= shift;
    my $nom_say		= lc(shift);
    my $action		= lc(shift);
    my $from		= shift;
    my $add_id		= shift;
    my $message		= shift;
    my $finished	= shift;
    my $created		= shift;
    my $delete		= shift;
    my $delete_time	= shift;

    push @{$class->{macro}->{list}->{$nom_say}}, {
					   'nom_say'		=> $nom_say,
					   'received_by'	=> $received_by,
					   'action'		=> $action,
					   'from'		=> $from,
					   'add_id'		=> $add_id,
					   'message'		=> $message,
					   'finished'		=> $finished,
					   'created'		=> $created,
                                           'delete'		=> $delete,
                                           'delete_time'	=> $delete_time
                                          };
    #printf("macro_add: 1:%s 2:%s 3:%s 4:%s 5:%s 6:%s 7:%s 8:%s\n", $nom_say, $received_by, $action,  $from,  $add_id,  $message, $finished,  $created);
}

sub macro_add_del
{
    my $class		= shift;

    if ( $#_ > 0)
    {
    my $received_by	= shift;
    my $nom_say		= lc(shift);
    my $action		= lc(shift);
    my $from		= shift;
    my $add_id		= shift;
    my $message		= shift;
    my $finished	= shift;
    my $created		= shift;
    my $delete		= shift;
    my $delete_time	= shift;

    push @{$class->{macro}->{list_del}->{$nom_say}}, {
					   'nom_say'		=> $nom_say,
					   'received_by'	=> $received_by,
					   'action'		=> $action,
					   'from'		=> $from,
					   'add_id'		=> $add_id,
					   'message'		=> $message,
					   'finished'		=> $finished,
					   'created'		=> $created,
                                           'delete'		=> $delete,
                                           'delete_time'	=> $delete_time
                                          };
    }
    elsif ( ref($_[0]) eq "HASH")
    {
        my $top	= shift;
        push @{$class->{macro}->{list_del}->{$top->{'nom_say'}}}, $top;
    }
}

# Je tag avec 'delete' la macro à effacé, je la copie dans la
# liste des 'list_del' et je l'efface dans la 'list'.
# Renvoit 1 pour dire que c'est effacé.
sub macro_del
{
    my $class	= shift;
    my $top	= shift;
    my $list	= shift;
    my $key	= shift; # name_macro
    my $seek	= shift;
    my $ret	= 0;

    #my $user		= sub { sprintf(".*!.*%s\@%s", $class->{self}->current_user('login'), $class->{self}->current_user('host')); };

    # Replacé par $class->macro_level_commun... if ( $class->{self}->from() =~ /^$user$/ ||$class->{self}->lvl() >= 150)
    if ( $class->macro_level_commun() )
    {
        $top->{'delete'}	= $class->{self}->from();
        $top->{'delete_time'}	= time();
        $class->{self}->debug(99, sprintf("DEL: name: '%s', id:'%s', from: '%s':%s -> \n",
                                  $top->{'nom_say'},
                                  $top->{'add_id'},
                                  $top->{'from'},
                                  $class->{self}->lvl(),
                                  ));
        $class->macro_add_del($top);
        $ret	= 1;
    }
    return( $ret );
}

# Permet de connaitre le proprio de la macro qui vient d'être utilisé
sub do_macro_info
{
    my $class    = shift;
    #my $macro    = shift || "";

    my $list    = $class->{macro}->{list};
    my $top    = "";
    my @var    = ();
    my $i    = 0;
    my $ret    = 0;
    my $count    = 0;

    my $format    = sub { push @var, [$top->{'nom_say'}, $top->{'add_id'} . " => " . $top->{'from'} . " "]; };

    foreach my $macro ( @_)
    {
    if ( defined($macro) && $macro ne "" && $#{$list->{$macro}} >= 0 )
    {
        $count    = $#{$list->{$macro}};
        RETd: for ($i=0 ; $i <= $count; $i++)
        {
            $top    = $list->{$macro}->[$i];
            &$format();
            printf("\nALAL: %s '%s'\n", $#var, $top->{'add_id'} );
        }

        $class->{self}->debug(99, sprintf("MACRO_INFO: name: '%s', id:'%s', from: '%s':%s -> \n",
                                      $top->{'nom_say'},
                                      $top->{'add_id'},
                                      $top->{'from'},
                                      $class->{self}->lvl(),
                                      ));
    } # if de vérif si $macro existe.
    elsif ($macro =~ /^\d+$/)
    {
        foreach my $tmp (keys %{$list})
        {
            foreach $i ( @{$list->{$tmp}})
            {
                if ($i->{'add_id'} eq $macro)
                {
                    $top    = $i;
                    &$format();
                }
            }
        }
    }
    else
    {
        $macro    = $class->{macro_seek_name}?$class->{macro_seek_name}:"";
        if ( defined($macro) && ($macro ne "" && $macro !~ /HASH/) )
        {
            $top    = $list->{$macro}->[$class->{macro_seek}->{$macro}];
            &$format();
        }
    }
    }

    if ($#var >= 0)
    {
        foreach my $tmp (@var)
        {
            $class->{self}->send_privmsg( sprintf("Macro ('%s') par ID => Propriétaire : %s\n", $tmp->[0], $tmp->[1]) );
        }
    }
    else
    {
        $class->{self}->send_privmsg( "Pas de macro utilisée" );
    }

    return( $ret );
}

sub macro_level_commun
{
    my $class	= shift;

    # CE TEST est bidon et n'apporte ce qui est désiré.
    # Il est donc bugué, car il se compare (l'user) à lui-même

    my $user	= sub { sprintf(".*!.*%s\@%s", $class->{self}->current_user('login'), $class->{self}->current_user('host')); };
    my $ret	= 0;

    if ( $class->{self}->from() =~ /^$user$/ ||$class->{self}->lvl() >= 150)
    {
        $ret	= 1;
    }
    return ( $ret );
}

sub do_macro_add
{
    my $class	= shift;

    my $cmd	= shift;
    my $arg	= shift;
    my $msg	= shift;
    my @arg	= @_;

    my @line	= ();
    my $line	= "";
    my $action	= $arg[0];
    my $macro	= $arg[1];
    
    if ($action =~ /(action)|(say)/)
    {
        if (defined($macro) && $macro ne "")
        {
            $class->macro_var_reset();
            $nom_say        = $macro;

            $class->macro_add( $class->{self}->current_nick(), $macro, $action,
                $class->{self}->from(), $class->{macro}->{last_id},
                join(" ", @arg[2..$#arg]), "1", time());

            $tmp	= join(" ", @arg[2..$#arg]);
            $tmp	=~ s/\%/\\\%/g;
            $class->{self}->send_notice( sprintf("Macro '%s' ajoutée et numérotée '%s', son contenu est '%s'",
            	$macro, $class->{macro}->{last_id}, $tmp)  );
            $class->{self}->send_notice( "Merci d'avoir utilisé le bot." );


            $class->{macro}->{last_id}++;
            # on position le seek à la dernière macro arrivée en mémoire...
            $class->{macro_seek}->{$macro}	= $#{$class->{macro}->{list}->{$macro}};
            $class->macro_write_list( $class->{macro_file} );
        }
    }
}

# &del('id', 'number');   Efface la macro qui porte l'id contenu dans "number"
#                         Normalement 1 seul macro est effacée.
# &del('name_macro all'); Efface toutes les macros qui porte le nom "name_macro"
# &del('name_macro', 'id');
#                         Efface toutes les macros dans "macro_name" qui contient
#                         les idN (['id1'], ['id2'], ...
# <!> 'id' peut être le nom d'une macro, normalement tout doit fonctionner.
sub do_macro_del
{
    my $class	= shift;
    my $macro	= shift || "";
    my $val	= shift	|| "";

    my $top	= "";
    my $id	= 0;
    my $seek	= 0;
    my $del	= 0;
    my $by_id	= 0;
    my $ret	= 0;
    my $i	= 0;
    my $count	= 0;

    my $list	= $class->{macro}->{list};

 # existe t-elle ?
 # Si oui, alors il sagit d'un nom et non d'une ID de $macro à traiter.
 if ( $#{$list->{$macro}} >= 0 )
 {
    $class->{macro}->{del}	= ();

    if ($val =~ /^(\d+)$/ || $macro =~ /^(\d+)$/)
    {
        $id	= $1;
        $by_id	= 1;
    }
    elsif ($val eq "all" || $val eq "*")
    {
        $val	= "all";
        # delete ${$class->{macro}->{list}}->{$macro}; !!!!!
        # return();
    }
    elsif ($val eq "")
    {
            if ( $#{$list->{$macro}} == 0)
            {
                # Cas unique où la macro existe, 1 seul fois.
                $seek	= 0;
                # delete ${$class->{macro}->{list}}->{$macro}; !!!
            }
            elsif ( $class->{macro_seek}->{$macro} == 0 )
            {
                # Efface la dernière utilisée OU celle selectionnée par défaut.
                # -> La dernière, du ARRAY, est selectionnées.
                $seek	= $#{$list->{$macro}};
                #splice( @{$class->{macro}->{list}}, $seek, 1); !!!!
            }
            else
            {
                # n'importe laquelle, ARRAY > 0
                $seek	= $class->{macro_seek}->{$macro} - 1 ;
            }
            $ret = $class->macro_del( $list->{$macro}->[$seek], $list, $macro );
            splice( @{$list->{$macro}}, $seek, 1);
            $ret	= 1;
        # delete ${$class->{macro}->{list}}->{$macro}->[$seek]; !!!
        # return();
    }
    else
    {
        $class->{self}->send_privmsg(" Cette façon de demander d'effacer une macro n'est pas gérée, ni même pensée, alors si vous estimé que c'est intérressent merci de le faire savoir à CurIeuX ou CIX !!");
    }

    # If d'effacement
    if ( !$ret && ($#{$list->{$macro}} >= 0 || $id != 0) )
    {
         printf("BITE_VV: %s, %s, %s\n", $macro, $seek, @{$list->{$macro}});
        foreach my $key ( keys %{$list})
        {
            #RETd: foreach my $top ( @{$list->{$key}})
            $count	= $#{$list->{$key}};
            RETd: for ($i=0 ; $i <= $count; $i++)   #$top ( @{$list->{$key}})
            {
                $top	= $list->{$key}->[$i];
                if ($top->{'nom_say'} eq "test")
                {
                    printf("DEL_TREST: %s, id=%s, '%s'->'%s'\n", "rr", $top->{'add_id'}, $tmp, $i);
                }

                if ( $top->{'delete'} eq "" ) 
                {
                    # On efface par ID
                    if ($id != 0 && $id eq $top->{'add_id'} && ($macro eq "id" || $by_id ) )
                    {
                        $del = 1;
                        $class->{self}->debug(99, sprintf("DEL: nameID: '%s', id:'%s', from: '%s'\n",
                                  $top->{'nom_say'},
                                  $top->{'add_id'},
                                  $top->{'from'}
                                  ));
                    }
                    elsif ( $key eq $macro && $val eq "all")
                    {
                        $del = 1;
                        $class->{self}->debug(99, sprintf("DEL: nameAL: '%s', id:'%s', from: '%s'\n",
                                  $top->{'nom_say'},
                                  $top->{'add_id'},
                                  $top->{'from'}
                                  ));
                    }
                    elsif ( $key eq $macro && $id eq $top->{'add_id'} )
                    {
                        $class->{self}->debug(99, sprintf("DEL: namei33: '%s', id:'%s', from: '%s'\n",
                                  $top->{'nom_say'},
                                  $top->{'add_id'},
                                  $top->{'from'}
                                  ));
                        # J'efface $macro qui vient d'être utilisé
                        # ou qui se trouve en position 0
                        $del = 1;
                    }
                    elsif ( 0 && $key eq $macro && ($val eq "" && $by_id == 0) )
                    {
                        # <!> Ne marche pas et ne peut marcher,
                        #     car cette possibilité ne peut que fonctionner
                        # plus haut, avant le foreach principale.

                        # J'efface $macro qui vient d'être utilisé
                        # ou qui se trouve en position 0
                        $del = 1;
                    }

                    if ($del)
                    {
                        $class->{self}->debug(99, sprintf("DEL: nameDE: '%s', id:'%s', from: '%s'\n",
                                  $top->{'nom_say'},
                                  $top->{'add_id'},
                                  $top->{'from'}
                                  ));
                        $del	= 0;
                        $top->{'delete'}	= $class->{self}->from();
                        $top->{'delete_time'}	= time();
                        $ret = $class->macro_del($top, $list, $key);
                        splice( @{$list->{$key}}, $i, 1);
                        $i--;
                        $count--;
                    }
                }
            } # for avec RETd
        } # foreach $key
    } # If d'effacement

    $class->macro_write_list("test.xml");
 }
}

sub macro_write_list
{
    my $class        = shift;
    my $file        = shift;

    my $td        = "";

  if ( defined($class->{macro}->{list}) )
  {
    my $fh;

    if ( open( $fh, ">" . "$file") )
    {
        $td	= $class->{self}->date();
        printf $fh (q@<?xml version="1.0" encoding="ISO-8859-1"?>
<?xml-stylesheet  href="add.xsl" type="text/xsl" ?>
<!-- %s -->

<macro_list last_id='%s'>

@, $td, $class->{macro}->{last_id});

        $class->macro_write_put($fh, $class->{macro}->{list}); # macro active
        printf $fh ("<\!-- Macro deleted -->\n"); #, $#{$class->{macro}->{list_del}} );
        $class->macro_write_put($fh, $class->{macro}->{list_del}); # macro deleted
        printf $fh (q@</macro_list>
@);
    }
    close( $fh );
  }
}

sub macro_read_list
{
    my $class		= shift;
    my $file		= shift;

    my @liste		= ();
    my %list;
    my %liste;
    my $last_id		= 1;
    my $delete		= 0;
    my $format		= "sextium";
    my $vor		= "";
    my $nom		= "";
    my $delete_from	= "";

    my $fh        ;

    if ( open( $fh, "$file") )
    {
        #delete $class->{macro}->{list};
        #delete $class->{macro_seek};
        $class->{macro}->{list}		= {};
        $class->{macro}->{list_del}	= {};
        $class->{macro_seek}		= {};
        $class->{macro_seek_name}	= {};
        $class->macro_var_reset();

        if ($file =~ /^(.*)\.bot$/)
        {
            $format        = "vladbot";
            $class->{macro}->{last_id}        = $class->{self}->fgets( $fh );
        }
        RETz: while ( !eof( $fh) )
        {
            $tmp        = $class->{self}->fgets( $fh );
            if( $format eq "vladbot") # format Vladbot
            {
                if (0)
                {
                    $tmp                = $class->{self}->me_chop( $class->{self}->fgets( $fh ) );
                    $vor                = lc($class->{self}->me_chop( $class->{self}->fgets( $fh ) ));
                    push @{$class->{macro}->{list}->{$vor}}, {
					    'nom_say'		=> $vor,
					    'received_by'	=> $tmp,
					    'action'		=> lc($class->{self}->fgets( $fh )),
					    'from'		=> $class->{self}->fgets( $fh ),
					    'add_id'		=> $class->{self}->fgets( $fh ),
					    'message'		=> $class->{self}->fgets( $fh ),
					    'finished'		=> $class->{self}->fgets( $fh ),
					    'created'		=> $class->{self}->fgets( $fh )
                                          };
                    $class->{macro_seek}->{$vor}        = 0;
                    $class->{macro_seek_name}		= $vor;
                }
                else
                {
                    # $class->macro_add($received_by, $nom_say, $action, $from, $add_id, $message, $finished, $created);
                    #$tmp	= $class->fgets( $fh );
                    $vor	= $class->{self}->fgets( $fh );
                    $class->macro_add(
                          $tmp,
                          $vor, # Nom_say, for macro_seek...
                          $class->{self}->fgets( $fh ),
                          $class->{self}->fgets( $fh ),
                          $class->{self}->fgets( $fh ),
                          $class->{self}->fgets( $fh ),
                          $class->{self}->fgets( $fh ),
                          $class->{self}->fgets( $fh )
                         );
                    $class->{macro_seek}->{$vor}	= 0;
                    $class->{macro_seek_name}		= $vor;
                #$class->{macro_seek}->{$nom_say}        = 0;
                    while (1 && !(<$fh> =~ /\001/)  )
                    {
                         # Skip the newline and three reserved fields
                    }
                }
            }
            elsif($format eq "sextium") # Format XML
            {
                if ( $last_id && $tmp =~ /<macro_list *last_id='(.*)'>/)
                {
                    $class->{macro}->{last_id}        = $1;
                    $last_id        = 0;
                }

                #$_ = $class->fgets( $fh );
                #printf("RELAIS: %s,\n", $tmp);
                if ( $tmp =~ /<macro *date='(.*)'>/)
                {
                    $created        = $1; # Time
                RETm: while (  1  && !eof( $fh) )
                {
                    $tmp	= $class->{self}->fgets( $fh ); # beurk :)
                    $_		= $tmp;

                    if    (/<nom>(.*)<\/nom>/)
                    {
                           $nom_say	= $1;
                    }
                    elsif (/<type>(.*)<\/type>$/)
                    {
                           $action	= $1;
                    }
                    elsif (/<from>(.*)<\/from>/)
                    {
                           if (!$delete)
                           {
                              $from	= $1;
                           }
                           elsif ($delete) # je veux prendre NOM ou DELETE et rien d'autre
                           {
                              $delete_from= $1;
                           }
                    }
                    elsif (/<add_id>(.*)<\/add_id>/)
                    {
                           $add_id	= $1;
                    }
                    elsif (/<message>(.*)<\/message>/)
                    {
                           $message	= $1;
                    }
                    elsif (/<received_by>(.*)<\/received_by>/)
                    {
                           $received_by	= $1;
                    }
                    elsif (/<finish>(.*)<\/finish>/)
                    {
                           $finished	= $1;
                    }
                    elsif (/<created>(.*)<\/created>/)
                    {
                           #$created	= $1;
                    }
                    elsif (/<delete>/)
                    {
                           $delete	= 1;
                    }
                    elsif (/<\/delete>/)
                    {
                           $delete	= 0;
                    }
                    elsif (/<time>(.*)<\/time>/)
                    {
                           $delete_time	= $1;
                    }
                    elsif (/<\/macro>/)
                    {
                       last RETm;
                    }
                #printf("DATE: %s\n", $tmp);
                }

                if ( $delete_from eq "")
                {
                    $class->macro_add( $received_by,
                                   $class->{self}->de_encap($nom_say),
                                   $class->{self}->de_encap($action),
                                   $class->{self}->de_encap($from),
                                   $add_id,
                                   $class->{self}->de_encap($message),
                                   $finished, $created,
                                   $delete_from,
                                   $delete_time);
                    $class->{macro_seek}->{$nom_say}	= 0;
                }
                else
                {
                    $class->macro_add_del( $received_by,
                                   $class->{self}->de_encap($nom_say),
                                   $class->{self}->de_encap($action),
                                   $class->{self}->de_encap($from),
                                   $add_id,
                                   $class->{self}->de_encap($message),
                                   $finished, $created,
                                   $delete_from,
                                   $delete_time);
                    $class->{macro_seek}->{$nom_say}	= 0;
                }
                $class->macro_var_reset();
                $delete_from	= "";
                $delete_time	= "";
                $delete		= 0;
                }
            }
            
            if ( $format eq "sextium" )
            {
                #if (!$last_id && $class->fgets( $fh ) =~ /<\/macro_list>/)
                if (!$last_id && $tmp =~ /<\/macro_list>/)
                {
                    last RETz;
                }
            }
        }
        close($fh );
    }
    else
    {
        $class->{self}->debug(1, "Erreur d'e lecture pour le fichier : ".$file);
    }

    #$class->{macro}->{list}        = \%liste;
    return( \@liste, $class->{macro} );
}

sub macro_write_put
{
    my $class	= shift;
    my $fh	= shift;
    my $list	= shift;
    my $td	= "";

        foreach my $key ( keys %{$list})
        {
            foreach my $top ( @{$list->{$key}} )
            {
                $td	= $class->{self}->date( $top->{'created'} );
                if (0)
                {
                $class->{self}->send_privmsg("MacroName: %-12s, type: %-7s, From: %s and ID: %s, Date: %s, Receveid: %10s : F:%2s, Message: %s",
                                     $top->{'nom_say'},
                                     $top->{'action'},
                                     $top->{'from'},
                                     $top->{'add_id'},
                                     $td,
                                     $top->{'received_by'},
                                     $top->{'finished'},
                                     $top->{'message'},

                                     );
                }
                else
                {
                    printf $fh ("    <macro date='%s'>
        <nom>%s</nom>
        <type>%s</type>
        <message>%s</message>
        <from>%s</from>
        <add_id>%s</add_id>
        <finish>%s</finish>
        <created>%s</created>
        <received_by>%s</received_by>",
                           $class->{self}->encap($top->{'created'}),
                           $class->{self}->encap($top->{'nom_say'}),
                           $class->{self}->encap($top->{'action'}),
                           $class->{self}->encap($top->{'message'}),
                           $class->{self}->encap($top->{'from'}),
                           $class->{self}->encap($top->{'add_id'}),
                           $class->{self}->encap($top->{'finished'}),
                           $td,
                           $class->{self}->encap($top->{'received_by'})
                           );
                     if ($top->{'delete'})
                     {
                         printf $fh ("
        <delete>
           <from>%s</from>
           <time>%s</time>
        </delete>", $top->{'delete'}, $top->{'delete_time'} );
                     }
                     printf $fh ("
    </macro>\n");
                }
            }
        }
}

sub macro_var_reset
{
    $nom_say		= "";
    $received_by	= "";
    $action		= "";
    $from		= "";
    $add_id		= "";
    $message		= "";
    $finished		= "";
    $created		= "";
    $delete		= "";
    $delete_time	= "";
}


1;
