#!/usr/bin/perl -w

# Vérifier
#
# A. Que le ON_NICK prenne bien en compte le changement de nick du bot.
# D. BUG quand le bot est kické, il se trompe de channel quand il purge celui où il a été kické
#    En fait, il lance del_channel2 avec le channel de départ (par kick/part) et efface
#    tous les users de sa liste, même s'il ne sont pas sur le channel en question.
# E. Faire un &save tous les 30mm
# F. Dans ON_JOIN/PART/LEAVE/NICK/KILL... faire en sorte que l'évènement soit
#    signalé par Channel.pm et non plus par Sextium.pl, ou alors placer
#    les logs en fonction de la réaction de Channel (mauvaise idée)... Si Channel.pm
#    voit le même nick dans plusieur channels il sera plus facile de les loggers
#    que dans Sextium.
# G. &install, si je fais $part, le bot revient. Si je met channel/active=no, 
#    que mettre quand je join ? ...
# H. Permetre l'ajout de 'lip dans le QUIT/JOIN pour pisg et autres ...
# I. Dans suck2 Lire le commantaire au sujet de @retval = $sel->can_read( 1 ) ; et du gainde performance Ã  gagner
#    Voire aussi pourquoi Suck2 ne remplace pas &suck et aussi si la regle de gaind e perf est valable
#	De plus :
#		use Socket qw(SOL_SOCKET SO_KEEPALIVE);
#		setsockopt($socket, SOL_SOCKET, SO_KEEPALIVE,  1);
#	voir si ca permet de mieux gÃ©rer les dÃ©cos.

# J. Dans &init -> 
#    $class->{select_time}	= $class->find("/select_time");;
#    Si find ne renvoit rien, alors la valeur {select_time} est a Zero, et donc bug !
# H. Voir pkoi il este $class->Debug et $class->debug!!!
# version actuelle: v0.4.3

BEGIN{
push @INC, ".";
$ENV{PATH}	= "/bin:/usr/bin:/usr/local/bin:/bin/:/usr/local/bin:/usr/local/sbin:/usr/games::/home/mans/bin"

}

=head1 DESCRIPTION

Sextium est une bot IRC évolué, il gère les actions retardées (QoS), les actions programmées
(Schelduler) permet une rapide intégration de module Perl.

=over
=back

=cut

# BUG CONNU:
# PB 1.
# Gere mal les deconnexions: après s'etre fait killé il ne reconnecte plus, mais lit le message NOTICE AUTH...
# Par contre si j'utile l'objet à l'exterrieur ca reconnecte bien...
#
# LOG du BUG NÂ°1 :
#	Process 26494 attached - interrupt to quit
#	select(8, [6], NULL, NULL, {0, 240436}) = 0 (Timeout)
#	getpeername(6, {sa_family=AF_INET, sin_port=htons(6667), sin_addr=inet_addr("130.237.188.200")}, [16]) = 0
#	time(NULL)                              = 1334040102
#	time(NULL)                              = 1334040102
#	time(NULL)                              = 1334040102
#	select(8, [6], NULL, NULL, {1, 0})      = 0 (Timeout)
#	getpeername(6, {sa_family=AF_INET, sin_port=htons(6667), sin_addr=inet_addr("130.237.188.200")}, [16]) = 0
#	time(NULL)                              = 1334040103
#	...


package sextium;
use strict;
use warnings;
use diagnostics;
#require "ctime.pl";

use IO::Socket;
use IO::Select;
use IO::File;
use IO::Handle;

use Config2;
use Mybot;

use vars qw($sock $sel $buf $var $tmp $on $arg1 $arg2 $arg3 $arg4 %on
            $day $mon $year $hour $min $sec
            $channel $userlist $login $host $action $server $mode
            $from $nick $to $to $channel $msg $raison $kicker $stdout $io $gcos $status
           );

%on = (
        '001'	=>	\&on_001,
        '002'	=>	\&on_002,
        '003'	=>	\&on_003,
        '332'	=>	\&on_332,
        '333'	=>	\&on_333,
        '433'	=>	\&on_nick,
        '353'	=>	\&on_353,		# annonce les utilisateurs d'un channel où le bot arrive.
        '352'	=>	\&on_who,		# On WHO
        '366'	=>	\&on_who_end,		# On WHO_end
        '372'	=>	\&on_372,
        '471'	=>	\&on_471,		# limit -l
        '474'	=>	\&on_474,		# banned +b
        '513'	=>	\&on_513,
      );

sub exit_cleanly { close $sock if (defined($sock)) ; exit(3); }
$SIG{INT} = $SIG{TERM} = $SIG{KILL} = \&exit_cleanly;


sub new
{
    my $self	= shift;
    #my %args	= @_;
    my $class	= {};
    

    bless $class, $self;

    $class->{debug_file}	= "/tmp/alpha_log_asterix.log";
    $class->{log_file}		= "/tmp/alpha_log_";
    $class->{log_ext}		= ".log";
    $class->{select_time}	= 0.6;
    #$class->init();

    return ($class);
}

sub init
{
    my $class			= shift;

    $class->config();

    $class->{debug_file}	= $class->find("/log/directory_temp") . "/" . $class->find("/log/debug_file")	|| "/tmp/alpha_log_asterix.log";
    $class->{log_file}		= $class->find("/log/directory_temp") . "/" . $class->find("/log/channel_prefix_file")	|| "/tmp/alpha_log_plugfr_ne_pas_effacer.log";
    $class->{log_ext}		= $class->find("/log/log_ext") || ".log";

    $class->{welcome}		= "";
    $class->{info_server}	= "";
    $class->{send_sleep}	= ();
    $class->{send_sleeph}	= ();
    $class->{server_created}	= ();
    $class->{motd}		= ();
    $class->{issue}		= ();
    $class->{who}		= ();

    $class->{select_time}	= $class->find("/select_time");;
    $class->{reconnect}		= "1";
    $class->{connect_die}	= $class->find("connect_die")	|| 0;
    $class->{on_kill}		= $class->find("on_kill")	|| 1;	# on reconnecte si je suis killÃ©
    $class->{on_kill_wait}	= $class->find("on_kill_wait")	|| 170;	# TEMPS d'attente avant reconnexion en seconds.
    $class->{une_fois_connecte}	= "0";	# variable a changer
    $class->auth_req(0);
    $class->{error}		= 0;
    $class->{log}		= {};
    $class->{nick_retry}	= $class->find("nick_retry") || 0;
    $class->{DEBUG}		= $class->find("debug") || "0";

    #$class->{mybot}		= new Mybot( cfg => { channel => "josemans"} );
    $class->{mybot}		= new Mybot( );
    #$class->{mybot}->{cfg}	= $class->{cfg}->{cfg}; # on passe la configureation aux modules/plugins...
    $class->{mybot}->{cfg}	= $class->{cfg}; # on passe la configureation aux modules/plugins...
    $class->{mybot}->{prefix_msg}	= $class->find("prefix_msg") if ($class->find("prefix_msg") ne "");
    $class->{mybot}->{_channel}->{cfg}	= $class->{cfg}; # on passe la configureation aux modules/plugins...
    $class->{mybot}->init();

    $class->myhostname	($class->find("myhostname")?$class->find("myhostname"):"localhost");
}

sub find
{
    my $class	= shift;
    my $branch	= shift;

    $branch	=~ s/\#//;
    return( $class->{cfg}->find($branch, @_)  );
}

sub _get
{
    my $class	= shift;
    my $branch	= shift;

    $branch	=~ s/\#//;
    return( $class->{cfg}->get($branch, @_)  );
}

sub config
{
    my $class	= shift;

    $class->{cfg}	= new Config2( configfile => 'bot.cfg' );
    $class->server      ( $class->{cfg}->find("server/freenode/host") );
    $class->port        ( $class->{cfg}->find("server/freenode/port") );
    $class->timeout     ( $class->{cfg}->find("server/freenode/timeout") );
    $class->mynick      ( $class->{cfg}->find("server/freenode/nick") );
    $class->mylogin     ( $class->{cfg}->find("server/freenode/login") );
    $class->mygcos      ( $class->{cfg}->find("server/freenode/gcos") );

    #$class->{cfg}->{autojoin}->{'\#gyptis'}		= 3;
    #$class->{cfg}->{autojoin}->{'default'}		= 300;
    #$class->{cfg}->{autojoin}->{'ban'}			= 300;
    #$class->{cfg}->{autojoin}->{'limit'}		= 120;
    #$class->{cfg}->{log}->{'#plugfr'}->{option}		= "all";
    #$class->{cfg}->{log}->{'#gyptis'}->{option}		= "all";
    #$class->{cfg}->{log}->{'#linuxfr'}->{option}	= "all";
    #$class->{cfg}->{log}->{'#debianfr'}->{option}	= "all";
    #$class->{cfg}->{'#debianfr'}->{talk}	= "yes";
    #$class->{cfg}->{'#gyptis'}->{talk}	= "yes";
    #$class->{cfg}->{'#plugfr'}->{talk}	= "yes";
    #$class->{cfg}->{'#perlfr'}->{talk}	= "yes";
}

sub une_fois_connecte
{
    my $class	= shift;
    if ( $#_ >= 0)
    {
        unless ($class->{une_fois_connecte})
        {
           #$class->send_sleep(00, "JOIN #gyptis\n");
           $class->{une_fois_connecte}	= 1;
           #$class->{log}->{'#plugfr'}->{option}   = "all";
        }
    }
    return( $class->{une_fois_connecte} );
}

sub install
{
    my $class	= shift;

    my $sleep	= 1;
    my $channel	= "";

    my %channel	= %{$class->find("/channel")};

    foreach my $tmp (keys %channel)
    {
        if ($tmp ne "")
        {
        $channel = '#' . $tmp;
        if ($class->{mybot}->{_channel}->channel_list($channel, "get") eq "" && $class->_get("/channel/$tmp/active") ne "no")
        {
            $sleep	= $class->find("/channel/$tmp/autojoin_start");
            $class->send_sleep($sleep?$sleep:"1", sprintf("JOIN %s\n", $channel) );
            $class->debug(99, sprintf("!!: JOIN \#%s dans %d seconds\n", $tmp, $sleep) );
        }
        else
        {
            #$class->debug(99, sprintf("!!: UNJOIN \#%s dans %d seconds --->>>  %s\n", $tmp, $sleep, $class->_get("/channel/$tmp/active")) );
        }
        }
    }

    $class->send_sleep2(9, "install", "cmd", \&install);
}

sub run
{
    my $class	= shift;

    do
    {
       $class->init();
       $class->open_socket();
       $class->send_nick();
       $class->install();
       $class->suck();
       $class->bot_close();

       if ($class->on_kill() > 1)
       {
          sleep( $class->{on_kill_wait} );
       }
    }
    while( $class->{reconnect} eq  "1" && $class->{connect_die} == 0); # $class->reconnect() n'est pas compris du perl -d
    return( $class->{connect_die} );
}

sub open_socket
{
    my $class	= shift;

    #my $server	= $class->server();

    #PeerAddr => "localhost",
    $sock = new IO::Socket::INET (
       PeerAddr => $class->server(),
       PeerPort => $class->port(),
       Timeout	=> $class->timeout(),
       Proto => 'tcp',
       Blocking	=> 0
      );
    $sel = new IO::Select( $sock );
	unless( $sock )
	{
		$class->Debug(1, sprintf("Sextium::open_socket() sock=NULL, connexion Ã©chouÃ©e") );
		die "Sextium::open_socket() Could not create socket: $!\n" unless $sock;
	}

}

sub send
{
    my $class	= shift;
    $class->debug(99, "SS: " . join(" ", @_) );
    $sock->send(@_);
}

sub send_stop
{
    my $class	= shift;
    my $nick	= shift || $nick;

    $class->{send_sleep}->{stop}	= $nick;
}

# schelduler, elle permet de programmer l'execution de commandes ou l'envoit de message
# sur IRC. C'est &suck qui se charge des envois et de vider la queue créee par &send_sleep2.
# &(sleep, "nick name| otjer texte (equiv. pid), type, msg, ...);
#   sleep	est le temps d'attente que devra attendre &suck pour executer &send_sleep2.
#   to		Nickname ou tout autres informations textuelles '\w+|\d+', le contenu est
#		important car il permetra d'identifier la, ou une suite de commandes afin
#		de procéder à des modification ou effaceement de la queue (fils d'attente)
#   type	cmd ou autre, si type=cmd alors une commande sera programmée pour que &suck
#		l'execute. Sinon (type=other) &suck envera, par &send(), le contenu de
#		$msg dans le socket d'IRC.
#   msg		Cette varaible peut contenir soit un message (texte) soit une référence
#		de fontion a executer par &suck (REF(0xxxxxx)).
#   ...		A cet endroit comme les arguements de la fonction qui sera programmée
#		Donc pour que ca soit prit en compte il faut que $type="cmd", ensuite
#		&suck passera, à &{$msg}, les options représenté par les "...".
sub send_sleep2
{
    my $class	= shift;
    my $sleep	= shift || $class->find("send_sleep_default");
    my $to		= shift;
    my $type	= shift;
    my $msg	= shift || "WARNING MSG no defined ";

    my @arg	= ();
    my $cmd	= "";
    my $time	= 0;

    if ( defined($class->{time}) )
    {
        # Pour avoir un semblent d'utilisation par seconds de &send_sleep sans
        # toucher à Mybot.pm et le reste, j'utilise un temps statiques pour
        # la programmation des évènements.
        $time	= $class->{time}++;
        #printf("DFINED TIME :%s \n", $time);
    }
    else
    {
        # Ici on suppose qu'one st pas executé dans un sous-objet comme Mybot.pm...
        $time	= time();
        #printf("NO DFINED TIME :%s \n", $time);
    }

    $time	+= $sleep;

    if ($type eq "cmd")
    {
        $cmd	= $msg;
        $msg	= "";
        @arg	= @_;
    }

    push @{$class->{send_sleeph}}, {
                                   sleep	=> $sleep,
                                   msg		=> $msg,
                                   time		=> $time,
                                   cmd		=> $cmd,
                                   arg		=> \@arg,
                                   to		=> $to,
                                   type		=> $type
                                  };
    $class->debug(99, "sS: ($sleep;;$time) to: $to, cmd_ref: '" . $cmd ."', MSG: " . $msg);
}

# Cette fonction existe pour garder une compatibilité avec les autres fonctions
# A terme il faudra tout remplacer par send_sleep2..
# &send_sleep([ time second,] msg [, \&cmd] );
sub send_sleep
{
    my $class	= shift;
    my $sleep	= 1;
    my $time	= 0;
    my $cmd	= "";
    my $msg	= "";
    my @arg	= ();

    if ( defined($class->{time}) )
    {
        # Pour avoir un semblent d'utilisation par seconds de &send_sleep sans
        # toucher à Mybot.pm et le reste, j'utilise un temps statiques pour
        # la programmation des évènements.
        $time	= $class->{time}++;
        #printf("DFINED TIME :%s \n", $time);
    }
    else
    {
        # Ici on suppose qu'one st pas executé dans un sous-objet comme Mybot.pm...
        $time	= time();
        #printf("NO DFINED TIME :%s \n", $time);
    }

    if ($#_ >= 1)
    {
        $sleep	= shift;
    }
    $time	+= $sleep;

    $msg	= shift;

    if ($#_ >= 0)
    {
        $cmd	= shift;
        @arg	= @_;
    }
    #$sock->send(@_);
    #push @{$class->{send_sleep}}, [$sleep, $msg, $time, $cmd, \@_];
    push @{$class->{send_sleeph}}, {
                                   sleep	=> $sleep,
                                   msg		=> $msg,
                                   time		=> $time,
                                   cmd		=> $cmd,
                                   arg		=> \@arg,
                                   to		=> "",
                                   type		=> ""
                                  };
    $class->debug(99, "Ss: ($sleep?$sleep:'Ce soir pas de sleep' ;;$time?$time:'No time') '" . $msg?$msg:"_NO_MSG_" ."' cmd_ref: '" . $cmd ."'");
}

sub bot_close
{
    my $class	= shift;
    $class->debug(99, "SS: CLOSE SOCKET *** " . join(" ", @_) );
    #$sel->remove ( $sock );
    #$sock->close();
    #close($sock);
    $sock	= undef;
    $sel	= undef;
}

sub suck
{
    my $class		= shift;

    my @retval		= ();
    my @sleep		= ();
    my %sleep		= ();
    my $c		= "";
    my $time		= ""; #time();
    my $rot		= 0;
    my $del		= 0;

    RETb: while ( 1 )
    {
        @retval = $sel->can_read( $class->{select_time} ) ;

        # Les tests de connexion : bonne, fermÃ©e...
	unless ( defined($sock) )
	{
       		$class->debug(1, "La connexion " . $| . "renvoit -0 argument dans retval, il sagit d'une erreur grave!, donc relance du bot\n");
		$class->{self}->{reconnect}      = 1;
		die();
		last RETb;
	}

        foreach my $fh (@retval)
        {
           if ($fh == $sock)
           {
              # C buerk, pas perfomant, mais au moins je sais ce que ca fait.
              # plutard ajouter une alarm...
              $buf = "";
              RETa: while ( ($rot = read($sock, $c, 1)) > 0 )
              {
                  if ( ord($c) == 10 )
                  {
                     last RETa;
                  }
                  $buf .= $c;
              }
              $class->debug(99, "RR: $buf");
              if ( $rot == 0 ) # Marche pas si j'envois QUOTE QUIT :byebye
              {
                 #printf("ON COUPE\n");
                 last RETb;
              }
              $rot = 1 if ($buf ne "");
           }
           else
           {
              $sel->remove($fh);
              $fh->close();
           }
        }

        # Sleep / thread comme on veut :)
        # $sleep, $msg, 0, $cmd, \@_]
        # sleep=> $sleep, msg => $msg, time => 0, cmd  => $cmd, arg  => \@_
        $time	= time();
        foreach (my $i=0; $i <= $#{$class->{send_sleeph}}; $i++)
        {
            %sleep	= %{${$class->{send_sleeph}}[$i]};
            if (defined($class->{send_sleep}->{stop}) && $class->{send_sleep}->{stop} eq $sleep{to})
            {
                $del	= 1;
            }
            else
            {
                # pas sûr que ca soit utilisé...
                if ($sleep{time} == 0)
                {
                    $sleep{time}	= time() + 1;#$sleep{sleep};
                    $tmp		= \%sleep; # je modifie ma REFérence.
                }

                if (time() >= $sleep{time} )
                {
                    if ( $sleep{cmd} ne "")
                    {
                        #$class->debug(99, sprintf("!2: Launch CODE_time '%s' -> sleep(%s), &cmd_ref(%s), arg : %s. Sock: '%s', sel: '%s', connected: '%s'", $time, $sleep{time}, $sleep{cmd}, join(" ", @{$sleep{arg}}, $sock, $sel, $sock->connected) ));
                        &{$sleep{cmd}} ($class, @{$sleep{arg}});
                    }
                    else
                    {
                        $class->debug(99, sprintf("!3: Send normal timei_actual(%s), thread timei_prg(%s), &cmd_ref(%s), arg : %s", $time, $sleep{time}, $sleep{cmd}, join(" ", @{$sleep{arg}})));
                        $class->send( $sleep{msg} ."\n" );
                    }
                    $del	= 1;
                }
            }

            if ($del)
            {
                splice (@{$class->{send_sleeph}},$i, 1);
                $del	= 0;
                $i--;
                #printf("On effece : %s:%s\n", $#{$class->{send_sleeph}}, $sleep{msg});
            }
        }

        $class->{send_sleep}->{stop}	= undef;

        if ($rot == 1)
        {
           $class->parse( $buf );
           $rot	= 0;
        }

        $buf = "";

    }
    $class->bot_close();
    return( 0 );
}

sub send_nick
{
    my $class	= shift;
    my $ret=0;
    if ( !$class->une_fois_connecte() ) # je suis pas connécté
    {
    $class->send( sprintf("NICK %s\n",
                 $class->mynick
               ));
    $class->send( sprintf("USER %s %s %s :%s\n",
                 $class->mylogin(),
                 $class->myhostname(),
                 $class->server(),
                 $class->mygcos()
               ));
    $class->send_sleep( time()+3, "", \&nick);
    $class->current_nick( $class->mynick() );
    $class->debug(99, sprintf("USER & NICk send: nick: '%s'", $class->current_nick()) );
    }
}

sub autojoin
{
     my $class		= shift;
     my $channel	= shift || "";
     my $status		= shift || "";

     my $time		= $class->{cfg}->{autojoin}->{'default'};

     $class->debug(99, "Request Autojoin on channel : '$to' with parameter : ".$class->{cfg}->{autojoin}->{$channel}."\n");
     if ( 1||$class->{cfg}->{autojoin}->{$channel} )
     {
         if ($status eq "ban")
         {
             $time = $class->{cfg}->{autojoin}->{'ban'};
         }
         $class->send_sleep($time, "JOIN $to\n");
     }
}

sub parse
{
    my $class	= shift;
    my $buf	= shift;

    $msg	= "";


    $_ = $buf;

    if (/^:*~*(\S+).*$/)
    {
       $class->from($1);
    }

    while(s/[
\n]//g) {}

    if (/^:*~*(\S+)\!~*(\S+)\@(\S+) +(PRIVMSG|NOTICE) +(\S+) +:(.*)$/)
    {
        $nick	= $1;
        $class->login($2);
        $host	= $3;
        $action	= $4;
        $to	= $5;
        $msg	= $6;
        $class->debug(99, $_  );

        if ($msg =~ /^(ACTION) *(.*)$/)
        {
            $action	= $1;
            $msg	= $2;
        }
        else
        {
            # Other CTCP fonction not implemented.
        }
        $class->{time}	= time();
        $class->{mybot}->on_cmd($class, $class->from(), $to, $msg);
        $class->{time}	= undef;
        $class->log2($nick, $to, $action, $msg);
    }
    elsif( /^:*~*(\S+)\!~*(\S+)\@(\S+) +(KICK) +(\S+) +(\S+) +: *(.*)$/ )
    {
        $kicker	= $1;
        $class->login($2);
        $host	= $3;
        $action	= $4;
        $to	= $5;
        $nick	= $6;
        $raison	= $7 || "";
        if ($class->current_nick() eq $nick) # c moi
        {
           $class->{mybot}->{_channel}->del_channel("", $to, "", "");
           $class->autojoin($to, "kick");
        }
        else # c un d'eux
        {
           $class->{mybot}->{_channel}->del_channel($nick, $to, $class->login(), $host);
           #printf("PAS BON\n");
        }
        $class->log2($kicker, $to, $action, $nick, $raison);

    }
    elsif( /^:*~*(\S+)\!~*(\S+)\@(\S+) +(MODE) +(\S+) +(\S+) +(.*)$/)
    {
        $nick	= $1;
        $class->login($2);
        $host	= $3;
        $action	= $4;
        $to	= $5;
        $mode	= $6;
        $msg	= $7 || "";
        $class->log2($nick, $to, $action, $mode, $msg);

    }
    elsif (/^NOTICE +(\S+)\s+:(.*)$/)
    {
       if ($1 eq "AUTH")
       {
          if (/Got ident response/) #NOTICE AUTH :*** Got ident response
          {
             $class->auth_req( 1 );
             $class->debug(99, sprintf("   Start auth\n") );
          }
          #$class->send_nick(); c beurk :)
       }
       else
       {
           $class->debug(99, sprintf("  INCONNU\n") );
       }
    }
    elsif( /^:*~*(\S+)\!~*(\S+)\@(\S+) +(JOIN) +:*(\S+)$/ )
    {
        $nick	= $1;
        $class->login($2);
        $host	= $3;
        $action	= $4;
        $to	= $5;

        $class->on_join();
        $class->log2($nick, $to, $action);
    }
    # :CIX!mans@gyptis.org INVITE AsteriX0 :#jose
    elsif (/^:*~*(\S+)\!~*(\S+)\@(\S+) +(INVITE) +(\S+) +:(.*)$/)
    {
        $nick	= $1;
        $class->login($2);
        $host	= $3;
        $action	= $4;
        #Name bot...	= $5;
        $to	= $6; # channel cible

        $class->{mybot}->myon_cmd($class, $class->from(), $to, "JOIN " . $to);
        $class->log2($nick, $to, $action, "on $to");
    }
    elsif( /^:*~*(\S+)\!~*(\S+)\@(\S+) +(PART) +(\S+) +:*"*(.*)"*$/ ||
           /^:*~*(\S+)\!~*(\S+)\@(\S+) +(PART) *:*(\S+)$/ )
    {
        $nick	= $1;
        $class->login($2);
        $host	= $3;
        $action	= $4;
        $to	= $5;
        $msg	= $6 || "";

        if ($class->current_nick() eq $nick)
        {
           #printf(" C MOI qui part\n");
           $class->{mybot}->{_channel}->del_channel("", $to, "", "");
        }
        else
        {
           #printf(" C pas moi qui part\n");
           $class->{mybot}->{_channel}->del_channel($nick, $to, $class->login(), $host);
        }
        $class->log2($nick, $to, $action, $msg);
    }
    elsif( /^:*~*(\S+)\!~*(\S+)\@(\S+) +(QUIT) +:"*(.*)"*$/ )
    {
       $nick	= $1;
       $class->login($2);
       $host	= $3;
       $action	= $4;
       $msg	= $5;

       if ($class->current_nick() ne $nick)
       {
          $tmp	= $class->{mybot}->{_channel}->del_channel($nick, "*", $class->login(), $host);
       }
       else
       {
          # Fonction innexistante -> $class->{mybot}->{_channel}->clear_channel();
       }

       if ($#{$tmp} >= 0)
       {
           foreach my $top (@${tmp})
           {
               $class->log2($nick, $top, $action, $msg);
           }
       }
       #$class->log2($nick, $to, $action, $msg);

    }
    elsif( /^:*~*(\S+) +(KILL) +(\S*) +:"*(.*)"*$/ )
    {
       $server	= $1;
       $action	= $2;
       $nick	= $3;
       $msg	= $4 || "";

       $class->{mybot}->{_channel}->init_channel();

       if ($class->on_kill() >= 1)
       {
          $msg = 1;
       }
       else
       {
          $msg = 0;
       }
       $class->{on_kill}++;
       $class->reconnect( $msg );
       $class->log2($nick, $to, $action, $msg);
    }
    elsif( /^:*~*(\S+)\!~*(\S+)\@(\S+) +(NICK) +:(.+)$/)
    {
       $nick	= $1;
       $class->login($2);
       $host	= $3;
       $action	= $4;
       $msg	= $5; # New nick

       if ($class->current_nick() eq $nick)
       {
           $class->debug(99, sprintf("   I change my nick old: %s, new: %s", $class->current_nick(), $nick));
           $class->current_nick( $msg );
       }

       $tmp	= $class->{mybot}->{_channel}->rename_nick($nick, "*", $class->login(), $host, $msg);
       if ($#{$tmp} >= 0)
       {
           foreach my $top (@${tmp})
           {
               $class->log2($nick, $top, $action, $msg);
           }
       }
       #$class->log2($nick, $to, $action, $msg);
    }
    elsif( /^:*~*(\S+) +(\d+) +(\S+) +(.+)$/ )
    {
       $nick	= $1;
       $on	= $2;
       $arg1	= $3;
       $arg2	= $4;
       $arg2	=~ / *(\S+) *:(.*)$/;
       $arg3	= $1;
       $arg4	= $2;
       $class->on_numeric();
    }
    elsif( /^:*~*(\S+)\!~*(\S+)\@(\S+) +(TOPIC) +(\S+) +:(.*)$/)
    {
       $nick	= $1;
       $class->login($2);
       $host	= $3;
       $action	= $4;
       $to	= $5;
       $msg	= $6;
       $class->log2($nick, $to, $action, $msg);
       $class->{mybot}->{_channel}->topic($to, $nick, $msg);
    }
    elsif(/^PING +:(.+)$/)
    {
        $class->debug(99, $_ );
        $arg1	= $1;
        $class->pong( $1 );
    }
    elsif (/^ERROR +:(.+):(.*).*$/)
    {
       $class->reconnect( "1" );
        $arg1	= $1;
        $arg2	= $2;
    }
    else
    {
        $class->debug(10, sprintf("    INCONNU :( ''%s'' ", $_ ) );
        $class->{error}++;
    }

    #die ("TROP d'erreur : too error") if ($class->{error} > 100);
    return ( 0 );
}

sub server	{ my ($class) = shift; if (@_) { $class->{server} = shift; } return( $class->{server} ); } 
sub port	{ my ($class) = shift; if (@_) { $class->{port} = shift; } return( $class->{port} ); } 
sub timeout	{ my ($class) = shift; if (@_) { $class->{timeout} = shift; } return( $class->{timeout} ); } 
sub mynick	{ my ($class) = shift; if (@_) { $class->{mynick} = shift; } return( $class->{mynick} ); }
sub current_nick{ my ($class) = shift; if (@_) { $class->{current_nick}    = shift; } return( $class->{current_nick} ); }
sub mylogin	{ my ($class) = shift; if (@_) { $class->{mylogin}= shift; } return( $class->{mylogin} ); }
sub mygcos	{ my ($class) = shift; if (@_) { $class->{mygcos} = shift; } return( $class->{mygcos} ); }

sub nick	{ my ($class) = shift; if (@_) { $class->{nick}   = shift; } return( $class->{nick} ); }
sub login	{ my ($class) = shift; if (@_) { $class->{login}  = $class->clean_from(shift); } return( $class->{login} ); }
sub gcos	{ my ($class) = shift; if (@_) { $class->{gcos}   = shift; } return( $class->{gcos} ); }
sub on_kill	{ my ($class) = shift; if (@_) { $class->{on_kill}= shift; } return( $class->{on_kill} ); }
sub reconnect	{ my ($class) = shift; if (@_) { $class->{reconnect} = shift; } return( $class->{reconnect} ); }
sub auth_req	{ my ($class) = shift; if (@_) { $class->{auth_req}  = shift; } return( $class->{auth_req} ); }
sub myhostname	{ my ($class) = shift; if (@_) { $class->{myhostname}  = shift; } return( $class->{myhostname} ); }

sub from
{
	my ($class) = shift;

	if (@_)
	{
		$class->{from}	= $class->clean_from( shift ) ;
	}
	return( $class->{from} );
}

sub clean_from
{
	my ($class) = shift;
	my $var		= shift;

	if (defined($var))
	{
		$var	=~ s/\~//;
		$var	=~ s/\w=//;
	}
	return( $var );
}
sub on_numeric
{
    my $class	= shift;
       if ( defined($on{$on} ) )
       {
          &{$on{$on}} ($class, $class->from(), $arg1, $arg2 );
       }
       else
       {
          $class->debug(20, sprintf("!!: Sextium::on_numeric='$on' no-found_"));
       }
}

# Message de bienvenue
sub on_001
{
    my $class	= shift;
    $class->{welcome}		= $arg2;
    $class->une_fois_connecte( 1 );
}

sub on_002
{
    my $class	= shift;
    $class->{info_server}	= $arg2;
    $class->une_fois_connecte( 1 );
}

sub on_003
{
    my $class	= shift;
    $class->{server_created}	= $arg2;
    $class->une_fois_connecte( 1 );
}

# info topic on channel...
# zelazny.freenode.net 332 CIX #gyptis :1 2 34
sub on_332
{
    my $class	= shift;
    $arg2	=~ s/^://;
    ($channel, $var) = split(/ /, $arg2, 2);
    $class->{mybot}->{_channel}->topic($channel, "", $var);
    $class->debug(99, "ii: on_topic     : $arg1, $arg2 ET $channel, $var");
}

# Time topic on channel...
sub on_333
{
    my $class	= shift;
    ($channel, $nick, $var) = split(/ /, $arg2, 10);
    $class->debug(99, "ii: on_topic_time: $arg1, $arg2 ET  $channel, $nick, $var");
    $class->{mybot}->{_channel}->topic($channel, $nick, "", $var);
}

sub on_join
{
    my $class	= shift;
    if ($class->current_nick() eq $nick )
    {
        $class->send("WHO $to\n");
        $class->send("TOPIC $to\n");
        # ne sert à rien d'utiliser : $class->{mybot}->{_channel}->add_channel($nick, $to, $class->login(), $host); ...
    }
    else
    {
       $class->{mybot}->{_channel}->add_channel($nick, $to, $class->login(), $host);
    }
    #$class->log2($nick, $to, $action);
}

# On WHO or on_352 - RPL_WHOREPLY
# "<channel> <user> <host> <server> <nick> <H|G>[*][@|+] :<hopcount> <real name>"
sub on_who
{
    my $class	= shift;

    if ($arg2 =~ /^(\S+) +~*(\S+) +(\S+) +(\S+) ~*(\S+) +(\S+) +:*(.*)$/)
    {
       $nick	= $arg1;
       $to	= $1;
       $class->login($2);
       $host	= $3;
       $server	= $4;
       $nick	= $5;
       $status	= $6;
       $gcos	= $7;
       $status	=~ /(H|G)*(\*)*(\@|\+)*/;
           my $flag	= $1?$1:"";
           my $ircop	= $2?$2:"";
           my $mode	= $3?$3:"";
       #printf("WHO: $nick, C: $to, L: $class->login(), H: $host, S: $server, ST: $status, GC: $gcos\n");
       #printf("WHO:    Mode: $mode, S: $flag, I: $ircop\n");
       $class->debug(99, "i!:   add_channel: ($nick, $to, $class->login(), $host)");
       $class->{mybot}->{_channel}->add_channel($nick, $to, $class->login(), $host);	#, $status, $gcos);

    }
}

# Message automatique après l'arrivé du bot sur un channel.
#:wells.freenode.net 353 ObeliX2 = #gyptis :ObeliX2 @CurIeuX @bdauvergne @ObeliX
# On on_353
sub on_353
{
    my $class	= shift;

    $arg2	=~ /^\=* *(\S+) +:(.*)$/;
    $to		= $1;
    $nick	= $class->current_nick();
    $class->on_join();
}

# On 366
sub on_who_end
{
    my $class	= shift;
}

sub on_372
{
    my $class	= shift;

    push @{$class->{motd}}, $arg2;
}

sub on_375
{
    my $class	= shift;

    push @{$class->{issue}}, $arg2;
}

sub on_nick
{
    my $class	= shift;
    my $nick	= $class->mynick() . $class->{nick_retry};

    $class->send("NICK " . $nick . "\n");
    $class->current_nick( $nick );
    $class->{nick_retry}++;
}

sub on_471
{
    my $class	= shift;
    $class->autojoin($to, "limit");
    $class->debug(99, "AUTOJOIN: on $to, status 'ban'");
}
    
sub on_474
{
    my $class	= shift;
    $class->autojoin($to, "ban");
    $class->debug(99, "AUTOJOIN: on $to, status 'ban'");
}
    
sub on_513
{
    my $class	= shift;

    $class->reconnect( "1" );
}

sub pong
{
    my $class	= shift;

    $class->send("PONG :$arg1
");
}





# MISC

sub debug
{
    my ($class) = shift;
    my ($lvl)   = shift;
    my ($arg)   = shift;
    my ($buf)   = "";

    $_ = \$arg;
    if ($class->{DEBUG} >= $lvl)
    {
    if (/SCALAR\(.*\)/ )
    {
       printf ("%s\n", $arg);
    }
    elsif (/ARRAY\(.*\)/ )
    {
       #  10        10         10
          $buf .= $class->{msg}{debug};;
          foreach my $tmp (@$arg)
          {
             $buf .= sprintf("[%s] %s", $tmp);
          }
          $buf .= sprint ("\n");


          printf ($buf);
    }
    elsif ( /HASH\(.*\)/ )
    {
       foreach my $tmp (keys %$arg)
       {
           printf (" %8s=>%s\n", $tmp, ${$arg}{$tmp} );
       }
    }
    }

    #close(OUT);
}

sub log2
{
    my ($class)	= shift;
    my ($nick)	= shift;
    my ($to)	= lc( shift );
    my ($action)= shift;
    my ($msg)	= shift || "";

    my $file	= "";


    #printf("LOG: find'%s', to='%s', action='%s'\n", $class->find("/log/$to"), $to, $action);
    if ( $class->find("/log/$to") =~ /$action/i
           ||
         $class->find("/log/$to") =~ /all/i
        )
    #if (defined($class->{cfg}->{log}->{$to}) && ($class->{cfg}->{log}->{$to}->{option} =~ /$action/i || $class->{cfg}->{log}->{$to}->{option} =~ /all/i ) )
    {
       $to	=~ /^#(.*)$/;
       # $nick =~ s%(.)%\\$1%g; pour parrer les nick TRUC|Bidule
       $channel	= $1;
       ($sec,$min,$hour, $day, $mon, $year) = localtime(time);
       $year	+= 1900;
       $mon	+= 1;
       ($sec	< 10) && ($sec = "0" . $sec);
       ($min	< 10) && ($min = "0" . $min);
       ($hour	< 10) && ($hour = "0" . $hour);

       foreach my $tmp (@_) { $msg .= " " . $tmp; }

       $file	= $class->{log_file} . $channel . $class->{log_ext}; #".log";
       if ( open(AOUT, ">>" . $file))
       {
          printf AOUT ("(%2d/%2d/%2d:%2d:%2d:%2d) <%8s> <%10s> <%10s> :%s\n",
                       $day, $mon, $year,
                       $hour, $min, $sec,
                       $nick, $to, $action, $msg);
          close(AOUT);
       }
       else
       {
          $class->debug(1, "!!: Error open write file in bot.pm::log2 filename '$file'\n");
       }
    }
}




# PLUS UTILISE

sub log
{
    my ($class)		= shift;
    my ($action)	= shift;
    my ($to)		= shift;

    $class->{cfg}->{log}->{$to}->{option}	= $action;
}

sub suck2
{
    my $class		= shift;

    my @retval		= ();
    my @sleep	= ();
    my $c		= "";
    my $rot		= 0;
    #my ($time)		= time();

    #$class->send_nick();
    RETb: while ( 1 )
    {
        #@retval = $sel->can_read( 0.001 ) ;
        @retval = $sel->can_read( 1 ) ;
        #$retval = select( $sock, undef, undef, 3);

# ICI, devrait etre reduit pour ne laisser que le "@retval = $sel->can_read( 1 ) ;" et un IF qui control
# s'il y a ou pas des donnes a envoyer a un analyseur. Gain -> performance.
# En effet s'il n'y a rien a lire le CPU va continuer a interpreter le code PErl qui suit le 
# "@retval = $sel->can_read( 1 ) ;" et donc excuter ses instructios pour rien.

        foreach my $fh (@retval)
        {
           return(1) unless (defined($sock)); # ne marche pas
           if ($fh == $sock)
           {
              # C buerk, pas perfomant, mais au moins je sais ce que ca fait.
              # plutard ajouter une alarm...
              $buf = "";
              RETa: while ( ($rot = read($sock, $c, 1)) > 0 )
              #RETa: while ( ($rot = $sock->recv($c, 1)) > 0 )
              {
                  if ( ord($c) == 10 )
                  {
                     last RETa;
                  }
                  $buf .= $c;
              }
              $class->debug(99, "RR: $buf");
              if ( $rot <= 0 ) # Marche pas si j'envois QUOTE QUIT :byebye
              {
                 #printf("ON COUPE\n");
                 last RETb;
              }
              $rot = 1 if ($buf ne "");
           }
           else
           {
              $sel->remove($fh);
              $fh->close();
           }
        }

        # Sleep / thread comme on veut :)
        #if ( $#{$class->{send_sleep}} >= 0)
        foreach my $sleep ( @{$class->{send_sleep}})
        {
            #@sleep	= @{$sleep};
            if ($sleep[2] == 0)
            {
                #$sleep[2]	= time() + $sleep[0];
            }

            if (time() >= $sleep[2] )
            {
                if ( $sleep[3] )
                {
                    $class->debug(99, sprintf("!!: thread time(%s), &cmd_ref(%s), arg : %s",
                                                 $sleep[2], $sleep[3], join(" ", @{$sleep[4]})));
                    &{$sleep[3]} ($class, @{$sleep[4]});
                }
                else
                {
            printf("TIME: %s == %s :: %s\n", time(), $sleep[1], $sleep[0]);
                    $sock->send( $sleep[1] );
                    last;
                }
                shift @{$class->{send_sleep}};
            }
        }

        if ($rot == 1)
        {
           $class->parse( $buf );
           $rot	= 0;
        }
        #printf("TIMe: %s >= %s, %s\n", time(), ($time + 3), $class->auth_req() );

        $buf = "";

        #last RETb if ($class->reconnect() eq "1" || !defined($sock->connected) );
    }
    $class->bot_close();
    return( 0 );
}


1;
